<?php
class console_reship{
    function reship_data($reship_id){
        $oReship = app::get('ome')->model('reship');
        $oOrders = app::get('ome')->model('orders');
        $reship_data = $oReship->dump(array('reship_id'=>$reship_id),'reship_bn,logi_no,logi_id,order_id,t_begin,return_type');
        $Oreship_items = app::get('ome')->model('reship_items');
        $oProcess_items = app::get('ome')->model('return_process_items');
        $Odly_corp = app::get('ome')->model('dly_corp');
        $dly_corp = $Odly_corp->dump($reship_data['logi_id'],'type');
        $Oreship_items = app::get('ome')->model('reship_items');
        $orders = $oOrders->dump($reship_data['order_id'],'order_bn');
        $reship_list = $Oreship_items->getlist('bn,product_name,product_id,num,branch_id',array('reship_id'=>$reship_id),0,-1);
        $data = array();
        foreach ($reship_list as $list) {
            $branch_id = $list['branch_id'];

            if(isset($data[$branch_id])){
                $data[$branch_id]['items'][] = $list;
            }else{
                //获取仓库详情
                $branch_detail = kernel::single('console_iostockdata')->getBranchByid($branch_id);

                $data[$branch_id]['items'][] = $list;
                $data[$branch_id]['reship_bn'] = $reship_data['reship_bn'];
                $data[$branch_id]['branch_bn'] = $branch_detail['branch_bn'];
                $data[$branch_id]['storage_code'] = $branch_detail['storage_code'];
                $data[$branch_id]['create_time'] = $reship_data['t_begin'];//storage_code
                $data[$branch_id]['memo'] = '';//storage_code
                $data[$branch_id]['return_type'] = $reship_data['return_type'];
                //memo original_delivery_bn
                $data[$branch_id]['original_delivery_bn'] = '';
                $data[$branch_id]['logi_no'] = $reship_data['logi_no'];
                $data[$branch_id]['logi_name'] = $reship_data['logi_name'];
                $data[$branch_id]['logi_code'] = $dly_corp['type'];
                $data[$branch_id]['order_bn'] = $orders['order_bn'];
                $data[$branch_id]['receiver_name'] = $reship_data['ship_name'];
                $data[$branch_id]['receiver_zip'] = $reship_data['ship_zip'];
                $data[$branch_id]['receiver_state'] = $reship_data['ship_area'];
                $data[$branch_id]['receiver_city'] = '';
                $data[$branch_id]['receiver_district'] = '';
                $data[$branch_id]['receiver_address'] = $reship_data['ship_addr'];
                $data[$branch_id]['receiver_phone'] = $reship_data['ship_tel'];
                $data[$branch_id]['receiver_mobile'] = $reship_data['ship_mobile'];
                $data[$branch_id]['receiver_email'] = $reship_data['ship_email'];

            }
        }

        return $data;
    }

    /**
    * 取消退货单
    */
    function notify_reship($type,$reship_id){
        $reship_data = kernel::single('console_reship')->reship_data($reship_id);
        if ($type == 'create'){//创建

            foreach ($reship_data as $rk=>$rv) {
                $wms_id = kernel::single('ome_branch')->getWmsIdById($rk);
                $tmp = $rv;
                kernel::single('console_event_trigger_reship')->create($wms_id, $tmp, false);
            }
        }else if($type == 'cancel'){//取消

            foreach ($reship_data as $rk=>$rv) {
                $wms_id = kernel::single('ome_branch')->getWmsIdById($rk);
                $tmp = $rv;
                kernel::single('console_event_trigger_reship')->cancel($wms_id, $tmp, true);
            }

        }else{
            return true;
        }

    }

    /**
     * 换货商品明细
     * @param
     * @return  array
     * @access  public
     * @author sunjng@shopex.cn
     */
    function change_items($reship_id)
    {
        $oReship_item = app::get('ome')->model('reship_items');
        $reship_item = $oReship_item->getList('bn,product_name,num,product_id',array('reship_id'=>$reship_id,'return_type'=>'change'),0,-1);
        return $reship_item;
    }

    public function siso_iostockReship($reship_id){
        $oReship = app::get('ome')->model('reship');
        $reship = $oReship->dump(array('reship_id'=>$reship_id),'branch_id,return_type');
        $oReship_item = app::get('ome')->model('reship_items');
        $normal_reship_item = $oReship_item->getList('*',array('reship_id'=>$reship_id,'normal_num|than'=>0));
        $defective_reship_item = $oReship_item->getList('*',array('reship_id'=>$reship_id,'defective_num|than'=>0));
        $reshipLib = kernel::single('siso_receipt_iostock_reship');
        $flag = true;
        if (count($normal_reship_item)>0){
            $return_type = $reship['return_type'];
            if ($return_type == 'refuse'){
                $reshipLib->_typeId=32;
            }else{
                $reshipLib->_typeId=30;
            }
           $normal_result = $reshipLib->create(array('reship_id'=>$reship_id,'items'=>$normal_reship_item,'branch_id'=>$reship['branch_id']), $data, $msg);
            if (!$normal_result){
                $flag = false;
            }
        }

        if (count($defective_reship_item)>0) {
            $damaged = kernel::single('console_iostockdata')->getDamagedbranch($reship['branch_id']);
            $reshipLib->_typeId=50;
            $defective_result = $reshipLib->create(array('reship_id'=>$reship_id,'items'=>$defective_reship_item,'branch_id'=>$damaged['branch_id'],'orig_type_id'=>'30'), $data, $msg);
            if (!$defective_result){
                $flag = false;
            }
        }
        return $flag;
    }

    public function update_sync_status($reship_id, $status, $msg=''){
        if(!$reship_id || !$status){
            return false;
        }



        $updateArr = array(
            'sync_status'=>$status
        );

        if($msg){
            $updateArr['sync_msg'] = $msg;
        }

        $reshipObj = app::get('ome')->model('reship');
        return $reshipObj->update($updateArr, array('reship_id'=>$reship_id));
    }

    /**
     * @ 退货单取消
     * @DateTime  2018-01-30T17:06:22+0800
     * @param
     * @param
     * @return
     */
    static public function cancel($reship,$log_memo=''){
        $reshipObj = app::get('ome')->model('reship');
        $logObj = app::get('ome')->model('operation_log');//写日志
        $updata = array('is_check'=>'5','t_end'=>time());
        $memo = $log_memo;

        if ($reship['is_check']=='1' && $reship['return_type'] == 'change' && $reship['change_status'] == '0') {
            //如果是退货已审核成功,单据不取消。但是把 换货订单状态生成关闭 释放冻结库存

            $updata['change_status']    ='2';
            $storeManageLib = kernel::single('ome_store_manage');
            $storeManageLib->loadBranch(array('branch_id'=>$reship['changebranch_id']));
            $params_stock = array(
                    "params" => array_merge($reship,array('reship_id'=>$reship['reship_id'])),
                    "node_type" => "refuseChangeReship",
            );
            $storeManageLib->processBranchStore($params_stock, $err_msg);
            $memo.=',换货订单状态更新为:不生成';
        }
        $reshipObj->update($updata,array('reship_id'=>$reship['reship_id']));
        $logObj->write_log('reship@ome',$reship['reship_id'],$memo);
    }

    static public function notice($reship){
        $res = array('rsp'=>'succ');
        if ($reship['is_check'] == '1'){
            $branch_id = $reship['branch_id'];
            $wms_id = kernel::single('ome_branch')->getWmsIdById($branch_id);
            $branch = kernel::single('ome_branch')->getBranchInfo($branch_id,'branch_bn,storage_code');
            $data = array(
                'reship_bn' =>  $reship['reship_bn'],
                'branch_bn' =>  $branch['branch_bn'],
            );

            $res = kernel::single('console_event_trigger_reship')->cancel($wms_id, $data, true);
        }
        return $res;

    }
}
?>
