<?php
/**
 * @desc    京东售后数据转换
 * @author: jintao
 * @since: 2016/7/20
 */
class erpapi_shop_matrix_360buy_response_aftersalev2 extends erpapi_shop_response_aftersalev2
{
    protected function _formatAddParams($params)
    {
        $sdf = parent::_formatAddParams($params);
        if ($sdf['refund_type'] == 'refund') {//新增京东售前退款格式转化
            //0、未审核 1、审核通过2、审核不通过 3、京东财务审核通过 4、京东财务审核不通过 5、人工审核通过 6、拦截并退款 7、青龙拦截成功 8、青龙拦截失败 9、强制关单并退款
            $status = $sdf['status'];
            if (in_array( $status,array('0')) ) {
                $sdf['status'] = 'WAIT_SELLER_AGREE';
                $sdf['refund_type'] = 'apply';
            }else if( in_array($status,array('1','5')) ){//申请通过
                $sdf['status'] = 'WAIT_BUYER_RETURN_GOODS';
                $sdf['refund_type'] = 'apply';
            }else if( in_array($status,array('2','4','11')) ){ //拒绝
                $sdf['status'] = 'SELLER_REFUSE_BUYER';
                $sdf['refund_type'] = 'apply';
            }else if( in_array($status,array('3','6','9')) ){ //成功
                $sdf['status'] = 'SUCCESS';
            }
            if ($sdf['order']['pay_bn'] == 'deposit' && $sdf['refund_fee']<=0){
                $sdf['refund_fee'] = $sdf['order']['payed'];
            }
        } 
      
        $sdf['pickware_type']       = $params['pickware_type'];
        $sdf['refund_version']      = $params['refund_version'];
        $sdf['return_ware_address'] = $params['return_ware_address'];
        $sdf['pickware_address']    = $params['pickware_address'];
        $sdf['customer_info']       = $params['customer_info'];
        $sdf['apply_detail_list']   = $params['apply_detail_list'];
        $sdf['customerExpect']      = $params['customerExpect'];
        if ($sdf['customerExpect']==20){
            $sdf['return_type'] = 'jdchange';
            
        }
        return $sdf;
    }

    protected function _getAddType($sdf) {
        if(in_array($sdf['refund_type'],array('refund','apply'))) { #退款
            return 'refund';
        } elseif ($sdf['refund_type'] == 'return') {
            return 'returnProduct';
        } elseif ($sdf['refund_type'] == 'reship') {
            if ($sdf['status'] == 'confirm_failed'){
                return 'returnProduct';
            }else{
               return 'reship'; 
            }
        }
    }

    protected function _formatAddItemList($sdf, $convert = array()) {
        
        if ($sdf['order']['tran_type'] == 'archive'){
            return $this->formatArchiveitemlist($sdf, $convert);
        }
        $convert = array(
            'sdf_field'     =>'oid',
            'order_field'   =>'oid',
            'default_field' =>'outer_id'
        );
        return parent::_formatAddItemList($sdf, $convert);
    }

    protected function _returnProductAddSdf($sdf) {
        $sdf = parent::_returnProductAddSdf($sdf);
        if ($sdf['order']['tran_type'] == 'archive'){
            $sdf['archive'] = '1';
           
        }
        if(!$sdf) return false;
        
        $sdf['choose_type_flag'] = 0;
        if($sdf['return_product']) {
            $data = app::get('ome')->model('return_product_360buy')->db_dump(array('return_id'=>$sdf['return_product']['return_id'],'shop_id'=>$sdf['shop_id']), 'refund_version');

            $sdf['refund_version_change'] = $sdf['refund_version'] > $data['refund_version'] ? true :false;
        }

        return $sdf;
    }

    protected function _returnProductAdditional($sdf) {
        $ret = array(
            'model' => 'return_product_360buy',
            'data' => array(
                'shop_id'        => $sdf['shop_id'],
                'return_bn'      => $sdf['refund_bn'],
                'receive_state'  => $sdf['status'],
                'pickware_type'  => $sdf['pickware_type'],
                'buyer_nick'     => $sdf['buyer_nick'],
                'logi_no'        => $sdf['express_code'],
                'refund_version' => $sdf['refund_version'],
                'return_address' => $sdf['return_ware_address'],
                'pick_address'   => $sdf['pickware_address'],
                'customer_info'  => $sdf['customer_info'],
                'apply_detail'   => $sdf['apply_detail_list'],
            )
        );
        return $ret;
    }

   #重新计算单价($refundItems 以bn作主键的数组 捆绑商品使用捆绑商品的bn)
    protected function _calculateAddPrice($refundItems, $sdf) {
        if ($sdf['order']['tran_type'] == 'archive'){
            $db = kernel::database();
            foreach($refundItems as $k=>$v){
                $order_item = $db->selectrow("SELECT sendnum,item_id,price FROM sdb_archive_order_items WHERE order_id=".$sdf['order']['order_id']." AND bn='".$v['bn']."'");
                $refundItems[$k]['sendNum'] = $order_item['sendnum'];
                $refundItems[$k]['order_item_id'] = $order_item['item_id'];

            }
            return $refundItems;
        }
        if(empty($refundItems)) {
            return array();
        }

        $objectMdl = app::get('ome')->model('order_objects');
        $itemMdl   = app::get('ome')->model('order_items');


        $return_items = array ();

        // 如果是捆绑
        foreach ($refundItems as $key => $value) {
            $object = $objectMdl->db_dump(array ('order_id' => $sdf['order']['order_id'], 'oid' => $value['oid'], 'delete' => 'false'));

            if (!$object) continue;

            if ($object['obj_type'] == 'pkg') {
                $items = $itemMdl->getList('*',array ('order_id' => $sdf['order']['order_id'], 'obj_id' => $object['obj_id'], 'delete' => 'false'));

                $i = 0; $c = count($items); $price = $value['price']; $priceAvg = bcdiv($price, $c, 2);
                foreach ($items as $v) {
                    if ($i == $c) {
                        $return_items[] = array (
                            'product_id' => $v['product_id'],
                            'bn'         => $v['bn'],
                            'name'       => $v['name'],
                            'price'      => $price,
                            'num'        => $v['nums']/$object['quantity']*$value['num'],
                            'sendNum'    => $v['sendnum'],
                            'order_item_id'=>   $v['item_id'],
                        );
                    } else {
                        $return_items[] = array (
                            'product_id' => $v['product_id'],
                            'bn'         => $v['bn'],
                            'name'       => $v['name'],
                            'price'      => $priceAvg,
                            'num'        => $v['nums']/$object['quantity']*$value['num'],
                            'sendNum'    => $v['sendnum'],
                            'order_item_id'=>   $v['item_id'],
                        );

                        $price = bcsub($price, $priceAvg, 2);
                    }
                }

                if (!$item) continue;

                $value['name']  = $item['name'];
                $value['price'] = $item['price'];

                $return_items[] = $value;

            } else {
                $item = $itemMdl->db_dump(array ('order_id' => $sdf['order']['order_id'], 'obj_id' => $object['obj_id'], 'delete' => 'false'));

                if (!$item) continue;

                $return_items[] = array (
                    'product_id' => $item['product_id'],
                    'bn'         => $item['bn'],
                    'name'       => $item['name'],
                    'sendNum'    => $item['sendnum'],
                    'price'      => $value['price'],
                    'num'        => $value['num'],
                    'order_item_id'=>   $item['item_id'],
                );
            }
        }

        return $return_items;
    }

    protected function _reshipAddItemList($sdf) {
        $reship_items = array();

        $rows = app::get('ome')->model('return_product_items')->getList('product_id,bn,name,num,price,order_item_id',array('return_id'=>$sdf['return_product']['return_id']));

        foreach ($rows as $value) {
            $reship_items[] = array (
                'product_id' => $value['product_id'],
                'bn'         => $value['bn'],
                'name'       => $value['name'],
                'price'      => $value['price'],
                'num'        => $value['num'],
                'sendNum'    => $value['num'],
                'order_item_id'=>$value['order_item_id'],
            );
        }

        return $reship_items;
    }

    public function add($params){
        if ($params['refund_type'] == 'reship' && $params['refund_id']) {

            $returnModel = app::get('ome')->model('return_product');
            $count = $returnModel->count(array (
                'shop_id'   => $this->__channelObj->channel['shop_id'],
                'return_bn' => $params['refund_id'],
                'source'    => 'matrix',
            ));
            if ($count == 0) {
                $returnRsp                = $params;
                $returnRsp['status']      = 'WAIT_BUYER_RETURN_GOODS';
                $returnRsp['refund_type'] = 'return';
                kernel::single('ome_return')->get_return_log($returnRsp,$this->__channelObj->channel['shop_id'],$msg);
            }
        }

        return parent::add($params);
    }



    public function formatArchiveitemlist($sdf, $convert){

        $refund_item_list = $sdf['refund_item_list']['return_item'];
        $items = array();
        $skuObj = app::get('inventorydepth')->model('shop_skus');
        foreach($refund_item_list as $v){

            //bn
            $item_id = $v['item_id'];//array('item_id'=>$item_id,'shop_id'=>$sdf['shop_id']),'shop_product_bn'
            $sku_detail = $skuObj->db->selectrow("SELECT shop_product_bn FROM sdb_inventorydepth_shop_skus WHERE shop_sku_id='".$item_id."' AND shop_id='".$sdf['shop_id']."'");
            if ($sku_detail){
                $productData = kernel::single('material_basic_select')->dump('material_name,material_bn,bm_id',array('material_bn'=>$sku_detail['shop_product_bn']));
           
            
                $items[] = array(

                    'bn'            =>  $sku_detail['shop_product_bn'],
                    'product_id'    =>  $productData['product_id'],
                    'name'          =>  $productData['name'],
                    'price'         =>  $sdf['refund_fee'],
                    //'sendNum'       =>  $order_item['sendnum'],
                    
                    'num'           =>  $v['num'],
                );
            }
            
        }

        return $items;
    }

}