<?php
/**
 * sunjing
 */

class erpapi_shop_matrix_pinduoduo_request_finance extends erpapi_shop_request_finance
{
    public function _getAddRefundParams($refund){
        $addon = unserialize($refund['addon']);
        if (!$refund || $addon['reship_id']) {
            return array();
        }

        $api_name = SHOP_AG_SEND_CANCEL;
        $title = '店铺('.$this->__channelObj->channel['name'].')同意退款(订单号:'.$refund['order_bn'].'退款单号:'.$refund['refund_bn'].')';

        $userName = kernel::single('desktop_user')->get_name();
        $params = array(
            'msg' => $userName . '同意',  # 审核意见
            'refund_id' => $refund['refund_apply_bn'],  # 售前退款数据唯一标示
            'status' => 'SUCCESS',
            'tid' => $refund['order_bn'],
        );
        return array($api_name, $title, $params);
    }

    /**
     * 退款申请单状态同步接口名
     * @param  string $status 2:已接受申请、3:已拒绝
     * @return [type]         [description]
     */
    public function _updateRefundApplyStatusApi($status)
    {
        return SHOP_AG_SEND_CANCEL;
    }

    /**
     * 退款申请单接口数据
     * @param  array $refund 退款申请单明细
     * @param  string $status 2:已接受申请、3:已拒绝
     * @return [type]         [description]
     */
    public function _updateRefundApplyStatusParam($refund, $status)
    {
        $oper = kernel::single('ome_func')->getDesktopUser();
        $params = array(
            'msg' => $oper['op_name'] . 'erp操作',  # 审核意见
            'refund_id' => $refund['refund_apply_bn'],  # 售前退款数据唯一标示
            'status' => $status == '2' ? 'SUCCESS' : 'FAIL',
        );

        return $params;
    }
}