<?php
/**
 * 发货单处理
 *
 * @category
 * @package
 * @author liuzecheng<liuzecheng@shopex.cn>
 * @version $Id: Z
 */
class erpapi_shop_matrix_vop_request_delivery extends erpapi_shop_request_delivery
{
    /**
     * 发货请求参数
     *
     * @return void
     * @author
     **/
    protected function get_confirm_params($sdf)
    {

        $param = parent::get_confirm_params($sdf);
        unset($param['company_name'], $param['logistics_no']);

        $product_list = array();
        foreach ($sdf['delivery_items'] as $key => $value) {
            if ($value['shop_goods_id'] && $value['shop_goods_id'] != '-1') {
                $product_list[$value['logi_no']][] = array (
                    'barcode' => $value['shop_goods_id'],
                    'amount'  => $value['number'],
                );
            }
        }

        if (kernel::single('ome_order_bool_type')->isJITX($sdf['orderinfo']['order_bool_type'])) {
            $param['store_sn'] = $sdf['store_code'];
            $param['package_num'] = 1;
            $param['tid'] = $sdf['orderinfo']['order_bn'];
            $packages = array ();
            foreach ($product_list as $logiNo => $value) {
                $detail = array();
                foreach ($value as $v) {
                    $detail[] = array(
                        'barcode' => $v['barcode'],
                        'quantity' => $v['amount'],
                    );
                }
                $packages[] = array(
                    'transport_no' => $logiNo,
                    'box_no' => 1,
                    'oqc_date' => $sdf['delivery_time'] ? $sdf['delivery_time'] : time(),
                    'package_no' => 1,
                    'details' =>$detail
                );
            }
            $param['packages'] = json_encode($packages);
        } else {
            if($sdf['delivery_bill_items']){
                foreach($sdf['delivery_bill_items'] as $bv){
                    if ($bv['shop_goods_id'] && $bv['shop_goods_id'] != '-1') {
                        $product_list[$bv['logi_no']][] = array (
                            'barcode' => $bv['shop_goods_id'],
                            'amount'  => $bv['number'],
                        );
                    }
                }
            }
            $packages = array ();
            foreach ($product_list as $logiNo => $value) {
                $packages[] = array(
                    'package_product_list' => $value,
                    'transport_no' => $logiNo,
                );
            }
            if(empty($packages)) {
                $packages[] = array(
                    'package_product_list' => array(),
                    'transport_no' => $sdf['logi_no'],
                );
            }
            $param['package_type'] = count($packages) > 1 ? 2 : 1;
            $param['packages'] = json_encode($packages);
        }
        return $param;
    }

    public function printThirdBill($sdf, $branchBn)
    {
        $orders = array();
        foreach ($sdf as $dly) {
            list($ident, $num) = explode('_', $dly['ident']);
            foreach ($dly['orders'] as $order) {
                $orders[] = array(
                    'seq_no' => str_pad($num, 5, '0', STR_PAD_LEFT),
                    'order_id' => $order['order_bn']
                );
            }
        }
        $title = '唯品会打印三单';
        $params = array();
        $params['store_sn'] = $branchBn;
        $params['batch_no'] = $branchBn . '-' . $ident;
        $params['print_type'] = 1;
        $params['orders'] = json_encode($orders);
        $rsp = $this->__caller->call(SHOP_PRINT_THIRD_BILL,$params, array(),$title,10,$ident);
        if($rsp['data']){
            $rsp['data'] = json_decode($rsp['data'], true);
        }
        return $rsp;
    }

    public function getDeliveryInfo($sdf)
    {
        $title = '唯品会获取发货单信息';
        $params = array();
        $params['store_sn'] = $sdf['branch_bn'];
        $params['orders'] = json_encode($sdf['order_bn']);
        $rsp = $this->__caller->call(SHOP_GET_DLY_INFO,$params, array(),$title,10,$sdf['primary_bn']);
        if($rsp['data']){
            $rsp['data'] = json_decode($rsp['data'], true);
            if($rsp['data']['msg']) {
                $rsp['data'] = json_decode($rsp['data']['msg'], true);
                $rsp['data'] = $rsp['data']['result'];
                foreach ($rsp['data'] as $k=>$val) {
                    $rsp['data'][$k]['order_bn'] = $val['order_id'];
                }
            }
        }
        return $rsp;
    }
}
