<?php
/**
 * 系统自动审单
 *
 * @access public
 * @author wangbiao<wangbiao@shopex.cn>
 * @version $Id: consign.php 2016-10-20
 */
class erpapi_shop_response_plugins_order_combine extends erpapi_shop_response_plugins_order_abstract
{
    public function convert(erpapi_shop_response_abstract $platform)
    {
        $combine    = array();
        
        #开启系统自动审单(默认:忽略可合并的订单)
        $cfg_combine    = app::get('ome')->getConf('ome.order.is_auto_combine');
        //$cfg_merge      = app::get('ome')->getConf('ome.order.is_merge_order');//忽略可合并的订单
        
        if($cfg_combine == 'true')
        {
            //过滤手动拉下来的订单
            if($platform->_ordersdf['auto_combine'] !== false)
            {
                $combine['order_id']    = null;
            }
        }
        
        if($platform->_ordersdf['cnAuto'] == 'true'){
            $combine['cnAuto'] = 'true';
        }
        return $combine;
    }
    
    /**
     * 订单完成后处理
     *
     * @return void
     * @author
     **/
    public function postCreate($order_id, $combine)
    {
        $pay_status    = false;
        
        //支付状态读取订单表(预售功能定制)
        $order_info    = app::get('ome')->model('orders')->dump(array('order_id'=>$order_id), 'pay_status, status, order_type, is_cod');
        
        //订单必须已支付OR货到付款,并且过滤单拉的订单
        if(($order_info['pay_status'] == '1' || $order_info['shipping']['is_cod'] == 'true') && $order_info['status'] == 'active' && in_array($order_info['order_type'], kernel::single('ome_order_func')->get_normal_order_type()))
        {
            //执行自动审单
            kernel::single('ome_order')->auto_order_combine($order_id,$combine);
        }
    }
}