<?php
/**
 * @author ykm 2017/7/6
 * @describe 订单发票
 */
class erpapi_shop_response_plugins_order_invoice extends erpapi_shop_response_plugins_order_abstract
{

    public function convert(erpapi_shop_response_abstract $platform)
    {
        $invoice = array();
        $invoice['tax_no']                  = $platform->_ordersdf['tax_no'];
        $invoice['tax_title']               = $platform->_ordersdf['tax_title'];
        $invoice['invoice_kind']            = $platform->_ordersdf['invoice_kind']?$platform->_ordersdf['invoice_kind']:"0";
        $invoice['invoice_bank_name']       = $platform->_ordersdf['invoice_bank_name'];
        $invoice['invoice_phone']           = $platform->_ordersdf['invoice_phone'];
        $invoice['invoice_address']         = $platform->_ordersdf['invoice_address'];
        $invoice['invoice_bank_account']    = $platform->_ordersdf['invoice_bank_account'];
        $invoice['value_added_tax_invoice'] = $platform->_ordersdf['value_added_tax_invoice'];
        $invoice['invoice_amount']          = $platform->_ordersdf['invoice_amount'];          // 开票金额
        
        if (!$platform->_tgOrder 
            && in_array($platform->__channelObj->channel['shop_type'], array('360buy'))){
            // $invoice_pmt_amount = 0;

            // 京东的优惠券，算支付金额。所以，ERP计算开票金额的时候，需要从支付总额中扣除优惠券。增加发票优惠字段invoice_pmt_amount
            // if ($platform->_ordersdf['pmt_detail']) {
            //     foreach($platform->_ordersdf['pmt_detail'] as $pmt_detail){
            //         list($pmt_prefix) = explode('-', $pmt_detail['pmt_describe']);
            //         if(!empty($pmt_detail['pmt_amount']) && in_array($pmt_prefix, array('41','52','34','39'))){
            //             $invoice_pmt_amount += $pmt_detail['pmt_amount'];
            //         }
            //     }
            // }

            if (!$invoice['invoice_amount']) $invoice['invoice_amount'] = $platform->_ordersdf['total_amount'];

            // 扣掉京东收取的退货无忧费
            if (1 === bccomp((float)$platform->_ordersdf['return_insurance_fee'], 0, 3)) {
                // $invoice_pmt_amount += $platform->_ordersdf['return_insurance_fee'];
                $invoice['invoice_amount'] -= $platform->_ordersdf['return_insurance_fee'];
            }

            // $invoice['invoice_pmt_amount'] = $invoice_pmt_amount;#发票优惠金额
        }


        $invoice['register_no'] = $platform->_ordersdf['payer_register_no'];
        $invoice['title_type'] = $invoice['register_no'] ? '1' : '0';
        $return = array();
        if($invoice['tax_no'] || $invoice['tax_title']) {
            if ($platform->_tgOrder) {
                $oldInvoice = app::get('ome')->model('order_invoice')->db_dump(array('order_id'=>$platform->_tgOrder['order_id']));
                if($oldInvoice) {
                    foreach ($invoice as $k => $val) {
                        if (isset($oldInvoice[$k]) && $val != $oldInvoice[$k]) {
                            $return[$k] = $val;
                        }
                    }
                } else {
                    $return = $invoice;
                }
            } else {
                $return = $invoice;
            }
        }
        return $return;
    }

    public function postCreate($order_id, $invoice)
    {
        $orderData = $this->getOrder($order_id);
        $sdf = app::get('ome')->model('orders')->plain_to_sdf($orderData);
        $sdf = array_merge($sdf, $invoice);

        
        kernel::single('ome_order_invoice')->insertInvoice($sdf);
    }

    public function postUpdate($order_id, $invoice) {
        app::get('ome')->model('order_invoice')->update($invoice, array('order_id'=>$order_id));
    }
}