<?php
/**
 * sunjing@shopex.cn
 * 换货订单处理
 */
class erpapi_shop_response_process_exchange {

    public function add($sdf) {

        $modelReturnProduct = app::get('ome')->model('return_product');
        if($sdf['return_product']) {
            $idBn = array(
                'return_id' => $sdf['return_product']['return_id'],
                'return_bn' => $sdf['return_product']['return_bn']
            );
            $this->_dealTableAdditional($sdf['table_additional'], $idBn);
            $this->_returnProductUpdateStatus($sdf);

            $msg = '更新成功';
        } else {
            $insertData = $this->_returnProductSdfToData($sdf);

            $returnProductItems = $insertData['return_product_items'];
            unset($insertData['return_product_items']);
            $rs = $modelReturnProduct->insert($insertData);
            if(!$rs) {
                return array('rsp'=>'fail', 'msg'=>'售后申请单新建失败');
            }
            $this->_insertReturnProductItems($returnProductItems, $insertData['return_id']);
            app::get('ome')->model('operation_log')->write_log('return@ome',$insertData['return_id'],'创建售后申请单');
            $msg = '创建售后申请单成功';
            $idBn = array(
                'return_id' => $insertData['return_id'],
                'return_bn' => $insertData['return_bn']
            );
            $this->_dealTableAdditional($sdf['table_additional'], $idBn);
            if (in_array($sdf['status'],array('3','5','6'))) {
                $sdf['return_id'] = $insertData['return_id'];
                $sdf['status'] = in_array($sdf['status'],array('3','4','6')) ? '3' : $sdf['status'];
                $this->_returnProductUpdateStatus($sdf);

            }

        }
        
        //退换货单自动审核
        if($sdf['status'] == '3'){
            /***
             * todo: 换货接口不自动推送队列审核，手工审核比较好.
             * 
            $is_auto_approve = app::get('ome')->getConf('return.auto_approve');
            if($is_auto_approve == 'on'){
                $Oreship = app::get('ome')->model('reship');
                $reshipLib = kernel::single('ome_reship');
                
                //获取reship_id
                $return_id = ($sdf['return_product'] ? $sdf['return_product']['return_id'] : $insertData['return_id']);
                $reshipdata = $Oreship->dump(array('return_id'=>$return_id, 'is_check'=>'0'), 'reship_id');
                
                //处理退换货单
                if($reshipdata['reship_id']){
                    $result = $reshipLib->batch_reship_queue($reshipdata['reship_id']);
                }
            }
            ***/
        }
        
        return array('rsp'=>'succ', 'msg' => $msg);
    }



    private function _dealTableAdditional($tableAdditional, $idBn) {

        if(empty($tableAdditional) || empty($idBn)) {
            return false;
        }
        $model = app::get('ome')->model($tableAdditional['model']);
        $data = array_merge($tableAdditional['data'], $idBn);

        $model->db_save($data);
    }


    private function _dealReturnProduct($sdf) {

    }

    private function _returnProductSdfToData($sdf) {

        $opInfo = kernel::single('ome_func')->get_system();
        $data = array(
            'return_bn'  => $sdf['return_bn'],
            'shop_id'    => $sdf['shop_id'],
            'member_id'  => $sdf['member_id'],
            'order_id'   => $sdf['order']['order_id'],
            'title'      => $sdf['order_bn'].'售后申请单',
            'content'    => $sdf['reason'],
            'comment'    => $sdf['desc'],
            'add_time'   => $sdf['created'],
            'status'     => '1',
            'op_id'      => $opInfo['op_id'],
            'refundmoney'=> '0',
            'money'      => '0',
            'shipping_type'=> $sdf['shipping_type'],
            'source'     => 'matrix',
            'shop_type'  => $sdf['shop_type'],
            'outer_lastmodify'=>$sdf['modified'],
            'delivery_id'=> $sdf['delivery_id'],
            'return_type'=>'change',
        );

        $refund_fee = 0;
        foreach($sdf['return_items'] as $val) {
            $val['branch_id']               =       $sdf['branch_id'];
            $data['return_product_items'][] =       $val;
            $refund_fee+=$val['num']*$val['price'];
        }

        $data['refundmoney'] = $data['money'] = $refund_fee;

        return $data;
    }

    private function _insertReturnProductItems($returnProductItems, $returnId) {
        if(empty($returnId) || empty($returnProductItems)) {
            return false;
        }
        foreach($returnProductItems as &$val) {
            $val['return_id'] = $returnId;
        }
        $modelItem = app::get('ome')->model('return_product_items');
        $sql = ome_func::get_insert_sql($modelItem, $returnProductItems);
        $rs = $modelItem->db->exec($sql);
        return $rs['rs'];
    }


    private function _returnProductUpdateStatus($sdf) {
        $operateLog = app::get('ome')->model('operation_log');
        $modelReturnProduct = app::get('ome')->model('return_product');
        $returnProduct = $sdf['return_product'];
        switch($sdf['status']) {
            case '1':

                break;
            case '3':

                $data = array(
                    'status'    => $sdf['status'],
                    'return_id' => $returnProduct['return_id'] ? $returnProduct['return_id'] : $sdf['return_id'],
                    'outer_lastmodify' => $sdf['modified'],
                    'choose_type_flag' => '1',
                );
                $modelReturnProduct->tosave($data, true);

                break;
            case '4':
            case '6':
                if ($sdf['reship']) {
                    $this->_updateReshipLogistics($sdf);
                }

                //如果没有退货单的情况下
                if (!$sdf['reship'] && $sdf['return_product']['status']<3){//售后申请单状态不为拒绝
                    $data = array(
                        'status'    => '3',
                        'return_id' => $returnProduct['return_id'],
                        'outer_lastmodify' => $sdf['modified'],
                        'choose_type_flag' => '1',
                    );
                    $modelReturnProduct->tosave($data, true);
                }
                $operateLog->write_log('return@ome', $returnProduct['return_id'],'线上已完成,请进行收货/质检等操作');
                break;
            case '5':
                $data = array(
                    'status'    => $sdf['status'],
                    'return_id' => $returnProduct['return_id'] ? $returnProduct['return_id'] : $sdf['return_id'],
                    'outer_lastmodify' => $sdf['modified'],
                );
                $modelReturnProduct->tosave($data, true);
                // 同步拒绝退货单
                if ($sdf['reship']){
                    $reship = $sdf['reship'];
                    $rs = console_reship::notice($reship);
                    console_reship::cancel($reship,'线上取消');

                }
                break;

            default:
                break;
        }
    }



    private function _updateReshipLogistics($sdf){
        $reship = $sdf['reship'];
        $logisticsCompany = $sdf['logistics_company'];
        $logisticsNo = $sdf['logistics_no'];
        if($reship){
            if ($reship && !$sdf['reship']['return_logi_name'] && (!$sdf['reship']['return_logi_no'] || $sdf['reship']['return_logi_no']=='None') && $logisticsCompany && $logisticsNo) {
                $memo ='更新物流公司:'.$logisticsCompany.',物流单号:'.$logisticsNo;
                $upData = array(
                    'return_logi_name'=>$logisticsCompany,
                    'return_logi_no'=>$logisticsNo,
                    'outer_lastmodify'=>$sdf['modified'],
                );

            }
            if ($sdf['version_change'] && $sdf['reship']['is_check']=='5' && $sdf['status']=='6'){//版本变化
                //未审核 接收申请
                $upData['is_check'] = '0';
                $upData['outer_lastmodify'] = $sdf['modified'];
                $memo.="版本变化,状态更新为未审核状态";
                $returnData= array('status'=>'3','outer_lastmodify'=>$sdf['modified']);
            }
            if ($upData){
                $rs = app::get('ome')->model('reship')->update($upData,array('reship_id'=>$reship['reship_id']));
                $operateLog = app::get('ome')->model('operation_log');
                $operateLog->write_log('reship@ome',$reship['reship_id'],$memo);
                if ($returnData){
                    app::get('ome')->model('return_product')->update($returnData,array('return_id'=>$sdf['return_product']['return_id']));
                    $operateLog->write_log('return@ome', $sdf['return_product']['return_id'],'版本变化更新成接受申请状态');
                }
            }
        }

        return false;
    }




}
