<?php
/**
 * 自助开发票
 * 
 * @author sunjing
 * @version 0.1
 */
class erpapi_shop_response_process_invoice {

    public function message_push($sdf) {
        if($sdf['old_invoice']) {
            $upData = array(
                'order_id'=>$sdf['old_invoice']['order_id'],
                'register_no' => $sdf['register_no'],
                'invoice_kind' => $sdf['invoice_kind'],
            );
            app::get('ome')->model('order_invoice')->update($upData, array('id'=>$sdf['old_invoice']['id']));
            kernel::single('ome_event_trigger_shop_invoice')->update_register_no($upData);
            return array('rsp'=>'succ', 'msg'=>'更新发票税号成功');
        }
        $insertData = array(
            'order_id' => $sdf['order_info']['order_id'],
            'tax_title' => $sdf['tax_title'],
            'register_no' => $sdf['register_no'],
            'invoice_kind' => $sdf['invoice_kind'],
            'title_type' => $sdf['title_type'],
            'create_time' => time()
        );
        $rs = app::get('ome')->model('order_invoice')->insert($insertData);
        if($rs) {
            app::get('ome')->model('operation_log')->write_log('order_modify@ome',$sdf['order_info']['order_id'],'订单保存发票信息');
            if($sdf['order_info']['is_tax'] == 'false') {
                app::get('ome')->model('orders')->update(array('is_tax' => 'true'), array('order_id' => $sdf['order_info']['order_id']));
            }
            $params = array_merge($sdf['order_info'], $insertData);
            kernel::single('ome_event_trigger_shop_invoice')->process($params,'create_invoice_order','order_create');
            return array('rsp'=>'succ', 'msg'=>'发票生成成功');
        }
        return array('rsp'=>'fail', 'msg'=>'发票生成失败');
    }

    public function add($order)
    {
        $orderMdl     = app::get('ome')->model('orders');
        $orderInvoice = app::get('ome')->model('order_invoice');

        // 判断是否已经开票
        $invoiceCount = $orderInvoice->count(array('order_id'=>$order['order_id']));

        // 如果未开票，删除重来
        if ($invoiceCount && app::get('invoice')->is_installed()) {
            $invoiceMdl = app::get('invoice')->model('order');

            foreach ($invoiceMdl->getList('is_status,order_id,sync',array('order_id'=>$order['order_id'])) as $value) {
                if ($value['is_status'] == '1' || $value['sync'] != '0') {
                    return array('rsp'=>'fail','msg'=>'订单已经开票!');
                }
            }

            if ($order['order_id']) $invoiceMdl->delete(array('order_id'=>$order['order_id']));
        }

        if ($invoiceCount) $orderInvoice->delete(array('order_id'=>$order['order_id']));

        // 标记订单为开票
        $orderMdl->update(array('is_tax'=>'true'), array('order_id'=>$order['order_id']));

        $memo = '买家要求开票,发票抬头: '. $order['tax_title'];
        kernel::single('ome_order_invoice')->insertInvoice($order,$memo);

        return array('rsp'=>'succ','msg'=>'自助开发票成功!');

    }
}
