<?php
/**
 * 规则应用模型类
 *
 * @author chenping<chenping@shopex.cn>
 */

class inventorydepth_mdl_regulation_apply extends dbeav_model 
{
    public $defaultOrder = 'priority asc';

    public function modifier_using($row) 
    {
        $using = '';
        if ($row == 'true') {
            $using = '<span style="color:green;">已启用</span>';
        } else {
            $using = '<span style="color:red;">未启用</span>';
        }

        return $using;
    }

    //定义导入文件模版字段
    function exportTemplate($filter){
        foreach ($this->io_title($filter) as $v){
            $title[] = kernel::single('base_charset')->utf2local($v);
        }
        return $title;
    }

    function io_title( $filter=null){
        switch( $filter ){
            case 'csv':
            default:
                $this->oSchema['csv'][$filter] = array(
                    '*:销售物料编码' => 'sales_material_bn',
                    '*:物料类型' => 'sales_material_type',
                   
                );
                
                break;
        }
        
        return $this->ioTitle['csv'][$filter] = array_keys( $this->oSchema['csv'][$filter] );   
     }

     function prepared_import_csv_row($row,$title,&$tmpl,&$mark,&$newObjFlag,&$msg){
        $salesMaterialObj    = app::get('material')->model('sales_material');
        $this->aa++;
        $mark = false;
        $fileData = $this->kvdata;
        if(!$fileData){
            $fileData = array();
        }
        if( substr($row[0],0,2) == '*:' ){
            $titleRs =  array_flip($row);
            $mark = 'title';
            return $titleRs;
        }else{
            //销售物料类型
            switch($row[1]){
                case "普通":
                    $sales_material_type = "1";
                    break;
                case "促销":
                    $sales_material_type = "2";
                    break;
                case "多选一":
                    $sales_material_type = "5";
                    break;
            }
            $sales_material_bn = trim($row[0]);
            if ($sales_material_bn) {
                $products    = $salesMaterialObj->dump(array('sales_material_bn'=>$sales_material_bn,'sales_material_type'=>$sales_material_type), 'sm_id');
                if(!$products){
                    $msg['error'] = '货号不存在 '.$sales_material_bn;
                    return false;
                }
                $fileData[$sales_material_type][] = $products['sm_id'];
            }
            $this->kvdata = $fileData;
        }
        return null;
     }

     function prepared_import_csv(){
        set_time_limit(0);
    }

    function finish_import_csv(){
        $applyObj = $this->app->model('regulation_apply');
        $data = $this->kvdata; unset($this->kvdata);
        $import_apply_goods = !empty($data[1]) ? $data[1] : array();
        $import_apply_pkg = !empty($data[2]) ? $data[2] : array();
        $import_apply_pko = !empty($data[5]) ? $data[5] : array();
        $id = intval($_POST['id']);
        $apply = $applyObj->dump(array('id'=>$id),'apply_goods,apply_pkg,apply_pko');
        if($apply['apply_goods'] == "_ALL_" && $apply['apply_pkg'] == "_ALL_" && $apply['apply_pko'] == "_ALL_" &&
                (!empty($import_apply_goods) || !empty($import_apply_pkg) || !empty($import_apply_pko))){
                $old_apply_goods = $old_apply_pkg = $old_apply_pko = array();
        }else{
            $old_apply_goods = $apply['apply_goods'] ? explode(',',$apply['apply_goods']) : array();
            $old_apply_pkg = $apply['apply_pkg'] ? explode(',',$apply['apply_pkg']) : array();
            $old_apply_pko = $apply['apply_pko'] ? explode(',',$apply['apply_pko']) : array();
        }
        $update_data = array();
        $apply_goods = array_merge($import_apply_goods,$old_apply_goods);
        $update_data['apply_goods'] = implode(',',array_unique($apply_goods));
        $apply_pkg = array_merge($import_apply_pkg,$old_apply_pkg);
        $update_data['apply_pkg'] = implode(',',array_unique($apply_pkg));
        $apply_pko = array_merge($import_apply_pko,$old_apply_pko);
        $update_data['apply_pko'] = implode(',',array_unique($apply_pko));
        $applyObj->update($update_data,array('id'=>$id));
        return null;
    }
}
