<?php

class logisticsmanager_waybill_taobao {
    /**
     * 云栈订单来源列表
     * @var Array $channelsTypeList
     */
    public static $channelsTypeList = array(
        'C' => 'TB',//淘宝
        'B' => 'TM',//天猫
        'OTHER' => 'OTHERS',//其它
    );
    /**
     * 默认订单来源类型
     * @var String 默认来源
     */
    public static $defaultChannelsType = 'OTHER';
    
    public static $businessType = array(
        'EMS' => 1,
        'EYB' => 2,
        'SF' => 3,
        'ZJS' => 4,
        'ZTO' => 5,
        'HTKY' => 6,
        'UC' => 7,
        'YTO' => 8,
        'STO' => 9,
        'TTKDEX' => 10,
        'DBKD'=>11,
        '100004928'=>12,
        'CN7000001003751'=>13,
        '2608021499_235'=>14,
        '2460304407_385'=>15,
        '2383545689_32'=>16,
    );

    /**
     * 获取物流公司编码
     * @param Sring $logistics_code 物流代码
     */
    public function logistics($logistics_code) {
        $logistics = array(
            'EMS' => array('code'=>'EMS','name'=>'普通EMS'),
            'EYB'=>array('code'=>'EYB','name'=>'经济EMS'),
            'SF'=>array('code'=>'SF','name'=>'顺丰'),
            'ZJS' => array('code' => 'ZJS', 'name'=>'宅急送'),
            'ZTO' => array('code' => 'ZTO', 'name' => '中通快递'),
            'HTKY' => array('code' => 'HTKY', 'name'=>'百世汇通'),
            'UC' => array('code' => 'UC', 'name' => '优速'),
            'YTO' => array('code' => 'YTO', 'name' => '圆通'),
            'STO' => array('code' => 'STO', 'name' => '申通'),
            'TTKDEX' => array('code' => 'TTKDEX', 'name' => '天天'),
            'QFKD' => array('code' => 'QFKD', 'name' => '全峰'),
            'FAST' => array('code' => 'FAST', 'name' => '快捷'),
            'POSTB' => array('code' => 'POSTB', 'name' => '邮政小包'),
	 '5000000007756'=>array('code' => '5000000007756', 'name' => '邮政标准快递'),	
            'GTO' => array('code' => 'GTO', 'name' => '国通'),
            'YUNDA'=>array('code' => 'YUNDA', 'name' => '韵达'),
            'DBKD'=>array('code' => 'DBKD', 'name' => '德邦快递'),
           
            '100004928'=>array('code' => '100004928', 'name' => '如风达'),
            '2608021499_235'=>array('code' => '2608021499_235', 'name' => '安能'),
            'CN7000001003751'=>array('code' => 'CN7000001003751', 'name' => '跨越速运'),
            
            '2460304407_385'=>array('code' => '2460304407_385', 'name' => '远成快运'),
            '2383545689_32'=>array('code' => '2383545689_32', 'name' => '九曳供应链'),
	    'CN7000001009020' => array('code'=>'CN7000001009020', 'name'=>'德邦快运','parent_waybill' => true),
            
            'BESTQJT'=>array('code' => 'BESTQJT', 'name' => '百世快运'),
             'DEPPON'=>array('code' => 'DEPPON', 'name' => '德邦物流'),
            'CN7000001000869' => array('code' => 'CN7000001000869', 'name'=>'安能快运','parent_waybill' => true),
            '2744832184_543'  => array('code' => '2744832184_543', 'name'=>'壹米滴答','parent_waybill' => true),
            'CN7000001021040' => array('code' => 'CN7000001021040', 'name'=>'韵达快运','parent_waybill' => true),
            '3108002701_1011'=>array('code' => '3108002701_1011', 'name' => '中通快运'),
        );

        if (!empty($logistics_code)) {
            return $logistics[$logistics_code];
        }
        return $logistics;
    }

    /**
     * 获取订单来源类型
     * @param String $type 类型
     */
    public static function get_order_channels_type($type) {
        $type = strtoupper($type);
        if (in_array($type, array_keys(self::$channelsTypeList))) {
            $channelsType =  self::$channelsTypeList[$type];
        }
        else {
            $channelsType = self::$channelsTypeList[self::$defaultChannelsType];
        }
        return $channelsType;
    }

    public static function getBusinessType($type) {
        $type = strtoupper($type);
        return self::$businessType[$type];
    }

    public function service_code($param) {
        $sdf = array('cp_code'=>$param['logistics']);
        $rs = kernel::single('erpapi_router_request')->set('shop', $param['shop_id'])->logistics_getCorpServiceCode($sdf);
        if($rs['rsp'] == 'fail' || empty($rs['data'])) {
            return array();
        }
        $data = json_decode($rs['data'], 1);
        $service = array();
        if($data['waybill_apply_subscription_info']) {
//            $objWaybillType = $this->_getObject($sdf['cp_code']);
//            $service = $objWaybillType->getServiceCode($data['waybill_product_type']);
            $obj = kernel::single('logisticsmanager_waybill_taobao_common');
            $service = $obj->getServiceCode($data);
        }
        return $service;
    }

    public function getServiceCodeValue($cpCode, $serviceCode) {
        if(empty($serviceCode)) {
            return array();
        }
//        $objWaybillType = $this->_getObject($cpCode);
//        return $objWaybillType->getServiceCodeValue($serviceCode);
        $obj = kernel::single('logisticsmanager_waybill_taobao_common');
        return $obj->getServiceCodeValue($serviceCode);
    }

//    protected function _getObject($cpCode) {
//        $obj = kernel::single('logisticsmanager_waybill_taobao_common');
//        $className = 'logisticsmanager_waybill_taobao_' . strtolower($cpCode);
//        try{
//            if(class_exists($className)) {
//                $obj = kernel::single($className);
//            }
//        }catch (Exception $e) {}
//
//        return $obj;
//    }
//    
    public function template_cfg() {
        $arr = array(
            'template_name' => '菜鸟',
            'shop_name' => '淘宝',
            'print_url' => 'http://cloudprint.cainiao.com/cloudprint/client/CNPrintSetup.exe',
            'template_url' => 'https://cloudprint.cainiao.com',
            'shop_type' => 'taobao',
            'control_type' => 'cainiao',
            'template_type'=>array('cainiao','cainiao_standard','cainiao_user'),
        );
        return $arr;
    }
}