<?php
/**
 * 基础物料控制层
 *
 * @author kamisama.xia@gmail.com
 * @version 0.1
 */

class material_ctl_admin_material_basic extends desktop_controller{

    var $workground = 'goods_manager';
    var $view_source = 'normal';

    /**
     * 基础物料列表分栏菜单
     *
     * @param Null
     * @return Array
     */
    function _views(){

        //默认列表查看的时候才显示TAB，关联物料时弹窗列表页不加载TAB by xiayuanjun
        if($this->view_source == 'normal'){
           $sub_menu = $this->_viewsNormal();
        }

        return $sub_menu;
    }

    function _viewsNormal(){
        $basicMaterialObj = app::get('material')->model('basic_material');

        $sub_menu = array(
            0 => array('label'=>app::get('base')->_('全部'),'filter'=>array(),'optional'=>false),
            1 => array('label'=>app::get('base')->_('在售'),'filter'=>array("visibled"=>1),'optional'=>false),
            2 => array('label'=>app::get('base')->_('停售'),'filter'=>array("visibled"=>2),'optional'=>false),
            3 => array('label'=>app::get('base')->_('全渠道'),'filter'=>array('omnichannel'=>1),'optional'=>false),
            4 => array('label'=>app::get('base')->_('非全渠道'),'filter'=>array('omnichannel'=>2),'optional'=>false),
        );

        foreach($sub_menu as $k=>$v)
        {
            $sub_menu[$k]['filter'] = $v['filter']?$v['filter']:null;
            $sub_menu[$k]['addon'] = $basicMaterialObj->count($v['filter']);
            $sub_menu[$k]['href'] = "index.php?app=material&ctl=admin_material_basic&act=".$_GET['act']."&view=".$k;
        }

        return $sub_menu;
    }

    /**
     * 基础物料列表项方法
     *
     * @param Post
     * @return String
     */
    function index(){

        $use_buildin_export    = false;
        $use_buildin_import    = false;
        
        $actions = array();
        $actions_group = array(
            array(
                'label' => '批量停售',
                'submit' => "index.php?app=material&ctl=admin_material_basic&act=batchInvisible&p[0]=".$_GET['view'],
                'confirm' => '你确定要对勾选的基础物料统一设为停售？',
                'target' => 'refresh'
            ),
            array(
                'label' => '批量在售',
                'submit' => "index.php?app=material&ctl=admin_material_basic&act=batchVisible&p[0]=".$_GET['view'],
                'confirm' => '你确定要对勾选的基础物料统一设为在售？',
                'target' => 'refresh'
            ),
        );
        if($_GET['view'] == "1"){ //在售tab 不显示批量在售
            unset($actions_group[1]);
        }elseif($_GET['view'] == "2"){ //停售tab 不显示批量停售
            unset($actions_group[0]);
        }
        
        switch($_GET['view'])
        {
            case '3':
            case '4':
                $actions_group[] = array(
                    'label' => '批量设置全渠道',
                    'submit'=> 'index.php?app=material&ctl=admin_material_basic&act=batchUpOmnichannel&p[0]='. $_GET['view'],
                    'target'=> 'dialog::{width:600,height:300,title:\'批量设置全渠道\'}"',
                );
            break;
            default:
                $use_buildin_export    = true;
                $use_buildin_import    = true;
                $actions    = array(
                                    array(
                                        'label' => '新增',
                                        'href' => 'index.php?app=material&ctl=admin_material_basic&act=add',
                                        'target' => '_blank',
                                    ),
                                    array(
                                        'label' => '导出模板',
                                        'href' => 'index.php?app=material&ctl=admin_material_basic&act=exportTemplate',
                                        'target' => '_blank',
                                    ),
                                );
                
                $actions_group[] = array(
                    'label'=>'批量设置保质期',
                    'submit'=>"index.php?app=material&ctl=admin_material_basic&act=BatchUpExpire&p[0]=".$_GET['view'],
                    'target'=>'dialog::{width:600,height:300,title:\'批量设置保质期\'}"',
                );
        }
        
        //压入批量操作
        $actions[] = array(
            "label" => "批量操作",
            "group" => $actions_group
        );

        $params = array(
            'title'=>'基础物料',
            'actions' => $actions,
            'base_filter' => $base_filter,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_filter'=>true,
            'use_buildin_export'=> $use_buildin_export,
            'use_buildin_import'=> $use_buildin_import,
            'finder_cols' => 'column_edit,material_name,material_bn,column_barcode,column_cost,column_weight,column_unit,column_retail_price,visibled,column_specifications,column_brand',
        );

        $this->finder('material_mdl_basic_material',$params);
    }

    /**
     * 基础物料批量导入的模板
     *
     * @param Null
     * @return String
     */
    function exportTemplate(){
        header("Content-Type: text/csv");
        header("Content-Disposition: attachment; filename=基础物料导入模板-".date('Ymd').".csv");
        header('Cache-Control:must-revalidate,post-check=0,pre-check=0');
        header('Expires:0');
        header('Pragma:public');
        $basicMaterialObj = app::get('material')->model('basic_material');
        $title = $basicMaterialObj->exportTemplate('basicM');
        echo '"'.implode('","',$title).'"';

        #模板案例
        $data[0]        = array('导入成品基础物料一','material_001','成品','barcode_001','在售','件','150','120','500',
                                'semi_material_001:1|semi_material_002:1|semi_material_003:1','关闭','','','灯具','200w灯泡|1米6灯架|黑色灯罩','商派OMS','开启','1','11','是','开启','否');
        $data[1]        = array('导入半成品基础物料二','material_002','半成品','barcode_002','在售','件','180','135','750',
                                '','开启','18','12','男装','白色|170M|棉','ONex OMS','关闭','','','否','关闭','是');

        foreach ($data as $items)
        {
            foreach ($items as $key => $val)
            {
                $items[$key]    = kernel::single('base_charset')->utf2local($val);
            }

            echo "\n";
            echo '"'.implode('","',$items).'"';
        }
    }

    /**
     * 基础物料新增的展示页面方法
     *
     * @param void
     * @return void
     */
    function add(){
        /*
        $featureGrpObj = app::get('flowctrl')->model('feature_group');
        $featureGrpList = $featureGrpObj->getList('*',array(), 0, -1);
        $this->pagedata['featureGrpList'] = $featureGrpList;
        */

        #获取物料品牌
        $brand_obj = app::get('ome')->model('brand');
        $brands = $brand_obj->getList('brand_id,brand_name', array());

        #获取物料分类
        $goods_type_obj = app::get('ome')->model('goods_type');
        $goods_types = $goods_type_obj->getList('type_id,name', array());

        #第三方仓储版_隐藏保质期管理(未安装invoice并且已安装omevirtualwms) ExBOY
        $show_storage_life    = true;
        if(app::get('invoice')->is_installed() == false)
        {
            if(app::get('omevirtualwms')->is_installed())
            {
                $show_storage_life    = false;
            }
        }

        $this->pagedata['show_storage_life']    = $show_storage_life;
        $this->pagedata['material_brand']       =  $brands;

        $this->pagedata['goods_types'] = $goods_types;

        $envSpecConf = app::get('ome')->getConf('ome.product.serial.merge');
        $this->pagedata['envSpecConf'] = $envSpecConf;

        //是否有O2O门店
        $exist_store = $this->getStoreRs();
        $this->pagedata['exist_store']    = $exist_store;

        $this->singlepage('admin/material/basic/add.html');
    }

    /**
     * 基础物料新增提交方法
     *
     * @param Post
     * @return Boolean
     */
    function toAdd(){
        $this->begin('index.php?app=material&ctl=admin_material_basic&act=index');

        #检查数据有效性
        $checkBasicLib    = kernel::single('material_basic_check');
        $err_msg          = '';

        if(!$checkBasicLib->checkParams($_POST, $err_msg)){
            $this->end(false, $err_msg);
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialExtObj = app::get('material')->model('basic_material_ext');
        $basicMaterialFeatureGrpObj = app::get('material')->model('basic_material_feature_group');
        $basicMaterialStockObj = app::get('material')->model('basic_material_stock');
        $basicMaterialConfObj = app::get('material')->model('basic_material_conf');
        $basicMaterialConfObjSpe = app::get('material')->model('basic_material_conf_special');
        $barocdeObj = app::get('material')->model('barcode');
        
        //是否全渠道
        $omnichannel = ($_POST['omnichannel'] == 1 ? 1 : 2);
        
        //保存物料主表信息
        $addData = array(
            'material_name' => $_POST['material_name'],
            'material_bn' => trim($_POST['material_bn']),
            'material_spu' => trim($_POST['material_spu']),
            'material_bn_crc32' => $_POST['material_bn_crc32'],
            'type' => $_POST['type'],
            'serial_number' => $_POST['serial_number'],
            'visibled' => $_POST['visibled'],
            'create_time' => time(),
            'omnichannel' => $omnichannel,
        );
        $is_save = $basicMaterialObj->save($addData);

        if($is_save){

            //保存条码信息
            $sdf = array(
                'bm_id' => $addData['bm_id'],
                'type' => material_codebase::getBarcodeType(),
                'code' => $_POST['material_code'],
            );
            $barocdeObj->insert($sdf);

            //保存保质期配置
            $useExpireConfData = array(
                'bm_id' => $addData['bm_id'],
                'use_expire' => $_POST['use_expire'] == 1 ? 1 : 2,
                'warn_day' => $_POST['warn_day'] ?  $_POST['warn_day'] : 0,
                'quit_day' => $_POST['quit_day'] ? $_POST['quit_day'] : 0,
                'create_time' => time(),
            );
            $basicMaterialConfObj->save($useExpireConfData);

            //如果关联半成品数据
            if($addData['type'] == 1){
                $basicMaterialCombinationItemsObj = app::get('material')->model('basic_material_combination_items');
                if(isset($_POST['at'])){
                    foreach($_POST['at'] as $k=>$v){
                        $tmpChildMaterialInfo = $basicMaterialObj->dump($k, 'material_name,material_bn');

                        $addCombinationData = array(
                            'pbm_id' => $addData['bm_id'],
                            'bm_id' => $k,
                            'material_num' => $v,
                            'material_name' => $tmpChildMaterialInfo['material_name'],
                            'material_bn' => $tmpChildMaterialInfo['material_bn'],
                            'material_bn_crc32' => sprintf('%u',crc32($tmpChildMaterialInfo['material_bn'])),
                        );
                        $basicMaterialCombinationItemsObj->insert($addCombinationData);
                        $addCombinationData = null;
                    }
                }
            }

            //保存基础物料的关联的特性
            if($_POST['ftgp_id']){
                $addBindFeatureData = array(
                    'bm_id' => $addData['bm_id'],
                    'feature_group_id' => $_POST['ftgp_id'],
                );
                $basicMaterialFeatureGrpObj->insert($addBindFeatureData);
                $addBindFeatureData = null;
            }

            //保存物料扩展信息
            $addExtData = array(
                'bm_id' => $addData['bm_id'],
                'cost' => $_POST['cost'] ? $_POST['cost'] : 0.00,
                'retail_price' => $_POST['retail_price'] ? $_POST['retail_price'] : 0.00,
                'weight' => $_POST['weight'] ? $_POST['weight'] : 0.00,
                'unit' => $_POST['unit'],
                'specifications' => $_POST['material_specification'],
                'brand_id' => empty($_POST['brand']) ? 0 : $_POST['brand'],
                'cat_id' => empty($_POST['goods_type']) ? '' : $_POST['goods_type'],
            );
            $basicMaterialExtObj->insert($addExtData);

            //保存物料库存信息
            $addStockData = array(
                'bm_id' => $addData['bm_id'],
                'store' => $_POST['store'] ? $_POST['store'] : 0,
                'store_freeze' => $_POST['store_freeze'] ? $_POST['store_freeze'] : 0,
            );
            $basicMaterialStockObj->insert($addStockData);

            //保存特殊扫码配置信息
            $addScanConfInfo = array(
                'bm_id' => $addData['bm_id'],
                'openscan' => $_POST['special_setting'] ? $_POST['special_setting'] : "",
                'fromposition' => $_POST['first_num'] ? $_POST['first_num'] : "",
                'toposition' => $_POST['last_num'] ? $_POST['last_num'] : "",
            );
            $basicMaterialConfObjSpe->insert($addScanConfInfo);

            //logs
            $operationLogObj    = app::get('ome')->model('operation_log');
            $operationLogObj->write_log('basic_material_add@wms', $addData['bm_id'], '基础物料添加');

            $this->end(true, '操作成功');
        }else{
            $this->end(false, '保存失败');
        }

    }

    /**
     * 基础物料编辑的展示页面方法
     *
     * @param Int $bm_id
     * @return Boolean
     */
    function edit($bm_id){
        $this->begin('index.php?app=material&ctl=admin_material_basic&act=index');
        if (empty($bm_id)){
            $this->end(false,'操作出错，请重新操作');
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialExtObj = app::get('material')->model('basic_material_ext');
        $basicMaterialCodeObj = app::get('material')->model('codebase');
        $basicMaterialConfObj = app::get('material')->model('basic_material_conf');
        $basicMaterialConfObjSpe = app::get('material')->model('basic_material_conf_special');
        $basicMaterialBrand = app::get('ome')->model('brand');

        $tmp_bm_id = intval($bm_id);
        $basicMaterialInfo = $basicMaterialObj->dump($tmp_bm_id);
        if(!$basicMaterialInfo){
            $this->end(false,'操作出错，请重新操作');
        }

        //检查部分按钮是否只读不可能修改
        $checkBasicLib    = kernel::single('material_basic_check');
        $readonly         = $checkBasicLib->checkEditReadOnly($bm_id);

        $basicMaterialExtInfo = $basicMaterialExtObj->dump($tmp_bm_id);
        $basicMaterialConfInfo = $basicMaterialConfObj->dump($tmp_bm_id);
        $basicMaterialBrandInfo = $basicMaterialBrand->getList('brand_id,brand_name', array());

        $material_info = array_merge($basicMaterialInfo,(array)$basicMaterialExtInfo,(array)$basicMaterialConfInfo);

        $basicBarCode = $basicMaterialCodeObj->dump(array('bm_id' => $tmp_bm_id, 'type' => material_codebase::getBarcodeType()), 'code');
        $material_info['material_cdoe'] =  empty($basicBarCode)?'':$basicBarCode['code'];

        $basicMaterialFeatureGrpObj = app::get('material')->model('basic_material_feature_group');
        $basicMaterialFeatureGrpInfo = $basicMaterialFeatureGrpObj->getList('*',array('bm_id'=>$tmp_bm_id), 0, 1);
        if($basicMaterialFeatureGrpInfo){
            $this->pagedata['bind_ftgp_id'] = $basicMaterialFeatureGrpInfo[0]['feature_group_id'];
            $this->pagedata['replacehtml'] = <<<EOF
<div id='hand-selected-product'>已选择了1个类目,<a href='javascript:void(0);' onclick='feature_group_selected_show();'>查看选中的类目.</a></div>
EOF;
        }

        $this->pagedata['material_info'] = $material_info;
        $this->pagedata['readonly'] = $readonly;

        #第三方仓储版_隐藏保质期管理(未安装invoice并且已安装omevirtualwms) ExBOY
        $show_storage_life    = true;
        if(app::get('invoice')->is_installed() == false)
        {
            if(app::get('omevirtualwms')->is_installed())
            {
                $show_storage_life    = false;
            }
        }
        $this->pagedata['show_storage_life']    = $show_storage_life;
        $this->pagedata['brand_info']           = $basicMaterialBrandInfo;

        #获取特殊配置情况
//        $envSpecConf = app::get('ome')->getConf('ome.product.serial.merge');
//        $this->pagedata['envSpecConf'] = $envSpecConf;
//        if($envSpecConf == 'special'){
        $specialConf = $basicMaterialConfObjSpe->dump($tmp_bm_id);
        $this->pagedata['specialConf'] = $specialConf;
//        }

        #获取物料分类
        $goods_type_obj = app::get('ome')->model('goods_type');
        $goods_types = $goods_type_obj->getList('type_id,name', array());
        $this->pagedata['goods_type'] = $goods_types;

        //是否有O2O门店
        $exist_store = $this->getStoreRs();
        $this->pagedata['exist_store']    = $exist_store;

        $this->singlepage('admin/material/basic/edit.html');
    }

    /**
     * 基础物料编辑提交方法
     *
     * @param Int $bm_id
     * @return Boolean
     */
    function toEdit(){
        $this->begin('index.php?app=material&ctl=admin_material_basic&act=index');

        #检查数据有效性
        $checkBasicLib    = kernel::single('material_basic_check');
        $err_msg          = '';
        $_POST['edit']    = true;//编辑标识

        if(!$checkBasicLib->checkParams($_POST, $err_msg)){
            $this->end(false, $err_msg);
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialExtObj = app::get('material')->model('basic_material_ext');
        $basicMaterialFeatureGrpObj = app::get('material')->model('basic_material_feature_group');
        $basicMaterialStockObj = app::get('material')->model('basic_material_stock');
        $basicMaterialConfObjSpe = app::get('material')->model('basic_material_conf_special');
        $basicMaterialConfObj = app::get('material')->model('basic_material_conf');
        $barocdeObj = app::get('material')->model('barcode');

        //更新基础物料基本信息
        $updateData['material_bn'] = $_POST['material_bn'];

        $updateData['material_name'] = $_POST['material_name'];
        $updateData['type'] = $_POST['type'];
        //编辑时唯一码选择否的话 做判断
        if($_POST['serial_number'] == "false"){
            $mdl_p_s = app::get('wms')->model('product_serial');
            $rs_serial_number = $mdl_p_s->dump(array("product_id"=>$_POST['bm_id']));
            if(!empty($rs_serial_number)){
                $this->end(false,"物料已存在唯一码，唯一码项不能选否。");
            }
        }
        $updateData['serial_number'] = $_POST['serial_number'];
        $updateData['visibled'] = $_POST['visibled'];
        $updateData['omnichannel'] = ($_POST['omnichannel'] == 1 ? 1 : 2);
        $updateData['material_spu'] = $_POST['material_spu'];
        
        $filter['bm_id'] = $_POST['bm_id'];

        //快照
        $basicMaterialLib    = kernel::single('material_basic_material');
        $basicMaterialInfo    = $basicMaterialLib->getBasicMaterialExt($filter['bm_id']);

        $specialInfo    = $basicMaterialConfObjSpe->dump(array('bm_id'=>$filter['bm_id']), '*');
        if($specialInfo)
        {
            $basicMaterialInfo    = array_merge($basicMaterialInfo, $specialInfo);
        }

        $confInfo    = $basicMaterialConfObj->dump(array('bm_id'=>$filter['bm_id']), '*');
        if($confInfo)
        {
            unset($confInfo['create_time']);
            $basicMaterialInfo    = array_merge($basicMaterialInfo, $confInfo);
        }

        //更新
        $is_update = $basicMaterialObj->update($updateData,$filter);
        if($is_update){
            //保存保质期配置
            $useExpireConfData = array(
                'bm_id' => $filter['bm_id'],
                'use_expire' => $_POST['use_expire'] == 1 ? 1 : 2,
                'warn_day' => $_POST['warn_day'] ?  $_POST['warn_day'] : 0,
                'quit_day' => $_POST['quit_day'] ? $_POST['quit_day'] : 0,
            );
            $basicMaterialConfObj->save($useExpireConfData);

            $codeData = array(
                'code'  =>  $_POST['material_code'],
            );
            $barocdeObj->update($codeData,$filter);
            //如果关联半成品数据
            if($updateData['type'] == 1){
                $basicMaterialCombinationItemsObj = app::get('material')->model('basic_material_combination_items');
                //删除原有半成品数据
                $basicMaterialCombinationItemsObj->delete(array('pbm_id'=>$filter['bm_id']));
                //新增半成品数据
                if(isset($_POST['at'])){
                    foreach($_POST['at'] as $k=>$v){
                        $tmpChildMaterialInfo = $basicMaterialObj->dump($k, 'material_name,material_bn');

                        $addCombinationData = array(
                            'pbm_id' => $filter['bm_id'],
                            'bm_id' => $k,
                            'material_num' => $v,
                            'material_name' => $tmpChildMaterialInfo['material_name'],
                            'material_bn' => $tmpChildMaterialInfo['material_bn'],
                            'material_bn_crc32' => sprintf('%u',crc32($tmpChildMaterialInfo['material_bn'])),
                        );
                        $basicMaterialCombinationItemsObj->insert($addCombinationData);
                        $addCombinationData = null;
                    }
                }
            }else{
                //如果是半成品的，更新下绑定的名称信息
                $basicMaterialCombinationItemsObj = app::get('material')->model('basic_material_combination_items');
                $basicMaterialCombinationItemsObj->update(array('material_name'=>$updateData['material_name']), $filter);
            }

            //删除原有的关联特性
            $basicMaterialFeatureGrpObj->delete(array('bm_id'=>$filter['bm_id']));
            //保存基础物料的关联的特性
            if($_POST['ftgp_id']){
                $addBindFeatureData = array(
                    'bm_id' => $filter['bm_id'],
                    'feature_group_id' => $_POST['ftgp_id'],
                );
                $basicMaterialFeatureGrpObj->insert($addBindFeatureData);
                $addBindFeatureData = null;
            }

            //保存物料扩展信息
            $updateExtData = array(
                'cost' => $_POST['cost'] ? $_POST['cost'] : 0.00,
                'retail_price' => $_POST['retail_price'] ? $_POST['retail_price'] : 0.00,
                'weight' => $_POST['weight'] ? $_POST['weight'] : 0.00,
                'unit' => $_POST['unit'],
                'specifications' => $_POST['material_specification'],
                'brand_id' => empty($_POST['brand']) ? 0 : $_POST['brand'],
                'cat_id' => empty($_POST['goods_type']) ? 0 : $_POST['goods_type'],
            );
            //判断扩展表是否存在
            $basicextData = $basicMaterialExtObj->dump(array('bm_id'=>$filter['bm_id']),'bm_id');
            if ($basicextData){
                $basicMaterialExtObj->update($updateExtData, $filter);
            }else{
                $updateExtData['bm_id'] = $filter['bm_id'];
                $basicMaterialExtObj->insert($updateExtData);
            }


            //保存扫码配置信息
            $addScanConfInfo = array(
                'openscan' => $_POST['special_setting'] ? $_POST['special_setting']: '',
                'fromposition' => $_POST['first_num'] ? $_POST['first_num'] : '',
                'toposition' => intval($_POST['last_num']) ? intval($_POST['last_num']) : 0,
            );
            $basicMaterialConfObjSpe->update($addScanConfInfo, $filter);
            //更新物料同步信息

            app::get('console')->model('foreign_sku')->update_status($filter['bm_id']);

            //logs
            $log_memo    = serialize($basicMaterialInfo);
            $operationLogObj    = app::get('ome')->model('operation_log');
            $operationLogObj->write_log('basic_material_edit@wms', $filter['bm_id'], $log_memo);

            $this->end(true, '保存成功');
        }else{
            $this->end(false, '保存失败');
        }

    }

    /**
     * 基础物料列表弹窗数据获取方法
     *
     * @param Void
     * @return String
     */
    function findMaterial()
    {
        $this->view_source = 'dialog';

        //只能选择可售的物料
        $base_filter['visibled'] = 1;

        if($_GET['type'] == 2){
            $base_filter['type'] = 2;
        }

        $params = array(
            'title'=>'基础物料列表',
            'use_buildin_new_dialog' => false,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_export'=>false,
            'use_buildin_import'=>false,
            'use_buildin_filter'=>true,
            'base_filter' => $base_filter,
        );
        $this->finder('material_mdl_basic_material', $params);
    }

    /**
     * 基础物料列表弹窗选中物料信息查询方法
     *
     * @param Int $bm_id
     * @return String
     */
    function getMaterial(){
        $bm_id = $_POST['bm_id'];
        $material_bn= $_GET['material_bn'];
        $material_name= $_GET['material_name'];

        if (is_array($bm_id)){
            if ($bm_id[0] == "_ALL_"){
                $filter = '';
            }else {
                $filter['bm_id'] = $bm_id;
            }
        }

        if($material_bn){
            $filter = array(
                'material_bn'=>$material_bn
            );
        }

        if($material_name){
            $filter = array(
                'material_name'=>$material_name
            );
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $filter['use_like'] = 1;
        $data = $basicMaterialObj->getList('bm_id,material_name,material_bn',$filter,0,-1);

        if (!empty($data)){
            $bm_ids = array();
            foreach ($data as $k => $item){
                $bm_id = $item['bm_id'];
                
                $item['num'] = null;
                $item['rate'] = 0;
                
                $rows[] = $item;
                
                $bm_ids[] = $item['bm_id'];
            }
            
            //扩展信息
            $costList = array();
            $basicMaterialExtObj = app::get('material')->model('basic_material_ext');
            $extList = $basicMaterialExtObj->getList('bm_id, cost', array('bm_id'=>$bm_ids));
            foreach ($extList as $key => $val){
                $bm_id = $val['bm_id'];
                
                //成本价
                $costList[$bm_id]['cost'] = $val['cost'];
            }
            
            //显示成本价
            foreach ($rows as $key => $val){
                $bm_id = $val['bm_id'];
                
                $rows[$key]['cost'] = ($costList[$bm_id]['cost'] ? $costList[$bm_id]['cost'] : 0.00);
            }
            
            unset($bm_ids, $data, $costList);
        }

        echo json_encode($rows);
    }

    /**
     * 基础物料组合信息异步加载方法
     *
     * @param Int $bm_id
     * @return String
     */
    function getEditMaterial($bm_id){
        if ($bm_id == ''){
            $bm_id = $_POST['p[0]'];
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialCombinationItemsObj = app::get('material')->model('basic_material_combination_items');

        $rows = array();
        $items = $basicMaterialCombinationItemsObj->getList('bm_id,material_bn,material_name,material_num',array('pbm_id'=>$bm_id),0,-1);

        echo json_encode($items);
    }

    /**
     * 基础物料组合信息异步加载方法
     *
     * @param Int $bm_id
     * @return String
     */
    function batchGenSalesMaterial(){
        $this->_request = kernel::single('base_component_request');
        $material_info = $this->_request->get_post();

        if(!isset($material_info['isSelectedAll']) && empty($material_info['bm_id'])){
            $error_msg = '请选择要生成销售物料的基础物料';
        }else{
            $lastBatchGenSalesMaterial = app::get('material')->getConf('lastBatchGenSalesMaterial'); //上次执行批量生成销售物料的时间
            $getMaterialIntervalTime = 5;

            if(($lastBatchGenSalesMaterial['execTime']+60*$getMaterialIntervalTime)<time()){
                $this->pagedata['is_allow'] = true;
            }else{
                $this->pagedata['is_allow'] = false;
            }
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        if(isset($material_info['isSelectedAll'])){
            unset($material_info['isSelectedAll']);
        }

        $materialList =$basicMaterialObj->getList('bm_id',$material_info, 0, -1);
        /*
        $count = 0;
        $i = 0;
        $materialGroup = array();
        foreach($materialList as $k => $material){
            if($count == 10){
                $count = 0;
                $i++;
            }

            $materialGroup[$i]['materials'] .= $material['bm_id'].",";

            $count++;
        }
        */

        $this->pagedata['materialCnt'] = count($materialList);
        $this->pagedata['materialGroup'] = json_encode($materialList);

        $this->pagedata['bm_id'] = serialize($material_info['bm_id']);

        $this->pagedata['lastBatchGenSalesMaterial'] = !empty($lastBatchGenSalesMaterial['execTime']) ? date('Y-m-d H:i:s',$lastBatchGenSalesMaterial['execTime']) : '';
        $this->pagedata['getMaterialIntervalTime'] = $getMaterialIntervalTime;
        $this->pagedata['currentTime'] = time();

        $this->display('admin/material/basic/gensalesmaterial.html');
    }

    function dobatchGen(){
        //传入的物料格式 id1,id2,id3,一次10个,页面js变量控制
        $params = $_POST['ajaxParams'];
        if (empty($params)) {
            echo $this->_ajaxRespone();
            exit;
        }

        /* 执行时间判断 start */
        $pageBn = intval($_POST['pageBn']);
        $lastBatchGenSalesMaterial = app::get('material')->getConf('lastBatchGenSalesMaterial'); //上次获取订单信息(key为execTime表示执行时间，key为pageBn表示页面编号),
        $getMaterialIntervalTime = 5;

        if($pageBn !=$lastBatchGenSalesMaterial['pageBn'] && ($lastBatchGenSalesMaterial['execTime']+60*$getMaterialIntervalTime)>time()){
            echo $this->_ajaxRespone();
            exit;
        }
        if($pageBn !=$lastBatchGenSalesMaterial['pageBn'] && $pageBn<$lastBatchGenSalesMaterial['execTime']){
            echo $this->_ajaxRespone();
            exit;
        }

        //记录本次获取订单时间
        $currentGetOrder = array(
            'execTime'=>time(),
            'pageBn'=>$pageBn,
        );
        app::get('material')->setConf('lastBatchGenSalesMaterial',$currentGetOrder);
        /* 执行时间判断 end */

        //基础物料转成销售处理
        $result = kernel::single('material_basic_exchange')->process($params);
        echo $this->_ajaxRespone($result);
    }

    /**
     *  对输入的内容进行格式化输出至AJAX
     *
     * @author hzjsq (2011/3/24)
     * @param Mixed $param 要转换的内容
     * @return String
     */
    private function _ajaxRespone($param) {

        if (empty($param)) {

            return json_encode(array('total' => 0, 'succ' => 0, 'fail' => 0));
        } else {

            return json_encode($param);
        }
    }

    /**
     * @description 显示关联的物料
     * @access public
     * @param void
     * @return void
     */
    public function showMaterialBase()
    {
        $bm_id = kernel::single('base_component_request')->get_post('bm_id');

        if ($bm_id)
        {
            #前端店铺_规则应用传值 ExBOY
            if(!is_array($bm_id))
            {
                $bm_id    = explode(',', $bm_id);
            }

            $this->pagedata['_input'] = array(
                'name' => 'bm_id',
                'idcol' => 'bm_id',
                '_textcol' => 'material_name',
            );

            $basicMaterialObj = app::get('material')->model('basic_material');
            $list = $basicMaterialObj->getList('bm_id,material_name', array('bm_id'=>$bm_id, 'visibled'=>1),0,-1,'bm_id asc');
            $this->pagedata['_input']['items'] = $list;
        }

        $this->display('admin/material/basic/show_material_base.html');
    }

    /**
     * @description 显示绑定的特性
     * @access public
     * @param void
     * @return void
     */
    public function showFeatureGrp()
    {
        $ftgp_id = kernel::single('base_component_request')->get_post('ftgp_id');

        if ($ftgp_id)
        {
            $this->pagedata['_input'] = array(
                'name' => 'ftgp_id',
                'idcol' => 'ftgp_id',
                '_textcol' => 'ftgp_name',
            );

            /*
            $featureGrpObj = app::get('flowctrl')->model('feature_group');
            $list = $featureGrpObj->getList('ftgp_id,ftgp_name', array('ftgp_id'=>$ftgp_id),0,-1,'ftgp_id asc');
            $this->pagedata['_input']['items'] = $list;
            */
        }

        $this->display('admin/material/basic/show_feature_group.html');
    }

    /**
     * @description 批量设置保质期配置的页面
     * @access public
     * @param void
     * @return void
     */
    public function BatchUpExpire($view){

        $sub_menu = $this->_views();
        foreach ($sub_menu as $key => $value) {
            if($key == $view){
                $base_filter = $value['filter'];
            }
        }

        $filter = array_merge((array)$_POST,(array)$base_filter);
        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialObj->filter_use_like = true;
        $count = $basicMaterialObj->count($filter);

        $this->pagedata['total'] = $count;
        $this->pagedata['filter'] = http_build_query($filter);
        $this->display('admin/material/basic/batch_update_expire.html');
    }

    /**
     * @description 设置保质期
     * @access public
     * @param array $_POST
     * @return void
     */
    function doBatchUpExpire(){

        $checkBasicLib    = kernel::single('material_basic_check');

        $page_no = intval($_GET['page_no']) ? intval($_GET['page_no']) : 1;
        $page_size = 10;
        $offset = ($page_no-1)*$page_size;
        $total = intval($_GET['total']);
        parse_str($_POST['filter'],$filter);

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialObj->filter_use_like = true;
        $materialList = $basicMaterialObj->getList('*',$filter,$offset,$page_size);
        $succ_num = $fail_num = 0;
        if ($materialList) {
            foreach ((array) $materialList as $material_info) {

                #如果有批次明细 或者 采购明细 就不能变更保质期的开关
                $readonly    = $checkBasicLib->checkEditReadOnly($material_info['bm_id']);
                if($readonly['use_expire'])
                {
                    $fail_num++;
                }
                else
                {
                    $arr_bm_id[] = $material_info['bm_id'];
                }
            }
            $succ_num = count($materialList)-$fail_num;

            if($arr_bm_id){
                //如果有批次明细就不能变更保质期的开关
                /**
                $basicMaterialStorageLifeObj = app::get('material')->model('basic_material_storage_life');
                $expireItemsInfo = $basicMaterialStorageLifeObj->getList('distinct bm_id',array('bm_id'=>$arr_bm_id));
                if($expireItemsInfo){
                    foreach($expireItemsInfo as $expireItem){
                        $flag = array_search($expireItem['bm_id'], $arr_bm_id);
                        if($flag >=0){
                            unset($arr_bm_id[$flag]);
                            $fail_num++;
                        }
                    }
                    $succ_num = count($materialList)-$fail_num;
                }else{
                    $succ_num = count($materialList);
                }
                */

                $basicMaterialConfObj = app::get('material')->model('basic_material_conf');
                $updateData = array(
                    'use_expire' => $_POST['use_expire'] == 1 ? 1 : 2,
                    'warn_day' => $_POST['warn_day'] ? $_POST['warn_day'] : 0,
                    'quit_day' => $_POST['quit_day'] ? $_POST['quit_day'] : 0,
                );
                $basicMaterialConfObj->update($updateData, array('bm_id'=>$arr_bm_id));
            }
        }

        $result = array('status'=>'running','data'=>array('succ_num'=>$succ_num,'fail_num'=>$fail_num));

        if ( ($page_size * $page_no) >= $total) {
            $result['status'] = 'complete';
            $result['data']['rate'] = '100';
        } else {
            $result['data']['rate'] =  $page_no * $page_size / $total * 100;
        }

        echo json_encode($result);exit;
    }

    /**
     * 批量设置全渠道页面
     */
    public function batchUpOmnichannel($view)
    {
        $sub_menu    = $this->_views();
        foreach ($sub_menu as $key => $value) {
            if($key == $view){
                $base_filter    = $value['filter'];
            }
        }

        $base_filter    = array('omnichannel'=> $base_filter['omnichannel']);
        $filter         = array_merge((array)$_POST, (array)$base_filter);

        $basicMaterialObj    = app::get('material')->model('basic_material');
        $basicMaterialObj->filter_use_like = true;

        $count    = $basicMaterialObj->count($filter);

        $this->pagedata['total'] = $count;
        $this->pagedata['filter'] = http_build_query($filter);

        $this->display('admin/material/basic/batch_set_omnichannel.html');
    }

    /**
     * 批量设置全渠道
     */
    function doBatchUpOmnichannel()
    {
        $page_no    = intval($_GET['page_no']) ? intval($_GET['page_no']) : 1;
        $page_size  = 10;
        $offset     = ($page_no-1) * $page_size;
        $total      = intval($_GET['total']);

        parse_str($_POST['filter'], $filter);

        $omnichannel    = ($_POST['omnichannel'] == 1 ? 1 : 2);

        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialObj->filter_use_like = true;
        $materialList = $basicMaterialObj->getList('bm_id, omnichannel', $filter, $offset, $page_size);
        $succ_num = $fail_num = 0;

        if ($materialList)
        {
            foreach ($materialList as $material_info)
            {
                $arr_bm_id[]    = $material_info['bm_id'];

                $succ_num++;
            }

            if($arr_bm_id)
            {
                $basicMaterialObj->update(array('omnichannel'=>$omnichannel), array('bm_id'=>$arr_bm_id));
            }
        }

        $fail_num  = count($materialList) - $succ_num;
        $result    = array('status'=>'running','data'=>array('succ_num'=>$succ_num, 'fail_num'=>$fail_num));

        if ( ($page_size * $page_no) >= $total)
        {
            $result['status']        = 'complete';
            $result['data']['rate']  = '100';
        } else {
            $result['data']['rate']  =  $page_no * $page_size / $total * 100;
        }

        echo json_encode($result);
        exit;
    }

    //判断O2O门店是否存在
    function getStoreRs()
    {
        //是否有O2O门店
        $storeObj    = app::get('o2o')->model('store');
        $storeInfo   = $storeObj->getList('store_id', array(), 0, 1);
        if($storeInfo)
        {
            return true;
        }

        return false;
    }

    /**
     * 查看快照
     */
    function show_history($log_id){
        $goodsTypeObj = app::get('ome')->model('goods_type');
        $brandObj     = app::get('ome')->model('brand');
        $logObj = app::get('ome')->model('operation_log');

        //日志
        $goodslog = $logObj->dump($log_id,'memo');
        $memo = unserialize($goodslog['memo']);

        //类型
        if($memo['cat_id'])
        {
            $typeInfo    = $goodsTypeObj->dump(array('type_id'=>$memo['cat_id']), 'type_id,name');
            $memo['type_name']    = $typeInfo['name'];
        }

        //品牌
        if($memo['brand_id'])
        {
            $brandInfo    = $brandObj->dump(array('brand_id'=>$memo['brand_id']), 'brand_id,brand_name');
            $memo['brand_name']    = $brandInfo['brand_name'];
        }

        //是否在售
        $memo['serial_number']    = ($memo['serial_number'] == 'true' ? '是' : '否');

        //是否在售
        $memo['is_sales']    = ($memo['visibled'] == 1 ? '在售' : '停售');

        //物料属性
        $memo['is_type']    = ($memo['type'] == 1 ? '成品' : '半成品');

        //是否全渠道
        $memo['is_channel']    = ($memo['omnichannel'] == 1 ? '是' : '否');

        //特殊扫码配置
        if($memo['openscan'] == 3)
        {
            $memo['openscan']    = '扫码中识别整个条码中第 '.$memo['fromposition'].' 位到第 '.$memo['toposition'].'位';
        }
        else
        {
            $memo['openscan']    = '';
        }

        //保质期
        if($memo['use_expire'] == 1)
        {
            $memo['show_storage_life']    = true;
            $memo['warn_day']    = $memo['warn_day'];
            $memo['quit_day']    = $memo['quit_day'];
        }

        $this->pagedata['data'] = $memo;

        $this->singlepage('admin/material/basic/history_log.html');
    }
    
    //批量停售
    function batchInvisible($view){
        $this->begin('');
        $view = intval($view);
        $sub_menu = $this->_views();
        foreach ($sub_menu as $key => $value) {
            if($key == $view){
                $base_filter = $value['filter'];
            }
        }
        $mdl_ma_ba_ma = app::get('material')->model('basic_material');
        $offset = 0;
        $limit = 100;
        $bm_ids = array();
        if(!$base_filter && isset($_POST["isSelectedAll"]) && $_POST["isSelectedAll"] == "_ALL_"){ //“全部”tab 全选的
            do{
                $rs = $mdl_ma_ba_ma->getList("bm_id",array("visibled"=>"1"),$offset,$limit,"bm_id asc");
                if(empty($rs)){
                    break;
                }
                $current_bm_ids = array();
                foreach($rs as $var_r){
                    $current_bm_ids[] = $var_r["bm_id"];
                }
                $bm_ids[] = $current_bm_ids;
                $offset = $offset + $limit;
            }while(!empty($rs));
        }elseif(isset($_POST["isSelectedAll"]) && $_POST["isSelectedAll"] == "_ALL_"){ //其余的tab 全选的
            $filter_arr = $base_filter;
            unset($filter_arr["bm_id"]);
            $filter_arr = array_merge(array("visibled"=>"1"),$filter_arr);
            do{
                $rs = $mdl_ma_ba_ma->getList("bm_id",$filter_arr,$offset,$limit,"bm_id asc");
                if(empty($rs)){
                    break;
                }
                $current_bm_ids = array();
                foreach($rs as $var_r){
                    $current_bm_ids[] = $var_r["bm_id"];
                }
                $bm_ids[] = $current_bm_ids;
                $offset = $offset + $limit;
            }while(!empty($rs));
        }else{ //勾选的
            $bm_ids = array_chunk($_POST["bm_id"],$limit);
        }
        if(empty($bm_ids)){
            $this->end(false, '无有效数据');
        }
        $update_arr = array("visibled"=>2);
        foreach($bm_ids as $var_bm_id){
            $filter_arr = array("bm_id"=>$var_bm_id);
            $mdl_ma_ba_ma->update($update_arr,$filter_arr);
        }
        $this->end(true, '操作成功');
    }
    
    //批量在售
    function batchVisible($view){
        $this->begin('');
        $view = intval($view);
        $sub_menu = $this->_views();
        foreach ($sub_menu as $key => $value) {
            if($key == $view){
                $base_filter = $value['filter'];
            }
        }
        $mdl_ma_ba_ma = app::get('material')->model('basic_material');
        $offset = 0;
        $limit = 100;
        $bm_ids = array();
        if(!$base_filter && isset($_POST["isSelectedAll"]) && $_POST["isSelectedAll"] == "_ALL_"){ //“全部”tab 全选的
            do{
                $rs = $mdl_ma_ba_ma->getList("bm_id",array("visibled"=>"2"),$offset,$limit,"bm_id asc");
                if(empty($rs)){
                    break;
                }
                $current_bm_ids = array();
                foreach($rs as $var_r){
                    $current_bm_ids[] = $var_r["bm_id"];
                }
                $bm_ids[] = $current_bm_ids;
                $offset = $offset + $limit;
            }while(!empty($rs));
        }elseif(isset($_POST["isSelectedAll"]) && $_POST["isSelectedAll"] == "_ALL_"){ //其余的tab 全选的
            $filter_arr = $base_filter;
            unset($filter_arr["bm_id"]);
            $filter_arr = array_merge(array("visibled"=>"2"),$filter_arr);
            do{
                $rs = $mdl_ma_ba_ma->getList("bm_id",$filter_arr,$offset,$limit,"bm_id asc");
                if(empty($rs)){
                    break;
                }
                $current_bm_ids = array();
                foreach($rs as $var_r){
                    $current_bm_ids[] = $var_r["bm_id"];
                }
                $bm_ids[] = $current_bm_ids;
                $offset = $offset + $limit;
            }while(!empty($rs));
        }else{ //勾选的
            $bm_ids = array_chunk($_POST["bm_id"],$limit);
        }
        if(empty($bm_ids)){
            $this->end(false, '无有效数据');
        }
        $update_arr = array("visibled"=>1);
        foreach($bm_ids as $var_bm_id){
            $filter_arr = array("bm_id"=>$var_bm_id);
            $mdl_ma_ba_ma->update($update_arr,$filter_arr);
        }
        $this->end(true, '操作成功');
    }
    
}
