<?php
/**
 * 销售物料控制层
 *
 * @author kamisama.xia@gmail.com
 * @version 0.1
 */

class material_ctl_admin_material_sales extends desktop_controller{

    var $workground = 'goods_manager';

    /**
     * 销售物料列表分栏菜单
     *
     * @param Null
     * @return Array
     */
    function _views(){

        #不是销售列表时_隐藏Tab
        if($_GET['act'] != 'index')
        {
            return '';
        }

        $salesMaterialObj = app::get('material')->model('sales_material');

        $sub_menu = array(
            0 => array('label'=>app::get('base')->_('全部'),'optional'=>false),
            1 => array('label'=>app::get('base')->_('普通'),'filter'=>array('sales_material_type'=>1),'optional'=>false),
            2 => array('label'=>app::get('base')->_('促销'),'filter'=>array('sales_material_type'=>2),'optional'=>false),
            3 => array('label'=>app::get('base')->_('赠品'),'filter'=>array('sales_material_type'=>3),'optional'=>false),
            4 => array('label'=>app::get('base')->_('福袋'),'filter'=>array('sales_material_type'=>4),'optional'=>false),
            5 => array('label'=>app::get('base')->_('多选一'),'filter'=>array('sales_material_type'=>5),'optional'=>false),
        );

        foreach($sub_menu as $k=>$v){
            $sub_menu[$k]['filter'] = $v['filter']?$v['filter']:null;
            $sub_menu[$k]['addon'] = $salesMaterialObj->count($v['filter']);
            $sub_menu[$k]['href'] = 'index.php?app=material&ctl=admin_material_sales&act=index&view='.$k;
        }

        return $sub_menu;
    }

    /**
     * 销售物料列表项方法
     *
     * @param Post
     * @return String
     */
    function index(){

        $params = array(
            'title'=>'销售物料',
            'actions' => array(
                    array(
                        'label' => '新建',
                        'href' => 'index.php?app=material&ctl=admin_material_sales&act=add',
                        'target' => '_blank',
                    ),
                    array(
                            'label' => '导出模板',
                            'href' => 'index.php?app=material&ctl=admin_material_sales&act=exportTemplate',
                            'target' => '_blank',
                    ),
            ),
            'base_filter' => $base_filter,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_filter'=>true,
            'use_buildin_export'=>true,
            'use_buildin_import'=>true,
        );

         $this->finder('material_mdl_sales_material',$params);
    }

    /**
     * @description 显示可售基础物料列表查询方法
     * @access public
     * @param void
     * @return void
     */
    function finder_common(){
        $params = array(
            'title'=>app::get('desktop')->_('基础物料列表'),
            'use_buildin_new_dialog' => false,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_export'=>false,
            'use_buildin_import'=>false,
            'use_buildin_filter'=>true,
            'use_buildin_setcol'=>true,
            'use_buildin_refresh'=>true,
            'finder_aliasname'=>'finder_common',
            'alertpage_finder'=>true,
            'use_buildin_tagedit'=>false,
        );

        $this->finder($_GET['app_id'].'_mdl_'.$_GET['object'],$params);
    }

    /**
     * @description 显示关联的物料
     * @access public
     * @param void
     * @return void
     */
    public function showMaterials()
    {
        $bm_id = kernel::single('base_component_request')->get_post('bm_id');

        if ($bm_id) {
            $this->pagedata['_input'] = array(
                'name' => 'bm_id',
                'idcol' => 'bm_id',
                '_textcol' => 'material_name',
            );

            $basicMaterialObj = app::get('material')->model('basic_material');
            $list = $basicMaterialObj->getList('bm_id,material_name, material_bn',array('bm_id'=>$bm_id),0,-1,'bm_id asc');

            //显示基础物料编码
            foreach ($list as $key => $val)
            {
                $list[$key]['material_name']    = '货号：'.$val['material_bn'] .'&nbsp;&nbsp;&nbsp;名称：'. $val['material_name'];
            }

            $this->pagedata['_input']['items'] = $list;
        }

        $this->display('admin/material/sales/show_materials.html');
    }

    /**
     * 销售物料新增的展示页面方法
     *
     * @param void
     * @return void
     */
    function add(){
        #过滤o2o门店店铺
        $shopObj = app::get('ome')->model('shop');
        $shopList = $shopObj->getList('shop_id,name', array('s_type'=>1), 0, -1);
        array_unshift($shopList,array('shop_id'=>'_ALL_','name'=>'全部店铺'));
        $this->pagedata['shops'] = $shopList;
        $this->singlepage('admin/material/sales/add.html');
    }

    /**
     * 基础物料新增提交方法
     *
     * @param Post
     * @return Boolean
     */
    function toAdd(){
        $this->begin('index.php?app=material&ctl=admin_material_sales&act=index');

        #数据有效性检查
        $checkSalesLib    = kernel::single('material_sales_check');
        $err_msg          = '';

        if(!$checkSalesLib->checkParams($_POST, $err_msg)){
            $this->end(false, $err_msg);
        }

        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        $salesMaterialShopFreezeObj = app::get('material')->model('sales_material_shop_freeze');

        //保存物料主表信息
        $addData = array(
            'sales_material_name' => $_POST['sales_material_name'],
            'sales_material_bn' => $_POST['sales_material_bn'],
            'sales_material_bn_crc32' => $_POST['sales_material_bn_crc32'],
            'sales_material_type' => $_POST['sales_material_type'],
            'shop_id' => $_POST['shop_id'],
            'create_time' => time(),
        );
        $is_save = $salesMaterialObj->save($addData);

        if($is_save){
            $is_bind = false;
            //如果有关联物料就做绑定操作
            $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
            //普通销售物料关联
            if(($_POST['sales_material_type'] == 1 || $_POST['sales_material_type'] == 3) && !empty($_POST['bm_id'])){
                $addBindData = array(
                        'sm_id' => $addData['sm_id'],
                        'bm_id' => $_POST['bm_id'],
                        'number' => 1,
                );
                $salesBasicMaterialObj->insert($addBindData);

                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 2 && !empty($_POST['at'])){
            //促销销售物料关联
                foreach($_POST['at'] as $k=>$v){
                    $addBindData = array(
                        'sm_id' => $addData['sm_id'],
                        'bm_id' => $k,
                        'number' => $v,
                        'rate' => $_POST['pr'][$k],
                    );
                    $salesBasicMaterialObj->insert($addBindData);
                    $addBindData = null;
                }

                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 4 && !empty($_POST['lbr'])){
                $mdl_material_luckbag_rules = app::get('material')->model('luckybag_rules');
                foreach($_POST['lbr'] as $var_lbr){
                    $addBindData = array(
                        "lbr_name" => $var_lbr["name"],
                        "sm_id" => $addData['sm_id'],
                        "bm_ids" => implode(",", $var_lbr["bm_ids"]),
                        "sku_num" => $var_lbr["sku_num"],
                        "send_num" => $var_lbr["send_num"],
                        "price" => $var_lbr["single_price"],
                    );
                    $mdl_material_luckbag_rules->insert($addBindData);
                }
                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 5 && !empty($_POST['sort'])){ //多选一
                $mdl_ma_pickone_ru = app::get('material')->model('pickone_rules');
                $select_type = $_POST["pickone_select_type"] ? $_POST["pickone_select_type"] : 1; //默认“随机”
                foreach($_POST['sort'] as $key_bm_id => $val_sort){
                    $current_insert_arr = array(
                        "sm_id" => $addData['sm_id'],
                        "bm_id" => $key_bm_id,
                        "sort" => $val_sort ? $val_sort: 0,
                        "select_type" => $select_type,
                    );
                    $mdl_ma_pickone_ru->insert($current_insert_arr);
                }
                $is_bind = true;
            }

            //如果有绑定物料数据，设定销售物料为绑定状态
            if($is_bind){
                $salesMaterialObj->update(array('is_bind'=>1),array('sm_id'=>$addData['sm_id']));
            }

            //保存销售物料扩展信息
            $addExtData = array(
                'sm_id' => $addData['sm_id'],
                'cost' => $_POST['cost'] ? $_POST['cost'] : 0.00,
                'retail_price' => $_POST['retail_price'] ? $_POST['retail_price'] : 0.00,
                'weight' => $_POST['weight'] ? $_POST['weight'] : 0.00,
                'unit' => $_POST['unit'],
            );
            $salesMaterialExtObj->insert($addExtData);

            //保存销售物料店铺级冻结
            if($_POST['shop_id'] != '_ALL_'){
                $addStockData = array(
                    'sm_id' => $addData['sm_id'],
                    'shop_id' => $_POST['shop_id'],
                    'shop_freeze' => 0,
                );
                $salesMaterialShopFreezeObj->insert($addStockData);
            }

            //logs
            $operationLogObj    = app::get('ome')->model('operation_log');
            $operationLogObj->write_log('sales_material_add@wms', $addData['sm_id'], '销售物料添加');

            $this->end(true, '操作成功');
        }else{
            $this->end(false, '保存失败');
        }

    }

    /**
     * 销售物料编辑的展示页面方法
     *
     * @param Int $bm_id
     * @return Boolean
     */
    function edit($sm_id){
        $this->begin('index.php?app=material&ctl=admin_material_sales&act=index');
        if (empty($sm_id)){
            $this->end(false,'操作出错，请重新操作');
        }

        $salesMaterialObj = app::get('material')->model('sales_material');

        $tmp_sm_id = intval($sm_id);
        $salesMaterialInfo = $salesMaterialObj->dump($tmp_sm_id);
        if(!$salesMaterialInfo){
            $this->end(false,'操作出错，请重新操作');
        }

        //检查物料是否有关联的订单,关联的基础物料不能改变
        //todo 需实现 readonly
        $checkSalesLib    = kernel::single('material_sales_check');
        $readonly        = $checkSalesLib->checkEditReadOnly($salesMaterialInfo['shop_id'], $tmp_sm_id, $salesMaterialInfo['is_bind']);

        //读取合并销售物料的扩展信息
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        $salesMaterialExtInfo = $salesMaterialExtObj->dump($tmp_sm_id);
        if($salesMaterialExtInfo){
            $salesMaterialInfo = array_merge($salesMaterialInfo,$salesMaterialExtInfo);
        }

        if(($salesMaterialInfo['sales_material_type'] == 1 || $salesMaterialInfo['sales_material_type'] == 3) && $salesMaterialInfo['is_bind'] == 1){
            $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
            $salesBasicMaterialInfo = $salesBasicMaterialObj->dump(array('sm_id'=>$tmp_sm_id));
            $count = count($salesBasicMaterialInfo['bm_id']);
            $this->pagedata['bind_bm_id'] = $salesBasicMaterialInfo['bm_id'];
            $this->pagedata['replacehtml'] = <<<EOF
<div id='hand-selected-product'>已选择了{$count}个物料,<a href='javascript:void(0);' onclick='material_selected_show();'>查看关联的物料.</a></div>
EOF;
        }

        $lib_ma_sa_ma = kernel::single('material_sales_material');
        //福袋类型获取数据
        $this->pagedata["lb_rule_current_part_number"] = 1;
        if($salesMaterialInfo['sales_material_type'] == 4 && $salesMaterialInfo['is_bind'] == 1){
            $this->pagedata["luckybag_rules_list"] = $lib_ma_sa_ma->get_luckybag_by_sm_id($tmp_sm_id);
            $luckybag_rules_list_end = end($this->pagedata["luckybag_rules_list"]);
            $this->pagedata["lb_rule_current_part_number"] = $luckybag_rules_list_end["load_part_number"] + 1;
        }
        
        //多选一类型获取数据
        if($salesMaterialInfo['sales_material_type'] == 5 && $salesMaterialInfo['is_bind'] == 1){
            $rs_pickone = $lib_ma_sa_ma->get_pickone_by_sm_id($tmp_sm_id);
            $this->pagedata["pickone_select_type"] = $rs_pickone[0]["select_type"];
        }
        
        //店铺信息(过滤o2o门店店铺)
        $shopObj = app::get('ome')->model('shop');
        $shopList = $shopObj->getList('shop_id,name', array('s_type'=>1), 0, -1);
        array_unshift($shopList,array('shop_id'=>'_ALL_','name'=>'全部店铺'));
        $this->pagedata['shops'] = $shopList;

        $this->pagedata['material_info'] = $salesMaterialInfo;
        $this->pagedata['readonly'] = $readonly;
        $this->singlepage('admin/material/sales/edit.html');
    }

    /**
     * 销售物料编辑提交方法
     *
     * @param Int $sm_id
     * @return Boolean
     */
    function toEdit(){
        $this->begin('index.php?app=material&ctl=admin_material_sales&act=index');
        #数据有效性检查
        $checkSalesLib = kernel::single('material_sales_check');
        $err_msg = '';
        $_POST['edit'] = true; //编辑标识 checkParams用
        if(!$checkSalesLib->checkParams($_POST, $err_msg)){
            $this->end(false, $err_msg);
        }
        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        //更新基础物料基本信息
        $filter['sm_id'] = $_POST['sm_id'];
        //快照
        $salesMaterialInfo = $salesMaterialObj->dump(array('sm_id'=>$filter['sm_id']), '*');
        $salesExtInfo = $salesMaterialExtObj->dump(array('sm_id'=>$filter['sm_id']), '*');
        if($salesExtInfo){
            $salesMaterialInfo = array_merge($salesMaterialInfo, $salesExtInfo); //原始销售物料基础和扩展数据
        }
        $lib_ma_sa_ma = kernel::single('material_sales_material');
        if($salesMaterialInfo["sales_material_type"] == "4"){ //原销售物料类型是福袋
            $salesMaterialInfo["luckybag_rules_list"] = $lib_ma_sa_ma->get_luckybag_by_sm_id($filter['sm_id']);
        }elseif($salesMaterialInfo["sales_material_type"] == "5"){ //原销售物料类型是多选一
            $salesMaterialInfo["pickone_rules_list"] = $lib_ma_sa_ma->get_pickone_by_sm_id($filter['sm_id']);
        }else{
            $bmInfoList = $lib_ma_sa_ma->getBasicMBySalesMId($filter['sm_id']);
            if($bmInfoList){
                $salesMaterialInfo['bm_list'] = $bmInfoList;
            }
        }
        //更新销售物料基本信息
        $updateData = array(
            "sales_material_name" => $_POST['sales_material_name'],
            "sales_material_type" => $_POST['sales_material_type'],
            "shop_id" => $_POST['shop_id'],
            "last_modified" => time(),
        );
        //更新
        $is_update = $salesMaterialObj->update($updateData,$filter);
        if($is_update){
            $is_bind = false; //如果有关联物料就做绑定操作
            $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
            $mdl_ma_lu_ru = app::get('material')->model('luckybag_rules');
            $mdl_ma_pickone_ru = app::get('material')->model('pickone_rules');
            //删除原有关联基础物料信息  后续会新增的（重做关系）
            $salesBasicMaterialObj->delete(array('sm_id'=>$filter['sm_id'])); //普通、赠品、促销
            $mdl_ma_pickone_ru->delete(array("sm_id"=>$filter['sm_id'])); //多选一
            if($_POST['sales_material_type'] != 4){
                //目前如果编辑提交时sales_material_type不是4福袋 删除原有的福袋数据（后续也有update、insert、delete逻辑）
                $rs_old_luckybag = $mdl_ma_lu_ru->dump(array("sm_id"=>$filter['sm_id']));
                if(!empty($rs_old_luckybag)){ //有旧的福袋数据删除sm_id对应的所有lbr数据
                    $mdl_ma_lu_ru->delete(array("sm_id"=>$filter['sm_id']));
                }
            }
            //普通销售物料关联
            if(($_POST['sales_material_type'] == 1 || $_POST['sales_material_type'] == 3) && !empty($_POST['bm_id'])){ //普通、赠品销售物料关联
                $addBindData = array(
                        'sm_id' => $filter['sm_id'],
                        'bm_id' => $_POST['bm_id'],
                        'number' => 1,
                );
                $salesBasicMaterialObj->insert($addBindData);
                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 2 && !empty($_POST['at'])){ //促销销售物料关联
            //促销销售物料关联
                foreach($_POST['at'] as $k=>$v){
                    $addBindData = array(
                        'sm_id' => $filter['sm_id'],
                        'bm_id' => $k,
                        'number' => $v,
                        'rate' => $_POST['pr'][$k],
                    );
                    $salesBasicMaterialObj->insert($addBindData);
                    $addBindData = null;
                }
                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 4 && !empty($_POST['lbr'])){ //福袋数据更新
                if($_POST["can_edit_luckybag_rules"] == "yes"){ //福袋数据可编辑
                    //判断处理删除部分
                    $edit_lbr_ids = array();
                    foreach($_POST['lbr'] as $var_lbr_id){
                        if($var_lbr_id["edit_lbr_id"]){
                            $edit_lbr_ids[] = $var_lbr_id["edit_lbr_id"];
                        }
                    } 
                    $rs_ma_lu_ru = $mdl_ma_lu_ru->getList("lbr_id",array("sm_id"=>$filter['sm_id']));
                    foreach($rs_ma_lu_ru as $var_mlr){
                        if(!in_array($var_mlr["lbr_id"],$edit_lbr_ids)){
                            $mdl_ma_lu_ru->delete(array("lbr_id"=>$var_mlr["lbr_id"]));
                        }
                    }
                    //处理新增和更新
                    foreach($_POST['lbr'] as $var_lbr){
                        $addBindData = array(
                                "lbr_name" => $var_lbr["name"],
                                "sm_id" => $filter['sm_id'],
                                "bm_ids" => implode(",", $var_lbr["bm_ids"]),
                                "sku_num" => $var_lbr["sku_num"],
                                "send_num" => $var_lbr["send_num"],
                                "price" => $var_lbr["single_price"],
                        );
                        if($var_lbr["edit_lbr_id"]){ //原有更新
                            $mdl_ma_lu_ru->update($addBindData,array("lbr_id"=>$var_lbr["edit_lbr_id"]));
                            $did_lbr_ids[] = $var_lbr["edit_lbr_id"];
                        }else{ //新增
                            $mdl_ma_lu_ru->insert($addBindData);
                        }
                    }
                }                
                $is_bind = true;
            }elseif($_POST['sales_material_type'] == 5 && !empty($_POST['sort'])){ //多选一
                $select_type = $_POST["pickone_select_type"] ? $_POST["pickone_select_type"] : 1; //默认“随机”
                foreach($_POST['sort'] as $key_bm_id => $val_sort){
                    $current_insert_arr = array(
                        "sm_id" => $filter['sm_id'],
                        "bm_id" => $key_bm_id,
                        "sort" => $val_sort ? $val_sort: 0,
                        "select_type" => $select_type,
                    );
                    $mdl_ma_pickone_ru->insert($current_insert_arr);
                }
                $is_bind = true;
            }

            //如果有绑定物料数据，设定销售物料为绑定状态
            if($is_bind){
                $salesMaterialObj->update(array('is_bind'=>1),array('sm_id'=>$filter['sm_id']));
            }else{
                $salesMaterialObj->update(array('is_bind'=>2),array('sm_id'=>$filter['sm_id']));
            }

            //更新销售物料扩展信息
            $updateExtData = array(
                'cost' => $_POST['cost'] ? $_POST['cost'] : 0.00,
                'retail_price' => $_POST['retail_price'] ? $_POST['retail_price'] : 0.00,
                'weight' => $_POST['weight'] ? $_POST['weight'] : 0.00,
                'unit' => $_POST['unit'],
            );
            $salesextData = $salesMaterialExtObj->dump(array('sm_id'=>$filter['sm_id']),'sm_id');
            if ($salesextData){
                $salesMaterialExtObj->update($updateExtData, $filter);
            }else{
                $updateExtData['sm_id'] = $filter['sm_id'];
                $salesMaterialExtObj->insert($updateExtData);
            }

            //保存日志 压入原始销售物料信息 供快照查看
            $log_memo = serialize($salesMaterialInfo);
            $operationLogObj = app::get('ome')->model('operation_log');
            $operationLogObj->write_log('sales_material_edit@wms', $filter['sm_id'], $log_memo);
            $this->end(true, '保存成功');
        }else{
            $this->end(false, '保存失败');
        }

    }

    /**
     * 促销类销售物料关联的基础物料信息异步加载方法
     * 还包括多选一类型的销售物料
     * @param Int $sm_id
     * @return String
     */
    function getEditMaterial($sm_id){
        if ($sm_id == ''){
            $sm_id = $_POST['p[0]'];
        }

        $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
        $basicMaterialObj = app::get('material')->model('basic_material');
        $basicMaterialExtObj = app::get('material')->model('basic_material_ext');

        $rows = array();
        $items = $salesBasicMaterialObj->getList('bm_id,sm_id,number,rate',array('sm_id'=>$sm_id),0,-1);
        if(!empty($items)){
            foreach($items as $k => $item){
                $basicMaterialInfo = $basicMaterialObj->dump(array('bm_id'=>$item['bm_id']),'material_bn,material_name');
                
                //成本价
                $extInfo = $basicMaterialExtObj->dump(array('bm_id'=>$item['bm_id']), 'bm_id, cost');
                $item['cost'] = $extInfo['cost'];
                
                $items[$k] = array_merge($item,$basicMaterialInfo);
            }
            $rows["original"] = $items; //普通、赠品、促销
        }
        //多选一
        $mdl_ma_pickone_ru = app::get('material')->model('pickone_rules');
        $pickone_items = $mdl_ma_pickone_ru->getList('bm_id,sm_id,sort,select_type',array('sm_id'=>$sm_id),0,-1);
        if(!empty($pickone_items)){
            foreach($pickone_items as $k => $pickone_item){
                $basicMaterialInfo = $basicMaterialObj->dump(array('bm_id'=>$pickone_item['bm_id']),'material_bn,material_name');
                $pickone_items[$k] = array_merge($pickone_item,$basicMaterialInfo);
            }
            $rows["pickone"] = $pickone_items;
        }
        echo json_encode($rows);
    }

    /**
     * 销售物料列表弹窗数据获取方法
     *
     * @param Void
     * @return String
     */
    function findSalesMaterial(){
        //已绑定的销售物料才可选择
        $base_filter = array('is_bind'=>1);

        if($_GET['shop_id']){
            $shop = explode('*',$_GET['shop_id']);
            $base_filter['shop_id'] = array($shop[0], '_ALL_');
        }

        if($_GET['type']){
            $base_filter['sales_material_type'] = $_GET['type'];
        }

        $params = array(
            'title'=>'销售物料列表',
            'use_buildin_new_dialog' => false,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_export'=>false,
            'use_buildin_import'=>false,
            'use_buildin_filter'=>true,
            'base_filter' => $base_filter,
        );
        $this->finder('material_mdl_sales_material', $params);
    }

    /**
     * 销售物料列表弹窗选中物料信息查询方法
     *
     * @param Int $bm_id
     * @return String
     */
    function getSalesMaterial(){
        $sm_id = $_POST['sm_id'];
        $sales_material_bn= $_GET['sales_material_bn'];
        $sales_material_name= $_GET['sales_material_name'];

        if (is_array($sm_id)){
            if ($sm_id[0] == "_ALL_"){
                $filter = '';
            }else {
                $filter['sm_id'] = $sm_id;
            }
        }

        if($sales_material_bn){
           $filter = array(
               'sales_material_bn'=>$sales_material_bn
           );
        }

        if($sales_material_name){
            $filter = array(
               'sales_material_name'=>$sales_material_name
           );
        }

        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        $salesMStockLib = kernel::single('material_sales_material_stock');
        $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
        $basicMaterialObj = app::get('material')->model('basic_material');

        $filter['use_like'] = 1;
        $data = $salesMaterialObj->getList('sm_id,sales_material_name,sales_material_bn',$filter,0,-1);

        if (!empty($data)){
            foreach ($data as $k => $item){
                $store = $salesMStockLib->getSalesMStockById($item['sm_id']);
                $ExtInfo = $salesMaterialExtObj->dump($item['sm_id'],'retail_price');
                $promoItems = $salesBasicMaterialObj->getList('*',array('sm_id'=>$item['sm_id']),0,-1);
                if($promoItems){
                    foreach($promoItems as $pk => &$promoItem){
                        $tmp_item = $basicMaterialObj->getList('material_name,material_bn',array('bm_id'=>$promoItem['bm_id']),0,1);
                        $promoItem = array_merge($promoItem , $tmp_item[0]);
                    }
                    $item['items'] = $promoItems;
                }

                $item['store'] = $store;
                $item['num'] = 1;
                $item['price'] = $ExtInfo['retail_price'];
                $rows[] = $item;
            }
        }
        echo json_encode($rows);
    }

    /**
     * 销售物料批量导入的模板
     *
     * @param Null
     * @return String
     */
    function exportTemplate()
    {
        header("Content-Type: text/csv");
        header("Content-Disposition: attachment; filename=销售物料导入模板-".date('Ymd').".csv");
        header('Cache-Control:must-revalidate,post-check=0,pre-check=0');
        header('Expires:0');
        header('Pragma:public');
        $salesMaterialObj = app::get('material')->model('sales_material');
        $title = $salesMaterialObj->exportTemplate('salesMaterial');
        echo '"'.implode('","',$title).'"';

        #模板案例
        $data[0]        = array('导入普通销售物料一','material_001','普通','我的淘宝店铺','100','125','200','只','product_001');
        $data[1]        = array('导入赠品销售物料二','material_002','赠品','全部店铺','0','0','0','个','product_002');
        $data[2]        = array('导入促销销售物料三','material_003','促销','我的京东店铺','150','165','500','个','product_001:2:30|product_002:3:30|product_003:4:40');
        $data[3]        = array('导入福袋销售物料四','material_004','福袋','我的天猫店铺','200','280','800','包','组合A:a1|a2|a3|a4-2|2|50.00#组合B:b1|b2-1|1|100.00');
        $data[4]        = array('导入多选一销售物料五','material_005','多选一','全部店铺','300','380','900','件','随机#sku01:0|sku02:0 或 排序#sku01:10|sku02:20');
        
        foreach ($data as $items)
        {
            foreach ($items as $key => $val)
            {
                $items[$key]    = kernel::single('base_charset')->utf2local($val);
            }

            echo "\n";
            echo '"'.implode('","',$items).'"';
        }
    }

    /**
     * 查看快照
     */
    function show_history($log_id){
        $logObj = app::get('ome')->model('operation_log');
        //日志
        $goodslog = $logObj->dump($log_id,'memo');
        $memo = unserialize($goodslog['memo']);
        //类型
        if($memo['sales_material_type'] == 3){
            $memo['type_name'] = '赠品';
        }elseif($memo['sales_material_type'] == 2){
            $memo['type_name'] = '促销';
        }elseif($memo['sales_material_type'] == 4){
            $memo['type_name'] = '福袋';
        }elseif($memo['sales_material_type'] == 5){
            $memo['type_name'] = '多选一';
        }else{
            $memo['type_name'] = '普通';
        }
        //所属店铺
        if($memo['shop_id'] && $memo['shop_id'] != '_ALL_'){
            $shopObj    = app::get('ome')->model('shop');
            $shopInfo   = $shopObj->dump(array('shop_id'=>$memo['shop_id']), 'name');
            $memo['shop_name'] = $shopInfo['name'];
        }else{
            $memo['shop_name'] = '全部店铺';
        }

        //关联基础物料
        $memo['is_pkg'] = false;
        $memo['is_luckybag'] = false;
        $memo['is_pickone'] = false;
        if($memo['sales_material_type'] == 2 && $memo['bm_list']){
            $memo['is_pkg'] = true;
        }elseif($memo['sales_material_type'] == 4 && $memo['luckybag_rules_list']){
            $memo['is_luckybag'] = true;
        }elseif($memo['sales_material_type'] == 5 && $memo['pickone_rules_list']){
            $memo["pickone_select_type_text"] = ($memo['pickone_rules_list'][0]["sort"] == 2) ? "排序" : "随机";
            $memo['is_pickone'] = true;
        }elseif($memo['bm_list']){
            foreach ($memo['bm_list'] as $key => $val){
                $memo['basic_material_bn'] = $val['material_bn'];
                $memo['basic_material_name'] = $val['material_name'];
            }
        }
        $this->pagedata['data'] = $memo;
        $this->singlepage('admin/material/sales/history_log.html');
    }
    
}
