<?php
/**
 * 基础物料数据结构
 *
 * @author kamisama.xia@gmail.com 
 * @version 0.1
 */

$db['basic_material']=array (
  'columns' =>
  array (
    'bm_id' =>
    array (
      'type' => 'int unsigned',
      'required' => true,
      'pkey' => true,
      'extra' => 'auto_increment',
      'label' => 'ID',
      'width' => 110,
      'hidden' => true,
      'editable' => false,
    ),
    'material_name' =>
    array (
      'type' => 'varchar(200)',
      'required' => true,
      'label' => '基础物料名称',
      'is_title' => true,
      'default_in_list' => true,
      'width' => 260,
      'searchtype' => 'has',
      'editable' => false,
      'filtertype' => 'normal',
      'filterdefault' => true,
      'in_list' => true,
    ),
    'material_bn' =>
    array (
      'type' => 'varchar(200)',
      'label' => '基础物料编码',
      'width' => 120,
      'editable' => false,
      'in_list' => true,
      'default_in_list' => true,
      'required'        => true,
      'searchtype' => 'nequal',
      'filtertype' => 'normal',
      'filterdefault' => true,
    ),
    'material_spu' =>
    array (
        'type' => 'varchar(200)',
        'label' => '基础物料款号',
        'width' => 120,
        'editable' => false,
        'in_list' => true,
        'searchtype' => 'nequal',
        'filtertype' => 'normal',
        'filterdefault' => true,
    ),
    'material_bn_crc32' =>
    array (
      'type' => 'bigint(13)',
      'label' => '货号查询索引值',
      'editable' => false,
      'required'        => true,
    ),
    'type' =>
    array (
      'type' => 'tinyint(1)',
      'label' => '物料属性',
      'width' => 100,
      'editable' => false,
      'default'         => 1,
      'editable' => false,
      'in_list' => true,
      'default_in_list' => false,
      'required'        => true,
    ),
    'serial_number' =>
    array (
      'type' => 'bool',
      'default' => 'false',
      'required' => true,
      'editable' => false,
      'label' => '唯一码',
      'width' => 75,
      'filtertype' => 'normal',
      'filterdefault' => true,
      'in_list' => true,
      'default_in_list' => true,
    ),
    'visibled' =>
    array(
      'type' => 'tinyint(1)',
      'label' => '销售状态',
      'width' => 100,
      'in_list' => true,
      'editable' => false,
      'default' => 1,
      'required' => true,
    ),
    'create_time' => array(
      'type' => 'time',
      'label' => '创建时间',
      'in_list' => true,
      'default' => 0,
    ),
    'disabled' =>
    array (
      'type' => 'bool',
      'default' => 'false',
      'required' => true,
      'editable' => false,
    ),
    'omnichannel' =>
    array(
      'type' => 'tinyint(1)',
      'label' => '是否全渠道',
      'in_list' => true,
      'editable' => false,
      'default' => 2,
    ),
    'last_modified' => array (
        'label' => '最后更新时间',
        'type' => 'last_modify',
        'width' => 130,
        'in_list' => true,
    ),
  ),
  'comment' => '基础物料表',
  'index' =>
  array (
    'uni_material_bn' =>
    array (
      'columns' =>
      array (
        0 => 'material_bn',
      ),
      'prefix' => 'UNIQUE',
    ),
    'ind_material_spu' =>
    array (
        'columns' =>
        array (
            0 => 'material_spu',
        ),
    ),
  ),
  'engine' => 'innodb',
  'version' => '$Rev:  $',
);
