<?php
class ome_ctl_admin_return_rchange extends desktop_controller {

    var $name = "退换货单";
    var $workground = "aftersale_center";

    //显示列表
    function index(){
        $params = array(
            'use_buildin_new_dialog' => false,
            'use_buildin_set_tag'=>false,
            'use_buildin_recycle'=>false,
            'use_buildin_import'=>true,
            'use_buildin_filter'=>true,
        );
        $params['use_buildin_export'] = true;
        $params['title'] = '退换货单';
        //$params['base_filter'] = array('status|noequal'=>'succ');
        $actions = array(
            array(
                'label' => '新建退换货单',
                'href' => 'index.php?app=ome&ctl=admin_return_rchange&act=rchange',
                'target' => "dialog::{width:1200,height:546,title:'新建退换货单'}",
            )
        );
        if ($_GET['view'] == '2') {
            $actions[] =array('label' => '发送至第三方',
                        'submit' => 'index.php?app=ome&ctl=admin_return_rchange&act=batch_sync',
                        'confirm' => '你确定要对勾选的退货单发送至第三方吗？',
                        'target' => 'refresh');
        }
        elseif($_GET['view']=='1')
        {
            //批量审核通过
            $actions[] = array(
                    'label' => '批量审核',
                    'submit' => 'index.php?app=ome&ctl=admin_return_rchange&act=batch_approve',
                    'target' => "dialog::{width:700,height:490,title:'批量审核'}",
            );
        }
        $actions[] = array(
            'label' => '导出模板',
            'href' => 'index.php?app=ome&ctl=admin_return_rchange&act=exportTemplate',
            'target' => '_blank',
        );
        $params['actions'] = $actions;
        $this->workground = "aftersale_center";

        if(isset($_POST['return_type'])){
            $params['base_filter']['return_type'] = $_POST['return_type'];
        }else{
            //过滤拒收退货
            $params['base_filter']['return_type'] = array('return','change');
        }

        //check shop permission
        $organization_permissions = kernel::single('desktop_user')->get_organization_permission();
        if($organization_permissions){
            $params['base_filter']['org_id'] = $organization_permissions;
        }

        # 权限判定
        if(!$this->user->is_super()){
           $add_rchange_permission = kernel::single('desktop_user')->has_permission('aftersale_rchange_add');
           if (!$add_rchange_permission) {
               unset($params['actions'][0]);
           }
        }
        #如果没有导出权限，则屏蔽导出按钮
        $params['use_buildin_export'] = kernel::single('desktop_user')->has_permission('aftersale_rchange_export');
        $this->finder ( 'ome_mdl_reship' , $params );
    }

    //tab展示
    function _views(){
        $sub_menu = $this->_view_all();
        return $sub_menu;
    }

    function _view_all(){
        $mdl_reship = $this->app->model('reship');
        $base_filter = array('return_type'=>array('return','change'));

        //check shop permission
        $organization_permissions = kernel::single('desktop_user')->get_organization_permission();
        if($organization_permissions){
            $base_filter['org_id'] = $organization_permissions;
        }

        $sub_menu = array(
            0 => array('label'=>__('全部'),'filter'=>$base_filter,'optional'=>false),
            1 => array('label'=>__('未审核'),'filter'=>array('is_check'=>'0'),'optional'=>false),
            2 => array('label'=>__('审核成功'),'filter'=>array('is_check'=>'1'),'optional'=>false),
            3 => array('label'=>__('审核失败'),'filter'=>array('is_check'=>'2'),'optional'=>false),
            //4 => array('label'=>__('收货成功'),'filter'=>array('is_check'=>'3'),'optional'=>false),
            //5 => array('label'=>__('拒绝收货'),'filter'=>array('is_check'=>'4'),'optional'=>false),
            6 => array('label'=>__('拒绝'),'filter'=>array('is_check'=>'5'),'optional'=>false),
            7 => array('label'=>__('补差价'),'filter'=>array('is_check'=>'6'),'optional'=>false),
            8 => array('label'=>__('完成'),'filter'=>array('is_check'=>'7'),'optional'=>false),
            9 => array('label'=>__('质检通过'),'filter'=>array('is_check'=>'8'),'optional'=>false),
            10 => array('label'=>__('拒绝质检'),'filter'=>array('is_check'=>'9'),'optional'=>false),
            11=> array('label'=>__('未录入退回物流号'),'filter'=>array('filter_sql'=>'({table}return_logi_no is null or {table}return_logi_no="")'),'optional'=>false),
            12 => array('label'=>__('质检异常'),'filter'=>array('filter_sql'=>'({table}is_check="10" or ({table}need_sv="false" and {table}is_check="0"))','optional'=>false)),
            13 => array('label'=>__('待确认'),'filter'=>array('is_check'=>'11','optional'=>false)),
        );

        foreach($sub_menu as $k=>$v){
            if (!IS_NULL($v['filter'])){
                $v['filter'] = array_merge($v['filter'], $base_filter);
            }
            $sub_menu[$k]['filter'] = $v['filter']?$v['filter']:null;
            $sub_menu[$k]['addon'] = $mdl_reship->count($v['filter']);
            $sub_menu[$k]['href'] = 'index.php?app=ome&ctl=admin_return_rchange&act=index&view='.$k;
        }

        return $sub_menu;
    }

    //新增弹窗页
    function rchange(){
        $return_type = array('return'=>'退货','change'=>'换货');
        if ($_GET['type']) {
            if ($_GET['type'] =='change') {
                $return_type = array('change'=>'换货','return'=>'退货');
            }
            $reship_data['return_type'] = $_GET['type'];
            $this->pagedata['reship_data'] = $reship_data;
        }
        $this->pagedata['return_type'] = $return_type;
        $this->pagedata['order_filter'] = array('pay_status'=>'1','ship_status'=>'1');
        $oProblem = $this->app->model('return_product_problem');
        $list = $oProblem->getList('problem_id,problem_name',array('disabled'=>'false'));
        $this->pagedata['problem_type'] = $list;

        //退货仓库设置
        $branchtype = app::get('wms')->getConf('wms.branchset.type');
        $this->pagedata['branchtype'] =  $branchtype;

        //只显示电商仓
        $branchObj = app::get('ome')->model('branch');
        $branch_list = $branchObj->getlist('branch_id,name',array('disabled'=>'false', 'b_type'=>1));
        $this->pagedata['branch_list'] = $branch_list;
        unset($branch_list);

	    $source = trim($_GET['source']);
        $this->pagedata['source'] = $source;
        $this->display('admin/return_product/rchange/rchange.html');
    }

    //新增或者编辑 退换货单ome_reship
    function add_rchange(){
        $this->begin();
        //获取所有传递参数
        $post = kernel::single('base_component_request')->get_params(true);
        //编辑 存在reship_id 获取is_check当前状态
        $Oreship = $this->app->model('reship');
        $post['is_check'] = NULL;
        if ($post['reship_id']){
            //当前状态
            $reshipinfo = $Oreship->dump($post['reship_id'],'is_check,change_status');
            if ($reshipinfo['is_check']=='7') {
                $this->end(false,'此单据已完成!');
            }
            $post['is_check'] = $reshipinfo['is_check'];
            $post['change_status'] = $reshipinfo['change_status'];
        }

        //格式化换货数据
        $rchangeObj = kernel::single('ome_return_rchange');
        $post = $rchangeObj->format_rchange_data($post);
        
        if($post["branch_id"] == "-1"){
            $this->end(false,'门店发货仓不支持售后');
        }

        //换货需验证退入和换出的仓库
        if($post["return_type"] == "change"){
            $result_branch_check = kernel::single('o2o_return')->check_reship_branch($post["branch_id"],$post["changebranch_id"],$error_msg);
            if(!$result_branch_check){
                $this->end(false,$error_msg);
            }
        }
        
        $mdl_ome_orders = app::get('ome')->model('orders');
        $rs_current_order = $mdl_ome_orders->dump($post["order_id"],'pay_status');
        if($rs_current_order["pay_status"] == "5" && $post["return_type"] == "change"){ //全额退款订单 并且是换货的
            $this->end(false,'全额退款订单不能做换货!');
        }
        
        //数据验证(商品、库存等)
        if(!$Oreship->validate($post,$v_msg)){
            $this->end(false,$v_msg);
        }

        //新增生成退换货单
        $reship_bn = $Oreship->create_treship($post,$msg);
        if($reship_bn == false) {
            $this->end(false,$msg);
        }
        //补差价
        if($reship_bn){
            if($rs_current_order["pay_status"] == "5"){ //全额退款订单
                $post["pay_status"] = "5";
            }
            $rchangeObj->update_diff_amount($post,$reship_bn);
        }

        $reship_id = $post['reship_id'];
        if(!$reship_id){
            //新增直接审核需要获取新的reship_id js这块需要直接跳转save_check审核方法
            $reship = $Oreship->getList('reship_id',array('reship_bn'=>$reship_bn),0,1);
            $reship_id= $reship[0]['reship_id'];
        }
        $params = array("reship_id"=>$reship_id);
        
        
        //退换货单自动审批(只处理新建的退换货单)
        if(empty($reshipinfo) && $post['is_confirm'] != 'true')
        {
            $is_auto_approve = app::get('ome')->getConf('return.auto_approve');
            if($is_auto_approve == 'on'){
                $reshipLib = kernel::single('ome_reship');
                
                $result = $reshipLib->batch_reship_queue($reship[0]['reship_id']);
            }
        }
        
        
        $this->end(true,$msg,null,$params);
    }

    /**
     * 根据order_bn快速获取订单信息（售后申请、退换货单2处加载订单信息）
     * @author yangminsheng
     **/
    function getOrderinfo(){
        $order_bn = trim($_GET['order_bn']);
        $source = trim($_GET['source']);
        if ($order_bn){
            //已支付部分退款并且已发货或部分退货的款到发货订单或货到付款已发货或部分退货的订单（包括全额退款的）
            $base_filter = array('disabled'=>'false','is_fail'=>'false','ship_status'=>array('1','3'),'pay_status'=>array('1','4','5'),'order_bn|has'=>$order_bn);
            $order = $this->app->model('orders');
            $data = $order->getList('order_id,order_bn',$base_filter);
            if ($source) {
                $is_archive = kernel::single('archive_order')->is_archive($source);
                if ($is_archive) {
                    $archive_ordObj = kernel::single('archive_interface_orders');
                    $data = $archive_ordObj->getOrder_list($base_filter,'order_id,order_bn');
                }
            }
            echo "window.autocompleter_json=".json_encode($data);
        }
    }

    //弹窗选择订单带入信息
    function getOdersById(){
        $source = trim($_GET['source']);
        $order_id = $_POST['id'];
        if ($order_id){
            if ($source && in_array($source,array('archive'))) {
                $archive_ordObj = kernel::single('archive_interface_orders');
                $base_filter = array('is_fail'=>'false','order_id'=>$order_id,'ship_status'=>array('1','3'),'pay_status'=>array('1','4'));
                if(isset($_GET["fullRefund"])){ //包括全额退款
                    $base_filter['pay_status'] = array('1','4','5');
                }
                $data = $archive_ordObj->getOrders($base_filter,'order_id,order_bn');
            }else{
                $orders = $this->app->model('orders');
                $base_filter = array('disabled'=>'false','is_fail'=>'false','order_id'=>$order_id,'ship_status'=>array('1','3'),'pay_status'=>array('1','4'));
                if(isset($_GET["fullRefund"])){ //包括全额退款
                    $base_filter['pay_status'] = array('1','4','5');
                }
                $data = $orders->dump($base_filter, 'order_id,order_bn');
            }
            $res['name'] = $data['order_bn'];
            $res['id'] = $data['order_bn'];
            echo json_encode($res);
            exit;
        }
    }

    //获取订单信息
    function ajax_getOrderinfo(){
        $json_data = array('rsp'=>'fail','msg'=>'');
        $post = kernel::single('base_component_request')->get_params(true);
        $source = $_GET['source'];
        if ($source && in_array($source,array('archive'))) {
            $oOrders = kernel::single('archive_interface_orders');
            $oDelivery = kernel::single('archive_interface_delivery');
            $order = $oOrders->getOrders(array('order_id'=>$post['order_id']),'*');
        }else{
            $oOrders = $this->app->model ( 'orders' );
            $oDelivery = $this->app->model ( 'delivery' );
            $order = $oOrders->dump ( array ('order_id' => $post['order_id'] ),'*' );
        }
        $oProduct = $this->app->model ( 'return_product' );
        if($order){
            $member = $this->app->model('members')->dump(array('member_id'=>$order['member_id']));
            $json_data['rsp'] = 'succ';
            $this->pagedata ['order_id'] = $order_id;
            $delivery = $oDelivery->getDeliveryByOrder('*',$post['order_id']);
            unset($delivery[0]['shop_id']);
            $order = array_merge($order,$delivery[0]);
            //加入了订单门店仓履约售后 判断是否是门店仓
            $branchLib = kernel::single('ome_branch');
            $store_id = $branchLib->isStoreBranch($order["branch_id"]);
            if($store_id){//是门店仓
                $order["branch_list"] = kernel::single('o2o_return')->get_aftersale_o2o_branch($order["branch_id"]);
                //售后设置->退货仓库设置 类型选择：发货仓库的
                $branchtype = app::get('wms')->getConf('wms.branchset.type');
                if($branchtype == "delivery"){ //如果当前门店仓不支持售后的
                    $support_aftersale = false;
                    foreach($order["branch_list"] as $var_ob){
                        if($order["branch_id"] == $var_ob["branch_id"]){
                            $support_aftersale = true;
                            break;
                        }
                    }
                    if(!$support_aftersale){
                        $order["branch_id"] = "-1";
                        $order["branch_name"] = "门店发货仓不支持售后";
                    }
                }
            }else{//是电商仓
                $order["branch_list"] = app::get('ome')->model('branch')->getlist('branch_id,name',array('disabled'=>'false', 'b_type'=>1));
            }
            $order['member_id'] = $member['account']['uname'];
            $order['createtime'] = date('Y-m-d H:i:s',$order['createtime']);
            $this->pagedata['ship_area'] = $order['ship_area'];
            $order['ship_area'] = $this->fetch('admin/return_product/rchange/show_area.html');
            $json_data['msg'] = $order;
        }
        echo json_encode($json_data);
        exit;
    }

    /**
     * @param Int $order_id 订单ID
     * @param String $type 数据类型 return:退货、change:换货
     */
    function get_data($order_id,$type,$source=''){
        //获取仓库模式
        $newItems = array();
        $tmp_product = array();
        $archive_ordObj = kernel::single('archive_interface_orders');
        if ($source == 'archive') {
            $order_object = $archive_ordObj->getOrder_object(array('order_id'=>$order_id),'*');
            $items = $archive_ordObj->getItemList($order_id);
        }else{
            $oOrders_item = $this->app->model ( 'order_items' );
            $order_object = $this->app->model('order_objects')->getList('*',array('order_id'=>$order_id));
            $items = $oOrders_item->getList ( '*', array ('order_id' => $order_id ),0,-1,'obj_id desc' );
        }
        $oReship_item = $this->app->model ( 'reship_items' );
        foreach($order_object as $object){
                $table = '<table><caption>捆绑信息</caption><thead><tr><th>销售物料编码</th><th>销售物料名称</th><th>价格</th><th>数量</th></tr></thead><tbody><tr>';
                $table .= '<td>'.$object['bn'].'</td><td>'.$object['name'].'</td><td>'.$object['price'].'</td><td>'.$object['quantity'].'</td>';
                $table .= '</tr></tbody></table>';
                $object['ref'] = $table;
                $oObject[$object['obj_id']] = $object;
        }
        $reshipObj = $this->app->model('reship');
        $tmpsale = $reshipObj->getSalepriceByorderId($order_id);


        $color = array('red','blue');
        foreach ( $items as $k => $v ) {
             $str_spec_value = '';
             $spec_info = unserialize($v['addon']);
             if(!empty($spec_info['product_attr'])){
                 foreach($spec_info['product_attr'] as $_val){
                     $str_spec_value .= $_val['value'].'|';
                 }
                 if(!empty($str_spec_value)){
                     $str_spec_value = substr_replace($str_spec_value,'',-1,1);
                 }
                 $items [$k]['spec_value'] = $str_spec_value;
             }

            if (!$objColor[$v['obj_id']]) {
                $objColor[$v['obj_id']] = $c = array_shift($color);
                array_push($color,$c);
            }

           // if($newItems[$v['bn']] && $newItems[$v['bn']]['bn'] !=''){
                   // $newItems[$v['bn']]['nums'] += $items[$k]['nums'];
                   // $newItems[$v['bn']]['sendnum'] += $items[$k]['sendnum'];
            //}else{

                if ($source == 'archive') {
                    $refund = $archive_ordObj->Get_refund_count ( $order_id, $v ['bn'] );
                    $items [$k] ['branch'] = $archive_ordObj->getBranchCodeByBnAndOd ( $v ['bn'], $order_id );
                }else{
                    $refund = $oReship_item->Get_refund_count ( $order_id, $v ['bn'],'',$v['item_id'] );
                    $items [$k] ['branch'] = $oReship_item->getBranchCodeByBnAndOd ( $v ['bn'], $order_id);
                }
                $items [$k] ['effective'] = $refund;
                $items [$k]['obj_type'] = $oObject[$v['obj_id']]['obj_type'];
                if ($oObject[$v['obj_id']]['ref']) {
                    $items [$k]['ref'] = $oObject[$v['obj_id']]['ref'];
                    $items [$k]['color'] = $objColor[$v['obj_id']];
                }

                $items[$k]['sale_price'] = $tmpsale[$oObject[$v['obj_id']]['bn']][$v['bn']] >0 ? $tmpsale[$oObject[$v['obj_id']]['bn']][$v['bn']] : $items[$k]['sale_price'];
                $items[$k]['order_item_id'] = $v['item_id'];
                $newItems[] = $items[$k];
            //}
            $tmp_product[] = $items[$k]['product_id'];
        }

        $items = $newItems;
        if($type == 'return'){
            $this->pagedata['total_return_filter'] = implode(',',$tmp_product);
        }else{
            $this->pagedata['total_change_filter'] = implode(',',$tmp_product);
        }

        $branch_mode = app::get ( 'ome' )->getConf ( 'ome.branch.mode' );

        $this->pagedata ['branch_mode'] = $branch_mode;

        $this->pagedata ['items'] = $items;

    }

    //获取退入商品信息
    function ajax_getProductinfo_one(){
        $html = '';
        $source = trim($_GET['source']);
        $this->get_data($_POST['order_id'],'return',$source);
        $html = $this->fetch('admin/return_product/rchange/rc_html_t.html');
        echo $html;exit;
    }

    //获取换出商品信息
    function ajax_getProductinfo_two(){
        $html = '';
        $this->get_data($_POST['order_id'],'change');
        $html = $this->fetch('admin/return_product/rchange/rc_html_c.html');
        echo $html;exit;
    }

    //返回支付/退款明细
    function ajax_paydetail(){
        $html = '';
        $this->paydetail($_POST['order_id']);
        $html = $this->fetch('admin/return_product/rchange/paydetail.html');
        echo $html;exit;
    }

    //获取支付信息
    function paydetail($order_id){
        $Orefunds = $this->app->model('refunds');
        $Opayments = $this->app->model('payments');
        $refunds = $Orefunds->getList('t_ready,refund_bn,money,paymethod,refund_refer',array('order_id'=>$order_id));
        $payments = $Opayments->getList('t_begin,payment_bn,money,paymethod,payment_refer',array('order_id'=>$order_id));
        $this->pagedata['payments'] = $payments;
        $this->pagedata['refunds'] = $refunds;
    }

    //退换货单审核
    function check($reship_id){
       $obj_return_process = app::get('ome')->model('return_process');
       $por_id = $obj_return_process->getList('por_id',array('reship_id'=>$reship_id));
       $this->pagedata['por_id'] = $por_id[0]['por_id'];
       $this->pagedata['act'] = 'save_check';
       $this->common_html(__FUNCTION__,$reship_id);
    }

    //最终收货
    function endcheck($reship_id){
       $obj_return_process = app::get('ome')->model('return_process');
       $por_id = $obj_return_process->getList('por_id',array('reship_id'=>$reship_id));
       $this->pagedata['por_id'] = $por_id[0]['por_id'];
       $this->pagedata['act'] = 'save_endcheck';
       $this->common_html(__FUNCTION__,$reship_id);
    }

    /**
     * 保存审核信息
     * $reship_id 退换货单主键
     * $status 当前状态 对应ome_reship is_check
     * $is_anti 是否是反审
     **/
    function save_check($reship_id,$status,$is_anti = false){
        $this->begin();
        
        //验证数据
        if (empty($reship_id)){
            $this->end(false, '没有可操作的退换货单');
        }
        
        $reshipLib = kernel::single('ome_reship');
        
        //执行审核
        $is_anti = ($is_anti ? true : false);
        $params = array('reship_id'=>$reship_id, 'status'=>$status, 'is_anti'=>$is_anti);
        $confirm = $reshipLib->confirm_reship($params, $error_msg);
        if(!$confirm){
            $this->end(false, $error_msg);
        }
        
        $this->end(true,"操作成功");
    }

    //最终收货保存
    function save_endcheck($reship_id,$status,$is_anti = false){
       $this->begin();
       if($reship_id){
            $Oreship = $this->app->model('reship');
            $oReship_item = $this->app->model('reship_items');
            $reship = $Oreship->dump(array('reship_id'=>$reship_id),'is_check,reship_bn,return_type,reason,need_sv');
            if($reship['is_check'] == '7'){
                $this->end(false,'改单据已完成!');
            }
            $normal_reship_item = $oReship_item->getList('*',array('reship_id'=>$reship_id,'normal_num|than'=>0),0,1);
            $reship_item = $oReship_item->getList('*',array('reship_id'=>$reship_id,'defective_num|than'=>0),0,1);
            if (count($normal_reship_item)==0 && count($reship_item)==0) {
                $this->end(false,'良品或不良品数量至少有一种不为0!');
            }
            if (count($reship_item)>0) {
                $branch_id = $reship_item[0]['branch_id'];
                $damaged = kernel::single('console_iostockdata')->getDamagedbranch($branch_id);
                if (!$damaged) {
                    $this->end(false,'由于有不良品入库，请设置主仓对应残仓');
                }
            }
            if($Oreship->finish_aftersale($reship_id)){
                kernel::single('console_reship')->siso_iostockReship($reship_id);
                if(!$result){
                    $this->end(false,'没有生成出入库明细!');
                }
            }
       }
       $this->end(true,'操作成功！');
    } // end func

    //退换货单编辑
    function edit($reship_id){
        $return_type = array('return'=>'退货','change'=>'换货');
        $this->pagedata['order_filter'] = array('pay_status'=>'1','ship_status'=>'1');
        $Oreship = $this->app->model('reship');
        $oOrder_pmt = $this->app->model('order_pmt');
        $reship_data = $Oreship->getCheckinfo($reship_id,false);

        //格式化费用金额
        $reship_data['bcmoney']    = (empty($reship_data['bcmoney']) ? '0.00' : $reship_data['bcmoney']);
        $reship_data['bmoney']    = (empty($reship_data['bmoney']) ? '0.00' : $reship_data['bmoney']);
        $reship_data['cost_freight_money']    = (empty($reship_data['cost_freight_money']) ? '0.00' : $reship_data['cost_freight_money']);
        
        $this->paydetail($reship_data['order_id']);
        $oProblem = $this->app->model('return_product_problem');
        $list = $oProblem->getList('problem_id,problem_name');
        $this->pagedata['problem_type'] = $list;
        $reship_data['return_type_name'] = $return_type[$reship_data['return_type']];
        
        //退回物流信息
        $return_id    = $reship_data['return_id'];
        if($return_id && empty($reship_data['return_logi_id']))
        {
            $oDly_corp    = app::get('ome')->model('dly_corp');
            $reProductObj    = app::get('ome')->model('return_product');
            $product_detail  = $reProductObj->dump(array('return_id'=>$return_id), 'process_data');
            $process_data    = ($product_detail['process_data'] ? unserialize($product_detail['process_data']) : '');
            if($process_data)
            {
                $corpinfo = $oDly_corp->dump(array('name'=>$process_data['shipcompany']), 'corp_id');
                
                $reship_data['return_logi_name']  = $corpinfo['corp_id'];
                $reship_data['return_logi_no']    = $process_data['logino'];
            }
        }
        
        $this->pagedata['reship_data'] = $reship_data;
        $pmts = $oOrder_pmt->getList('pmt_amount,pmt_describe',array('order_id'=>$reship_data['order_id']));
        $this->pagedata['pmts'] = $pmts;
        $this->pagedata['total_return_filter'] = $reship_data['total_return_filter'];
        $this->pagedata['total_change_filter'] = $reship_data['total_change_filter'];

        # 计算差价
        $this->pagedata['diffmoney'] = $reship_data['diff_money'];

        # 订单的支付明细
        $oPayments = $this->app->model('payments');
        $this->pagedata['payments'] = $oPayments->getList('payment_id,payment_bn,t_begin,download_time,money,paymethod',array('order_id'=>$reship_data['order_id']));

        # 订单的退款明细
        $oRefunds = $this->app->model('refunds');
        $this->pagedata['refunds'] = $oRefunds->getList('refund_bn,t_ready,download_time,money,paymethod',array('order_id'=>$reship_data['order_id']));
        $oOrders = $this->app->model ( 'orders' );
        if (in_array($reship_data['archive'],array('1'))) {
            $archive_ordObj = kernel::single('archive_interface_orders');
            $oDelivery = kernel::single('archive_interface_delivery');
            $order = $archive_ordObj->getOrders(array('order_id'=>$reship_data['order_id']),'*');
        }else{
            $oDelivery = $this->app->model ( 'delivery' );
            $order = $oOrders->dump ( array ('order_id' => $reship_data['order_id'] ),'*' );
        }
        $this->pagedata['order'] = $order;

        //退换货类型
        if($order['pay_status'] == '5'){
            unset($return_type['change']); //全额退款的订单不允许换货
        }
        $this->pagedata['return_type'] = $return_type;
        
        //退货仓库设置
        $branchtype = app::get('wms')->getConf('wms.branchset.type');
        $this->pagedata['branchtype'] =  $branchtype;

        $delivery = $oDelivery->getDeliveryByOrder('*',$reship_data['order_id']);
        //加入了订单门店仓履约售后 判断是否是门店仓 显示branch_list
        $branchLib = kernel::single('ome_branch');
        $store_id = $branchLib->isStoreBranch($delivery[0]["branch_id"]);
        if($store_id){//是门店仓
            $this->pagedata["branch_list"] = kernel::single('o2o_return')->get_aftersale_o2o_branch($delivery[0]["branch_id"]);
        }else{//是电商仓
            $this->pagedata["branch_list"] = app::get('ome')->model('branch')->getlist('branch_id,name',array('disabled'=>'false', 'b_type'=>1));
        }

        $this->pagedata['source'] = $reship_data['source'];

        //[最终收货]禁止编辑数据
        $this->pagedata['not_edit'] = ($reship_data['return_type']=='change' && $reship_data['is_check']=='11') ? true : false;
        //判断编辑时显示未选择明细
        if ($reship_data['is_check'] == '0'){
            $return_items = $reship_data['return'];
            $return_bn_array=array();
            foreach($return_items as $items){
                $return_bn_array[] = $items['order_item_id'];
            }
            $order_item = $this->get_Orderdata($reship_data['order_id'],$reship_data['source']);

            foreach($order_item as $ok=>$ov){
                if (in_array($ov['order_item_id'],$return_bn_array) || $ov['effective']<=0){
                    unset($order_item[$ok]);
                }
            }

          
            $this->pagedata['order_item'] = $order_item;
            unset($order_item);
        }
        $this->display('admin/return_product/rchange/rchange.html');
    }

    //反审核
    function anti_check($reship_id){
       if(!$reship_id)
        die("单据号传递错误！");
       $Oreship = $this->app->model('reship');
       $reship = $Oreship->dump(array('reship_id'=>$reship_id),'reship_bn');
       $this->pagedata['reship_id'] = $reship_id;
       $this->pagedata['reship_bn'] = $reship['reship_bn'];
       $oOperation_log = $this->app->model('operation_log');
       $memo = '进行反审核';
       $oOperation_log->write_log('reship@ome',$reship_id,$memo);
       $this->display('admin/return_product/rchange/anti_check.html');
    }

    //入库单
    function ruku($reship_id){
        $this->pagedata['act'] = 'save_ruku';
        $this->pagedata['ruku_html'] = true;
        $Oreship = $this->app->model('reship');
        $reships = $Oreship->dump(array('reship_id'=>$reship_id),'order_id');
        $this->paydetail($reships['order_id']);
        $this->common_html(__FUNCTION__,$reship_id);
    }

    /**
     * 保存入库单信息
     * status 状态：
     *       5: 拒绝 生成一张发货单 商品明细为退入商品中的商品信息
     *       6：补差价，生成一张未付款的支付单
     *       8: 完成
     **/
    function save_ruku($reship_id,$status){
        if(!$reship_id)
            die('单据号传递错误!');
        $this->begin();
        $data = kernel::single('base_component_request')->get_params(true);

        $Oreship = $this->app->model('reship');
        $Oreship->saveinfo($reship_id,$data,$status);
        $this->end(true,'操作成功！');
    }

    //保存验收退换货单状态
    function save_accept_returned($reship_id,$status){
       $this->begin();
       if($reship_id){
            $oOperation_log = $this->app->model('operation_log');
            $Oreship = $this->app->model('reship');
            $oProduct_pro = $this->app->model('return_process');
            $oProduct_pro_detail = $oProduct_pro->product_detail($reship_id);
            $reship = $Oreship->dump(array('reship_id'=>$reship_id),'is_check,return_id,reason');
            if($reship['is_check'] == '3'){
                $this->end(false,'改单据已验收过!');
            }
            //增加售后收货前的扩展
            foreach(kernel::servicelist('ome.aftersale') as $o){
                if(method_exists($o,'pre_sv_charge')){
                    if(!$o->pre_sv_charge($_POST,$memo)){
                        $this->end(false, app::get('base')->_($memo));
                    }
                }
            }
            $data['branch_name'] = $oProduct_pro_detail['branch_name'];
            $data['memo'] = $_POST['info']['memo'];
            $data['shipcompany'] = $_POST['info']['shipcompany'];
            $data['shiplogino'] = $_POST['info']['shiplogino'];
            $data['shipmoney'] = $_POST['info']['shipmoney'];
            $data['shipdaofu'] = $_POST['info']['daofu'] == 1 ? 1 : 0;
            $data['shiptime'] = time();
            if($status == '4'){
                $addmemo = ',拒绝收货';
                $refuse_memo = unserialize($reship['reason']);
                $refuse_memo .= '#收货原因#'.$_POST['info']['refuse_memo'];
                $prodata = array('reship_id'=>$reship_id,'reason'=>serialize($refuse_memo));
                $oProduct_pro->cancel_process($prodata);
            }elseif($status == '3'){
                $prodata = array('reship_id'=>$reship_id,'process_data'=>serialize($data));
                $addmemo = ',收货成功';
                $oProduct_pro->save_return_process($prodata);
            }
            $filter = array(
                'is_check'=>$status,
                'return_logi_name'=>$data['shipcompany'],
                'return_logi_no'=>$data['shiplogino'],
            );
            $Oreship->update($filter,array('reship_id'=>$reship_id));
            if($reship['return_id']){
                $Oproduct = $this->app->model('return_product');
                $recieved = 'false';
                if($status == '3'){
                   $recieved = 'true';
                }
                $Oproduct->update(array('process_data'=>serialize($data),'recieved'=>$recieved),array('return_id'=>$reship['return_id']));
            }
            $Oreship_items = $this->app->model('reship_items');
            $oBranch = $this->app->model('branch');
            $reship_items = $Oreship_items->getList('branch_id',array('reship_id'=>$reship_id,'return_type'=>'return'));
            $branch_name = array();
            foreach($reship_items as $k=>$v){
                $branch_name[] = $oBranch->Get_name($v['branch_id']);
            }
            $add_name = array_unique($branch_name);
            $memo='仓库:'.implode(',', $add_name).$addmemo;
            $oOperation_log = $this->app->model('operation_log');
            if($reship['return_id']){
                $oOperation_log->write_log('return@ome',$reship['return_id'],$memo);
            }
            $oOperation_log->write_log('reship@ome',$reship_id,$memo);

            /*
            if($oProduct_pro_detail['return_id']){
               //售后申请状态更新
                foreach(kernel::servicelist('service.aftersale') as $object=>$instance){
                    if(method_exists($instance,'update_status')){
                        $instance->update_status($oProduct_pro_detail['return_id']);
                    }
                }
            }
            */

           //增加售后收货前的扩展
            foreach(kernel::servicelist('ome.aftersale') as $o){
                if(method_exists($o,'after_sv_charge')){
                    $o->after_sv_charge($_POST);
                }
            }

       }

       $this->end(true,'操作成功！');

    }


    //收货拒绝理由
    function refuse_reason($reship_id,$status,$type){
        if($type == 'returned'){
           $refuse_memo = '收货拒绝';
           $ctl = 'admin_return_rchange';
           $act = 'save_accept_returned';
        }else{
           $refuse_memo = '质检拒绝';
           $ctl = 'admin_return_sv';
           $act = 'tosave';
        }
        $this->pagedata['finder_id'] = $_GET['finder_id'];
        $this->pagedata['refuse_memo'] = $refuse_memo;
        $this->pagedata['from_type'] = $_GET['from_type'];
        $this->pagedata['ctl'] = $ctl;
        $this->pagedata['act'] = $act;
        $this->pagedata['reship_id'] = $reship_id;
        $this->pagedata['status'] = $status;
        $this->display('admin/return_product/rchange/refuse_reason.html');
    }

    //验收退换货单
    function accept_returned($reship_id){
        $this->pagedata['act'] = 'save_accept_returned';
        $this->common_html(__FUNCTION__,$reship_id);
    }

    //验收退换货和审核公共页面
    function common_html($display_button = 'check',$reship_id){
        if(!$reship_id) die('单据号传递错误!');
        $Oreship = $this->app->model('reship');
        $reship_data = $Oreship->getCheckinfo($reship_id);
        $rchangeobj = kernel::single('ome_return_rchange');
        $changelist = $rchangeobj->getChangelist($reship_id,$reship_data['changebranch_id']);
        $reship_data['reason'] = unserialize($reship_data['reason']);
        $oProblem = $this->app->model('return_product_problem');
        $list = $oProblem->dump(array('problem_id'=>$reship_data['problem_id']),'problem_name');
        # 支付单
        $this->pagedata['payments'] = $this->app->model('payments')->getList('*',array('order_id'=>$reship_data['order_id']));
        # 退款单
        $this->pagedata['refunds'] = $this->app->model('refunds')->getList('*',array('order_id'=>$reship_data['order_id']));
        $reship_data['problem_type'] = $list['problem_name'];
        $this->pagedata['changelist'] = $changelist;
        $this->pagedata['reship_data'] = $reship_data;
        $this->pagedata['display_button'] = $display_button;
        $this->display('admin/return_product/rchange/check.html');
    }

    //获取展示销售物料信息
    function getProducts(){
        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
        $basicMaterialObj = app::get('material')->model('basic_material');
        $libBranchProduct = kernel::single('ome_branch_product');
        $lib_o2o_return = kernel::single('o2o_return');
        $salesMLib = kernel::single('material_sales_material');
        $pro_id = $_POST['product_id'];
        $type = $_GET['type'];
        if (is_array($pro_id)){
            $filter['sm_id'] = $pro_id;
        }
        $filter['is_bind'] = 1;

        //选择换货的仓库
        $branch_id = intval($_GET['changebranch_id']);
        //判断是否是门店仓
        $store_id = kernel::single('ome_branch')->isStoreBranch($branch_id);

        $rows = array();
        $dataList = $salesMaterialObj->getList('sm_id, sales_material_name, sales_material_bn, sales_material_type', $filter);
        if($dataList){
            foreach ($dataList as $key => $item){
                $item['num']            = 1;
                $item['product_id']     = $item['sm_id'];
                $item['bn']             = $item['sales_material_bn'];
                $item['name']           = $item['sales_material_name'];
                #销售物料类型
                switch($item['sales_material_type']){
                    case "2":
                        $item['item_type'] = 'pkg';
                        $item['item_type_name'] = '促销'; break;
                    case "3":
                        $item['item_type'] = 'gift';
                        $item['item_type_name'] = '赠品'; break;
                    case "4":
                        $item['item_type'] = 'lkb';
                        $item['item_type_name'] = '福袋'; break;
                    case "5":
                        $item['item_type'] = 'pko';
                        $item['item_type_name'] = '多选一'; break;
                    default:
                        $item['item_type'] = 'product';
                        $item['item_type_name'] = '普通'; break;
                        break;
                }
                $item['type']    = $type;
                #销售物料价格
                $salesMaterialRow    = $salesMaterialExtObj->dump(array('sm_id'=>$item['sm_id']), 'cost, retail_price');
                $item['price']       = ($salesMaterialRow['retail_price'] ? $salesMaterialRow['retail_price'] : 0);

                #关联的基础物料信息
                $temp_sale_store   = array();
                if($item['sales_material_type'] == 4){ //福袋
                    //获取福袋的基础物料数据
                    $ma_lu_lo = app::get('material')->model('luckybag_log');
                    $mdl_ma_lu_ru = app::get('material')->model('luckybag_rules');
                    $random_luckybag = false;
                    if($_GET["order_id"]){
                        $rs_luckybag = $ma_lu_lo->getList("lbr_id,bm_id,price",array("sm_id"=>$item['sm_id'],"order_id"=>$_GET["order_id"]));
                        if(empty($rs_luckybag)){
                            $random_luckybag = true;
                        }else{ //存在福袋信息
                            foreach($rs_luckybag as $var_rl){
                                $tmp_basic_item = $basicMaterialObj->dump(array('bm_id'=>$var_rl["bm_id"]),'material_name,material_bn,type');
                                if($store_id){//门店仓
                                    $arr_stock = $lib_o2o_return->o2o_store_stock($branch_id,$var_rl["bm_id"]);
                                    $tmp_item_store = $arr_stock["store"]; //值可能会包括 "-" "x" 或 真实的库存数
                                }else{//电商仓
                                    $tmp_store = $libBranchProduct->getAvailableStore($branch_id, array($var_rl["bm_id"]));
                                    $tmp_item_store = ($tmp_store[$var_rl["bm_id"]] ? $tmp_store[$var_rl["bm_id"]] : 0);
                                }
                                $rs_lu_ru = $mdl_ma_lu_ru->dump(array("lbr_id"=>$var_rl['lbr_id']));
                                //根据销售物料绑定的基础物料计算可用库存
                                if($tmp_item_store > 0){
                                    $temp_sale_store[] = floor($tmp_item_store/$rs_lu_ru['send_num']);
                                }else{
                                    $temp_sale_store[] = $tmp_item_store;
                                }
                                $item['items'][] = array(
                                    "lbr_id" => $var_rl['lbr_id'],
                                    "lbr_input" => "<input type='hidden' name='basic_lbr_".$item['sm_id']."_".$var_rl["bm_id"]."' value='".$var_rl['lbr_id']."' />",
                                    "sm_id" => $item['sm_id'],
                                    "bm_id" => $var_rl["bm_id"],
                                    'number' => $rs_lu_ru['send_num'], //默认加载的数量
                                    'material_name' => $tmp_basic_item["material_name"],
                                    'material_bn' => $tmp_basic_item["material_bn"],
                                    'type' => $tmp_basic_item["type"],
                                    'type_name' => '',
                                    'store' => $tmp_item_store,
                                    'change_num' => $rs_lu_ru['send_num'], //默认加载的数量
                                );
                            }
                        }
                    }else{
                        $random_luckybag = true;
                    }
                    if($random_luckybag){ //重新随机获取福袋数据
                        $basicMInfos = $salesMLib->get_order_luckybag_bminfo($item['sm_id']);
                        foreach($basicMInfos as $var_rl){
                            if($store_id){//门店仓
                                $arr_stock = $lib_o2o_return->o2o_store_stock($branch_id,$var_rl["bm_id"]);
                                $tmp_item_store = $arr_stock["store"]; //值可能会包括 "-" "x" 或 真实的库存数
                            }else{//电商仓
                                $tmp_store = $libBranchProduct->getAvailableStore($branch_id, array($var_rl["bm_id"]));
                                $tmp_item_store = ($tmp_store[$var_rl["bm_id"]] ? $tmp_store[$var_rl["bm_id"]] : 0);
                            }
                            //根据销售物料绑定的基础物料计算可用库存
                            if($tmp_item_store > 0){
                                $temp_sale_store[] = floor($tmp_item_store/$var_rl['number']);
                            }else{
                                $temp_sale_store[] = $tmp_item_store;
                            }
                            $item['items'][] = array(
                                    "lbr_id" => $var_rl['lbr_id'],
                                    "lbr_input" => "<input type='hidden' name='basic_lbr_".$item['sm_id']."_".$var_rl["bm_id"]."' value='".$var_rl['lbr_id']."' />",
                                    "sm_id" => $item['sm_id'],
                                    "bm_id" => $var_rl["bm_id"],
                                    'number' => $var_rl['number'], //默认加载的数量
                                    'material_name' => $var_rl["material_name"],
                                    'material_bn' => $var_rl["material_bn"],
                                    'type' => $var_rl["type"],
                                    'type_name' => '',
                                    'store' => $tmp_item_store,
                                    'change_num' => $var_rl['number'], //默认加载的数量
                            );
                        }                        
                    }
                }elseif($item['sales_material_type'] == 5){ //多选一
                    //根据order_id拿对应的shop_id
                    $ome_orders = app::get('ome')->model('orders');
                    $rs_order_info = $ome_orders->dump(array("order_id"=>$_GET["order_id"]),"shop_id");
                    $basicMInfos = $salesMLib->get_order_pickone_bminfo($item['sm_id'],"1",$rs_order_info["shop_id"]);
                    foreach($basicMInfos as $var_rl){
                        $tmp_store = $libBranchProduct->getAvailableStore($branch_id, array($var_rl["bm_id"]));
                        $item['items'][] = array(
                                "sm_id" => $item['sm_id'],
                                "bm_id" => $var_rl["bm_id"],
                                'number' => $var_rl['number'], //默认加载的数量
                                'material_name' => $var_rl["material_name"],
                                'material_bn' => $var_rl["material_bn"],
                                'type' => $var_rl["type"],
                                'type_name' => '',
                                'store' => ($tmp_store[$var_rl["bm_id"]] ? $tmp_store[$var_rl["bm_id"]] : 0),
                                'change_num' => $var_rl['number'], //默认加载的数量
                        );
                    }
                }else{
                    $promoItems = $salesBasicMaterialObj->getList('*',array('sm_id'=>$item['sm_id']),0,-1);
                    if($promoItems){
                        foreach($promoItems as $pk => &$promoItem){
                            $product_id    = $promoItem['bm_id'];
                            $tmp_item      = $basicMaterialObj->getList('bm_id, material_name, material_bn, type',array('bm_id'=>$product_id),0,1);
                            $tmp_item[0]['sm_id']    = $item['sm_id'];#销售物料sm_id_改变申请数量JS使用
                            #基础物料属性
                            $tmp_item[0]['type_name']    = '';
                            
                            #基础物料库存
                            if($store_id){//门店仓
                                $arr_stock = $lib_o2o_return->o2o_store_stock($branch_id,$product_id);
                                $tmp_item[0]['store'] = $arr_stock["store"]; //值可能会包括 "-" "x" 或 真实的库存数
                            }else{//电商仓
                                $tmp_store = $libBranchProduct->getAvailableStore($branch_id, array($product_id));
                                $tmp_item[0]['store'] = ($tmp_store[$product_id] ? $tmp_store[$product_id] : 0);
                            }
                            
                            #申请换货的数量
                            $tmp_item[0]['change_num'] = $promoItem['number'];
                            $promoItem = array_merge($promoItem , $tmp_item[0]);
                            
                            //根据销售物料绑定的基础物料计算可用库存
                            if($tmp_item[0]['store'] > 0)
                            {
                                $temp_sale_store[]    = floor($tmp_item[0]['store']/$promoItem['number']);
                            }
                            else
                            {
                                $temp_sale_store[]    = $tmp_item[0]['store'];
                            }
                        }
                        $item['items'] = $promoItems;
                    }
                }
                #[根据选择的换货仓库]获取基础物料库存
                if($item['sales_material_type'] == 5){ //多选一 object层库存是item的基础物料库存叠加
                    $item['sale_store'] = $salesMLib->get_pickone_branch_store($item['sm_id'],$branch_id);
                }else{
                    $item['sale_store'] = min($temp_sale_store);
                }
                $rows[]    = $item;
            }
        }
        
        echo "window.autocompleter_json=".json_encode($rows);exit;
    }

    //构造一个商品列表 供换货销售物料选择
    function getGoods($product_id){
        #搜索条件
        $base_filter['is_bind'] = 1;#已绑定基础物料
        if($product_id){
            $base_filter['sm_id|notin']    = explode(',', $product_id);
        }

        //销售物料所属店铺
        $order_id    = trim($_GET['order_id']);
        if($order_id){
            $orderObj    = app::get('ome')->model('orders');
            $orderRow    = $orderObj->dump(array('order_id'=>$order_id), 'shop_id');
            if($orderRow){
                $base_filter['shop_id']    = array($orderRow['shop_id'], '_ALL_');
            }
        }

        /**
         * 普通、促销、赠品
        if($_GET['type'] == 1)
        {
            $base_filter['sales_material_type'] = 1;#只显示普通销售物料
        }
        **/

        $params = array(
                'title'=>'销售物料列表',
                'use_buildin_new_dialog' => false,
                'use_buildin_set_tag'=>false,
                'use_buildin_recycle'=>false,
                'use_buildin_export'=>false,
                'use_buildin_import'=>false,
                'use_buildin_filter'=>true,
                'base_filter' => $base_filter,
        );
        $this->finder('material_mdl_sales_material', $params);
    }

    //取消退换货单
    function do_cancel($reship_id){
        if(!$reship_id){
            die("单据号传递错误！");
        }
        $Oreship = app::get('ome')->model('reship');
        $reship = $Oreship->dump(array('reship_id'=>$reship_id),'reship_bn,return_id,return_type,changebranch_id,is_check');
        if($_POST){//提交
            $reship_id = $_POST['reship_id'];
            $Oreship->update(array('is_check'=>'5','t_end'=>time()),array('reship_id'=>$reship_id));
            
            //判断是否是已确认拒绝如果是需要释放冻结库存
            if ($reship['return_type'] == 'change' && $reship['is_check'] == '1') {
                //库存管控 换货预占 目前只有电商仓
                $storeManageLib = kernel::single('ome_store_manage');
                $storeManageLib->loadBranch(array('branch_id'=>$reship['changebranch_id']));
                $params_stock = array(
                        "params" => array_merge($reship,array('reship_id'=>$reship_id)),
                        "node_type" => "reshipReturnRefuseChange",
                );
                $storeManageLib->processBranchStore($params_stock, $err_msg);
            }
            
            $memo = '状态:拒绝';
            $memo.= $_POST['cancel_flag']== '1' ? ',强制取消':'';
            $oOperation_log = app::get('ome')->model('operation_log');//写日志
            if($reship['return_id']){
                $oOperation_log->write_log('return@ome',$reship['return_id'],$memo);
                $data = array ('return_id' => $reship['return_id'], 'status' => '5', 'last_modified' => time () );
                $oProduct = app::get('ome')->model ( 'return_product' );
                $oProduct->update_status ( $data );
            }
            $oOperation_log->write_log('reship@ome',$reship_id,$memo);
        }
        $this->pagedata['reship_bn'] = $reship['reship_bn'];
        $this->pagedata['reship_id'] = $reship_id;
        $this->display('admin/return_product/rchange/do_cancel.html');
    }

    //打回发货单方法
    function do_back($reship_id){
        if(!$reship_id)
            die("单据号传递错误！");
        $Oreship = $this->app->model('reship');
        $Oreturn_products = $this->app->model('return_product');
        if($_POST){
            $reship_id = $_POST['reship_id'];
            $memo = '';
            $delivery_num=0;//发货单数量
            $oReship = $this->app->model('reship');
            $oDelivery = $this->app->model('delivery');
            $oDelivery_order= $this->app->model('delivery_order');
            $oDelivery_items = $this->app->model('delivery_items');
            $oOrder_items = $this->app->model('order_items');
            $reshipinfo = $oReship->dump(array('reship_id'=>$reship_id));
            $order_items = $oOrder_items->getList('*',array('order_id'=>$reshipinfo['order_id']));
            $order_id = $reshipinfo['order_id'];
            $delivery_order = $oDelivery_order->dump(array('order_id'=>$order_id),'delivery_id');
            $delivery_id = $delivery_order['delivery_id'];
            $is_archive = kernel::single('archive_order')->is_archive($reshipinfo['source']);
            if ($is_archive) {
                $archive_delObj = kernel::single('archive_interface_delivery');
                $deliveryinfo = $archive_delObj->getDelivery(array('delivery_id'=>$delivery_id),'branch_id,delivery_id,logi_id,delivery_cost_actual');
            }else{
                $deliveryinfo = $oDelivery->dump($delivery_id,'branch_id,delivery_id,logi_id,delivery_cost_actual');
            }
            $delivery_items = $this->app->model('reship_items')->getList('product_id,bn,product_name,num as number',array('reship_id'=>$reship_id,'return_type'=>'return'));

            $Process_data = array_merge($deliveryinfo,$reshipinfo);
            $Process_data['logi_id'] = $reshipinfo['logi_id']!='' ? $reshipinfo['logi_id'] :$deliveryinfo['logi_id'];
            $Process_data['logi_name'] = $reshipinfo['logi_name']!='' ? $reshipinfo['logi_name'] :$deliveryinfo['logi_name'];
            $Process_data['delivery_items'] = $delivery_items;

            define('FRST_TRIGGER_OBJECT_TYPE','发货单：售后申请原样寄回生成发货单');
            define('FRST_TRIGGER_ACTION_TYPE','ome_mdl_return_product：saveinfo');

            $new_delivery_bn = $oReship->create_delivery($Process_data);
            $delivery_memo = '，发货单号为:'.$new_delivery_bn;
            $delivery_num = 1;
            $oReship->update(array('is_check'=>'5'),array('reship_id'=>$reship_id));
            if($reshipinfo['return_id']){
                $Oreturn_products->update(array('status'=>'5'),array('return_id'=>$reshipinfo['return_id']));
            }

            if($delivery_num!=0){
                $memo.='   生成了'.$delivery_num.'张发货单'.$delivery_memo;
            }

            //售后原样寄回埋点
            $new_delivery_info = $oDelivery->dump(array('delivery_bn'=>$new_delivery_bn),'delivery_id');
            //发货单通知单推送仓库
            ome_delivery_notice::create($new_delivery_info['delivery_id']);

            $oOperation_log = $this->app->model('operation_log');//写日志
            if($reshipinfo['return_id']){
               $oOperation_log->write_log('return@ome',$reshipinfo['return_id'],$memo);
            }
            $oOperation_log->write_log('reship@ome',$reship_id,$memo);
            echo '生成退回发货单成功!';exit;
        }
        $reship = $Oreship->dump(array('reship_id'=>$reship_id),'reship_bn');
        $this->pagedata['reship_bn'] = $reship['reship_bn'];
        $this->pagedata['reship_id'] = $reship_id;
        $this->display('admin/return_product/rchange/do_back.html');

    }

    //根据仓库ID和货品ID 获取相应的库存数量
    function ajax_showStore(){
        $libBranchProduct = kernel::single('ome_branch_product');#基础物料 ExBOY
        $branch_id = $_POST['branch_id'];
        $product_id = $_POST['product_id'];
        $result = array('res'=>'fail','msg'=>'product_id is empty');
        if($product_id && $branch_id){
            $store = $libBranchProduct->get_product_store($branch_id,$product_id);
            $result = array('res'=>'succ','msg'=>$store);
        }
        echo json_encode($result);exit;
    }

    //根据订单ID 获取相应的优惠方案信息
    function ajax_getPmts(){
        $order_id = $_POST['order_id'];
        if($order_id){
            $oOrder_pmt = $this->app->model('order_pmt');
            $pmts = $oOrder_pmt->getList('pmt_amount,pmt_describe',array('order_id'=>$order_id));
            $this->pagedata['pmts'] = $pmts;
            $html = $this->fetch('admin/return_product/rchange/show_pmt.html');
            echo $html;exit;
        }
    }


    /**
     * 计算补差价金额
     * @author chenping<chenping@shopex.cn>
     **/
    public function calDiffAmount($reship_id,$return_type){
        $archive_ordObj = kernel::single('archive_interface_orders');
        $post = kernel::single('base_component_request')->get_post();
        $is_check = $post['is_check'];

        $reshipObj = app::get('ome')->model('reship');
        $reship_detail = $reshipObj->dump(array('reship_id'=>$reship_id),'archive,shop_id');
        $post['archive'] = $reship_detail['archive'];
        # 进行数量判断
        if (isset($post['return']['goods_bn']) && is_array($post['return']['goods_bn'])) {
            foreach ($post['return']['goods_bn'] as $pbn) {
                if ($is_check == '11') {
                    if ($post['return']['normal_num'][$pbn] > $post['return']['effective'][$pbn]) {
                        $error = array(
                            'error' => "货品【{$pbn}】的入库数量大于可退入数量!",
                        );
                        break;
                    }
                }else{
                    if ($post['return']['num'][$pbn] > $post['return']['effective'][$pbn]) {
                        $error = array(
                            'error' => "货品【{$pbn}】的申请数量大于可退入数量!",
                        );
                        break;
                    }
                }

            }
            if ($error) {
                echo json_encode($error);exit;
            }
        }

        $post["shop_id"] = $reship_detail["shop_id"];
        //格式化换货数据
        $rchangeObj    = kernel::single('ome_return_rchange');
        $post          = $rchangeObj->format_rchange_data($post);

        $money = kernel::single('ome_return_rchange')->calDiffAmount($post);
        $moneyValue = $money;
        $curModel = app::get('eccommon')->model('currency');
        foreach ($money as $key => &$value){
            #货币格式化
            if($key != 'tnums' && $key != 'change_nums'){
                $value = $curModel->changer($value);
            }
        }
        $money['mvalue'] = $moneyValue;
        # 判断退款金额是否大于订单金额
        if ($post['order_id']) {
            $source = $_GET['source'];
            if ($source && in_array($source,array('archive')) || $post['archive'] =='1') {
                $orderInfo = $archive_ordObj->getOrder_list(array('order_id'=>$post['order_id']),'total_amount,payed,pay_status');
            }else{
                $orderInfo = $this->app->model('orders')->getList('total_amount,payed,pay_status',array('order_id'=>$post['order_id']),0,1);
            }
            
            if($orderInfo[0]['pay_status'] == '5'){ //全额退款订单
                $money['tmoney'] = '￥0.00';
                $money['totalmoney'] = '￥0.00';
                $money['mvalue']['tmoney'] = 0.00;
                $money['mvalue']['totalmoney'] = 0.00;
                $moneyValue['totalmoney'] = 0.00;
                if($post['bcmoney'] > $orderInfo[0]['payed']){
                    $error = array('error' => "订单已经全额退款,补偿费用不能大于订单的已支付金额!");
                    echo json_encode($error);exit;
                }
            }
            
            if ($moneyValue['totalmoney']-$post['bcmoney']>$orderInfo[0]['payed']) {
                $error = array(
                    'error' => "退款金额不能大于订单的已支付金额!",
                );
                echo json_encode($error);exit;
            }
            if ($return_type == 'return' && $moneyValue['totalmoney']<0) {
                $error = array(
                    'error' => "退款金额不能小于零!",
                );
                echo json_encode($error);exit;
            }
            if ($return_type == 'change' && $money['change_nums'] > $money['tnums']){
                $error = array(
                    'error' => "换货总数量不可以大于退货申请数量!",
                );
                echo json_encode($error);exit;
            }
        }

        echo json_encode($money);exit;

    }

    //更新(物流公司和单号)
    public function update_reship($reship_id){
        $finder_id = $_GET['finder_id'];
        $this->begin();
        if (!$reship_id) {
            $this->end(false,$this->app->_('退换货单不存在!'));
        }

        $post = kernel::single('base_component_request')->get_post();
        if (empty($post['return_logi_no'])) {
            $this->end(false,$this->app->_('物流单号不能为空!'));
        }
        if (empty($post['return_logi_name'])) {
            $this->end(false,$this->app->_('物流公司不能为空!'));
        }

        $reshipModel = $this->app->model('reship');
        $isExit = $reshipModel->getList('reship_id',array('return_logi_no'=>$post['return_logi_no'],'reship_id|noequal'=>$reship_id,'is_check|noequal'=>'5'));
        if ($isExit) {
            //$this->end(false,$this->app->_('物流单号已经存在!'));
        }

        $post = kernel::single('base_component_request')->get_post();
        $reshipUpdate = array(
            'return_logi_no' => $post['return_logi_no'],
            'return_logi_name' => $post['return_logi_name'],
        );
        
        //update
        $affect_row = $reshipModel->update($reshipUpdate,array('reship_id'=>$reship_id));
        if(!is_numeric($affect_row) || $affect_row <= 0){
            $this->end(false, $this->app->_('更新物流单号失败!'));
        }
        $result = true;
        
        # 记LOG
        //$corp = $this->app->model('dly_corp')->getList('name',array('corp_id'=>$post['return_logi_name']),0,1);
        $oOperation_log = $this->app->model('operation_log');
        $memo = '更改退回物流单号('.$post['return_logi_no'].'),退回物流公司('.$post['return_logi_name'].')';
        $oOperation_log->write_log('reship@ome',$reship_id,$memo);

        $msg = $result ? $this->app->_('更新成功!') : $this->app->_('更新失败');
        $this->end($result,$msg);
    }

    /**
     * @description 选择补差价订单
     * @param Int $order_id 原订单ID
     * @param Int $page 页码
     */
    public function selectDiffOrder($order_id,$page=1){
        if(empty($order_id)){
            $result = array(
                'error' => $this->app->_('退货订单不存在!'),
            );
            echo '退货订单不存在!';exit;
        }

        $pagelimit = 20;

        $orderModel = $this->app->model('orders');
        $order = $orderModel->getList('member_id,total_amount,shop_id',array('order_id'=>$order_id),0,1);
        if (!$order) {
            $archive_ordObj = kernel::single('archive_interface_orders');
            $order = $archive_ordObj->getOrder_list(array('order_id'=>$order_id),'member_id,total_amount,shop_id');
            if (!$order) {
                $result = array(
                'error' => $this->app->_('退货订单信息不存在!'),
                );
                echo '退货订单信息不存在!';exit;
            }
        }

        # 查询该会员的所有订单
        $filter = array(
            'member_id' => $order[0]['member_id'],
            //'total_amount|lthan' => $order[0][''],
            'pay_status' => '1',
            'ship_status' => '0',
            'status'  => 'active',
            'process_status' => 'unconfirmed',
            'shop_id' => $order[0]['shop_id'],
            'order_id|noequal' => $order_id,
        );
        $diffOrders = $orderModel->getList('order_id,order_bn,total_amount,cost_freight,cost_protect,tostr,shop_id,member_id,createtime,pay_status,ship_status',$filter,($page-1)*$pagelimit,$pagelimit,'createtime desc');

        if ($diffOrders) {
            foreach ($diffOrders as $key=>$diffOrder) {
                $diffOrders[$key]['uname'] = &$members[$diffOrder['member_id']];
                $diffOrders[$key]['shop_name'] = &$shops[$diffOrder['shop_id']];
                $diffOrders[$key]['pay_status'] = $orderModel->schema['columns']['pay_status']['type'][$diffOrder['pay_status']];
                $diffOrders[$key]['ship_status'] = $orderModel->schema['columns']['ship_status']['type'][$diffOrder['ship_status']];

                $member_ids[] = $diffOrder['member_id'];
                $shop_ids[] = $diffOrder['shop_id'];
            }

            $memberModel = $this->app->model('members');
            $memberList = $memberModel->getList('member_id,uname,name',array('member_id'=>$member_ids));
            foreach ($memberList as $key=>$member) {
                $members[$member['member_id']] = $member['uname'];
            }

            $shopModel = $this->app->model('shop');
            $shopList = $shopModel->getList('shop_id,name',array('shop_id' => $shop_ids));
            foreach ($shopList as $key=>$shop) {
                $shops[$shop['shop_id']] = $shop['name'];
            }

            $this->pagedata['diffOrders'] = $diffOrders;

            $count = $orderModel->count($filter);

            $totalpage = ceil($count/$pagelimit);
            $pager = $this->ui()->pager(array(
                'current'=>$page,
                'total'=>$totalpage,
                'link'=>'javascript:gotopage(%d);',
            ));
            $this->pagedata['pager'] = $pager;
        }

        $this->pagedata['order_id'] = $order_id;

        if ($page==1) {
            $view = 'admin/return_product/rchange/diff_orders.html';
        }else{
            $view = 'admin/return_product/rchange/diff_orders_container.html';
        }
        $this->display($view);
    }

    /**
     * @description 补差价订单选定确认
     * @access public
     */
    public function diffOrderSelected(){
        $post = kernel::single('base_component_request')->get_post();
        $order = kernel::single('ome_return_rchange')->diffOrderValidate($post,$errormsg);
        if ($order === false) {
            $this->pagedata['errormsg'] = $errormsg;
        }
        $this->pagedata['order'] = $order;
        $this->display('admin/return_product/rchange/diff_orders_confirm.html');
    }

    /**
     * @description 质检异常处理页
     * @access public
     */
    public function processException($reship_id){
        $reshipModel = $this->app->model('reship');
        $reason = $reshipModel->select()->columns('reason')->where('reship_id=?',$reship_id)->instance()->fetch_one();
        $reason = unserialize($reason);
        $this->pagedata['reason'] = $reason['sv'];
        $this->pagedata['reship_id'] = $reship_id;
        $this->display('admin/return_product/rchange/process_exception.html');
    }

    /**
     * @description质检异常确认
     * @access public
     */
    public function doException(){
        $this->begin();
        $reship_id = $_POST['reship_id'];
        if (!$reship_id) {
            $this->end(false,$this->app->_('退换货单据不存在!'));
        }
        $op_info = kernel::single('ome_func')->getDesktopUser();
        $reshipModel = $this->app->model('reship');
        $row = $reshipModel->select()->columns('reason,is_check')->where('reship_id=?',$reship_id)->instance()->fetch_row();
        if ($row['is_check'] == '10') {
            $this->end(false,'对不起！该单据已经置为异常!');
        }
        $reason = $row['reason'];
        $reason = (array)unserialize($reason);
        $reason['sv'][] = array(
            'op_id' => $op_info['op_id'],
            'op_name' => $op_info['op_name'],
            'reason' => $_POST['reason'],
            'createtime' => time(),
        );
        $updateData = array(
            'reason' => serialize($reason),
            'is_check' => '10',
        );
        $reshipModel->update($updateData,array('reship_id'=>$reship_id));
        # 写日志
        $this->app->model('operation_log')->write_log('reship@ome',$reship_id,'质检异常，重新审核');
        $this->end(true);
    }

    /**
     * 发送退货单至第三方
     * @author sunjing@shopex.cn
     */
    function batch_sync(){
        $this->begin('');
        kernel::database()->exec('commit');
        $ids = $_POST['reship_id'];
        $oReship = app::get('ome')->model('reship');
        if ($ids) {
            foreach ($ids as $reship_id ) {
                $reship_list = $oReship->dump(array($reship_id=>$reship_id,'is_check'=>1),'reship_id');
                if ($reship_list) {
                    $reship_data = kernel::single('ome_receipt_reship')->reship_create(array('reship_id'=>$reship_id));
                    $wms_id = kernel::single('ome_branch')->getWmsIdById($reship_data['branch_id']);
                    kernel::single('console_event_trigger_reship')->create($wms_id, $reship_data, false);
                }
            }
        }
        $this->end(true, '命令已经被成功发送！！');
    }

    /**
     * 获取换货明细
     * @access  public
     * @author sunjing@shopex.cn
     */
    function getchangeProducts($reship_id){
        $changebranch_id = $_GET['changebranch_id'];
        $rchangeobj = kernel::single('ome_return_rchange');
        $changelist = $rchangeobj->getChangelist($reship_id,$changebranch_id);
        echo json_encode($changelist);
    }

     /**
     * @param Int $order_id 订单ID
     * @param array 返回订单明细
     */
    function get_Orderdata($order_id,$source){

        $newItems = array();
        $tmp_product = array();
        $archive_ordObj = kernel::single('archive_interface_orders');
        if ($source == 'archive') {
            $order_object = $archive_ordObj->getOrder_object(array('order_id'=>$order_id),'*');
            $items = $archive_ordObj->getItemList($order_id);
        }else{
            $oOrders_item = $this->app->model ( 'order_items' );
            $order_object = $this->app->model('order_objects')->getList('*',array('order_id'=>$order_id));
            $items = $oOrders_item->getList ( '*', array ('order_id' => $order_id ),0,-1,'obj_id desc' );
        }
        $oReship_item = $this->app->model ( 'reship_items' );
        foreach($order_object as $object){
            $table = '<table><caption>捆绑信息</caption><thead><tr><th>基础物料编码</th><th>基础物料名称</th><th>价格</th><th>数量</th></tr></thead><tbody><tr>';
            $table .= '<td>'.$object['bn'].'</td><td>'.$object['name'].'</td><td>'.$object['price'].'</td><td>'.$object['quantity'].'</td>';
            $table .= '</tr></tbody></table>';
            $object['ref'] = $table;
            $oObject[$object['obj_id']] = $object;
        }
        $reshipObj = $this->app->model('reship');
        $tmpsale = $reshipObj->getSalepriceByorderId($order_id);
        $color = array('red','blue');
        foreach ( $items as $k => $v ) {
             $str_spec_value = '';
             $spec_info = unserialize($v['addon']);
             if(!empty($spec_info['product_attr'])){
                 foreach($spec_info['product_attr'] as $_val){
                     $str_spec_value .= $_val['value'].'|';
                 }
                 if(!empty($str_spec_value)){
                     $str_spec_value = substr_replace($str_spec_value,'',-1,1);
                 }
                 $items [$k]['spec_value'] = $str_spec_value;
             }

            if (!$objColor[$v['obj_id']]) {
                $objColor[$v['obj_id']] = $c = array_shift($color);
                array_push($color,$c);
            }

            //if($newItems[$v['bn']] && $newItems[$v['bn']]['bn'] !=''){
                   // $newItems[$v['bn']]['nums'] += $items[$k]['nums'];
                    //$newItems[$v['bn']]['sendnum'] += $items[$k]['sendnum'];
            //}else{
                if ($source == 'archive') {
                    $refund = $archive_ordObj->Get_refund_count ( $order_id, $v ['bn'] );
                    $items [$k] ['branch'] = $archive_ordObj->getBranchCodeByBnAndOd ( $v ['bn'], $order_id );
                }else{
                    $refund = $oReship_item->Get_refund_count ( $order_id, $v ['bn'],'',$v['item_id'] );
                    $items [$k] ['branch'] = $oReship_item->getBranchCodeByBnAndOd ( $v ['bn'], $order_id );
                }
               
                $items [$k] ['effective'] = $refund;
                $items [$k]['obj_type'] = $oObject[$v['obj_id']]['obj_type'];
                if ($oObject[$v['obj_id']]['ref']) {
                    $items [$k]['ref'] = $oObject[$v['obj_id']]['ref'];
                    $items [$k]['color'] = $objColor[$v['obj_id']];
                }

                $items[$k]['sale_price'] = $tmpsale[$oObject[$v['obj_id']]['bn']][$v['bn']] >0 ? $tmpsale[$oObject[$v['obj_id']]['bn']][$v['bn']] : $items[$k]['sale_price'];
                $items[$k]['order_item_id'] = $v['item_id'];
                $newItems[] = $items[$k];
           // }
        }



        return $newItems;

    }

    public function checkCancel($reship_id){
        $reshipObj = app::get('ome')->model('reship');
        $reship_detail = $reshipObj->dump(array('reship_id'=>$reship_id), 'is_check,branch_id,reship_bn');
        if ($reship_detail['is_check']=='0'){
            $result = array('rsp'=>'succ');

        }else{//其它状态。需要发送第三方

            $wms_id = kernel::single('ome_branch')->getWmsIdById($reship_detail['branch_id']);
            $branch = kernel::single('ome_branch')->getBranchInfo($reship_detail['branch_id'],'branch_bn,storage_code');
            $data = array(
                'reship_bn' =>  $reship_detail['reship_bn'],
                'branch_bn' =>  $branch['branch_bn'],
            );
            $result = kernel::single('console_event_trigger_reship')->cancel($wms_id, $data, true);

        }

        echo json_encode($result);
    }
    
    public function batch_approve(){
        $reshipObj = app::get('ome')->model('reship');
    
        //获取可操作数据
        $filter = array('reship_id'=>$_POST['reship_id'], 'return_type'=>array('return','change'), 'is_check'=>'0', 'status'=>'ready');
        $dataList = $reshipObj->getList('reship_id', $filter, 0, 100);
        
        $sdf = array();
        if($dataList){
            foreach ($dataList as $key => $val){
                $sdf[] = $val['reship_id'];
            }
        }
        
        $this->pagedata['need_return_list'] = json_encode($sdf);
        $this->pagedata['need_return_list_count'] = count($sdf);
        $this->pagedata['finder_id'] = $_GET['finder_id'];
    
        $this->display('admin/return_product/rchange/batch_approve.html');
    }
    
    /**
     * 请求执行可操作
     * @param
     * @return
     * @access  public
     * @author cyyr24@sina.cn
     */
    function ajax_batch_approve()
    {
        set_time_limit(0);
        
        $reshipLib = kernel::single('ome_reship');
        
        $result = array('rsp'=>'fail', 'error_msg'=>'');
        
        //post
        $reship_id = intval($_POST['reship_id']);
        if(!$reship_id){
            $result['error_msg'] = '无效操作!';
            echo(json_encode($result));
            exit;
        }
        
        //执行审核
        $params = array('reship_id'=>$reship_id, 'status'=>'1', 'is_anti'=>false, 'exec_type'=>2);
        $confirm = $reshipLib->confirm_reship($params, $error_msg);
        if(!$confirm){
            $result['error_msg'] = $error_msg;
            echo(json_encode($result));
            exit;
        }
        
        //return
        $result = array('rsp'=>'succ', 'error_msg'=>'');
        echo(json_encode($result));
        exit;
    }
    
    function exportTemplate(){
        header("Content-Type: text/csv");
        header("Content-Disposition: attachment; filename=Reship".date('Ymd').".csv");
        header('Cache-Control:must-revalidate,post-check=0,pre-check=0');
        header('Expires:0');
        header('Pragma:public');
        $pObj = app::get('ome')->model('reship');
        $title1 = $pObj->exportTemplate('import_reship');
        echo '"'.implode('","',$title1).'"';
        $title2 = $pObj->exportTemplate('import_reship_return_item');
        echo "\n\n";
        echo '"'.implode('","',$title2).'"';
        $title3 = $pObj->exportTemplate('import_reship_change_item');
        echo "\n\n";
        echo '"'.implode('","',$title3).'"';
    }
    
}
