<?php
/**
 * 仓库类型Lib
 * @author xiayuanjun
 * @version 1.0
 */
class ome_branch_type{

    static private $__instance = null;

    static private $__branches = array();

    function __construct(){
        if(!isset(self::$__instance)){
            self::$__instance = app::get('ome')->model('branch');
        }
    }

    /**
     *
     * 获取自建类型的仓库id列表
     * @param null
     * @return array $__branches['ownIds'] 自建仓库id列表数据
     */
	public function getOwnBranchIds(){
        if(!isset(self::$__branches['ownIds'])){
            $tmpBranchList = self::$__instance->getList('branch_id',array('owner'=>'1'));

            $tmpBranchIds = array();
            foreach ($tmpBranchList as $key => $value) {
                $tmpBranchIds[] = $value['branch_id'];
            }
            self::$__branches['ownIds'] = $tmpBranchIds;
        }
        return self::$__branches['ownIds'];
	}

    /**
     *
     * 获取自建类型的仓库列表
     * @param null
     * @return array $__branches['own'] 自建仓库列表数据
     */
	public function getOwnBranchLists(){
        if(!isset(self::$__branches['own'])){
            self::$__branches['own'] = self::$__instance->getList('branch_id,branch_bn,name',array('owner'=>'1'));
        }else{
            return self::$__branches['own'];
        }
	}

    /**
     *
     * 获取第三方类型的仓库列表
     * @param null
     * @return array $__branches['other'] 第三方仓库列表数据
     */
	public function getOtherBranchLists(){
        if(!isset(self::$__branches['other'])){
            self::$__branches['other'] = self::$__instance->getList('branch_id,branch_bn,name',array('owner'=>'2'));
        }else{
            return self::$__branches['other'];
        }
	}

    public function getBranchIdByStoreCode($storeCode, $type = '3pl') {
        $branchBn = (array) $storeCode;
        $arrBranch = array();
        $delivBranch = app::get('ome')->model("branch")->getDelivBranch();
        $branchR = app::get('ome')->model('branch_relation')->getList('branch_id,relation_branch_bn',
            array('relation_branch_bn'=>$branchBn, 'type'=>$type));
        foreach($branchR as $val) {
            if(!$arrBranch[$val['relation_branch_bn']] && $delivBranch[$val['branch_id']]) {
                $arrBranch[$val['relation_branch_bn']] = $val['branch_id'];
            }
        }
        $branch = app::get('ome')->model('branch')->getList('branch_id,branch_bn', array('branch_bn'=>$branchBn));
        foreach($branch as $val) {
            if(!$arrBranch[$val['branch_bn']] && $delivBranch[$val['branch_id']]) {
                $arrBranch[$val['branch_bn']] = $val['branch_id'];
            }
        }
        // $branchRelation = app::get('wmsmgr')->model('branch_relation')->getList('*', array('wms_branch_bn'=>$branchBn));
        // foreach($branchRelation as $val) {
        //     if(!$arrBranch[$val['wms_branch_bn']] && $delivBranch[$val['branch_id']]){
        //         $arrBranch[$val['wms_branch_bn']] = $val['branch_id'];
        //     }
        // }
        return $arrBranch;
    }
    
    public function isAppointBranch($order) {
        $boolType = $order['order_bool_type'];

        if(kernel::single('ome_order_bool_type')->isJITX($boolType)) {
            return 'vopjitx';
        }

        return false;
    }
}