<?php
/**
 * vop发货数据
 *
 * @category
 * @package
 * @author sunjing@shopex.cn
 * @version $Id: Z
 */
class ome_event_trigger_shop_data_delivery_vop extends ome_event_trigger_shop_data_delivery_common
{
    public function get_sdf($delivery_id)
    {
        $this->__sdf = parent::get_sdf($delivery_id);
        $delivery = $this->__deliverys[$delivery_id];
      
        if ($delivery['type'] == 'vopczc') {
            $this->__sdf['logi_no']   = $order['order_bn'];
        }
        $this->_get_split_sdf($delivery_id);
        if ($this->__sdf['is_split'] == 1) {
            $this->_get_delivery_items_sdf($delivery_id, true);
            if(empty($this->__sdf['delivery_items'])) {
                return array();
            }
        } else {
            $this->_get_delivery_items_sdf($delivery_id);
        }
        
        if ($this->__sdf) {
            $delivery_bill_detail = $this->_get_delivery_bill_detail($delivery_id);
            $delivery_bill_items = array();
        	foreach ($delivery_bill_detail as $d_b_detail) {
        		if ($d_b_detail['logi_no']) {
                    //
                    $delivery_items = $this->__sdf['delivery_items'];

                    foreach($delivery_items as $v){
                        if($v['delivery_id'] == $delivery_id){
                            $delivery_bill_items[] = array(

                                'logi_no'	=>	$d_b_detail['logi_no'],
                                'number'        => 0,
                              
                                'shop_goods_id' => $v['shop_goods_id'],

                            );
                        }
                    }
        		}
        	}
            if ($delivery_bill_items) $this->__sdf['delivery_bill_items'] = $delivery_bill_items;
        }

        return $this->__sdf;
    }

    protected function _get_delivery_items_sdf($delivery_id, $allDelivery = false)
    {
        $delivery_items = array();

        if($allDelivery) {
            $delivery_items_detail = $this->_get_delivery_items_detail_order($delivery_id);
        } else {
            $delivery_items_detail = $this->_get_delivery_items_detail($delivery_id);
        }
        $order_objects         = $this->_get_order_objects($delivery_id);
        $pkg_nums = array();
        foreach ($delivery_items_detail as $key => $value) {
            $order_item = $order_objects[$value['order_obj_id']]['order_items'][$value['order_item_id']];

            if ($value['item_type'] == 'pkg') {
                $number = $order_objects[$value['order_obj_id']]['quantity']*$value['number']/$order_item['nums'];
                $number = ceil($number);
                if (isset($pkg_nums[$value['order_obj_id']])){
                     if($pkg_nums[$value['order_obj_id']]>=$order_objects[$value['order_obj_id']]['quantity']){
                           $number=0;
                     }

                     $pkg_nums[$value['order_obj_id']]+=$number;
                }else{
                    $pkg_nums[$value['order_obj_id']]=$number;
                }
                $delivery_items[] = array(
                    'name'          => trim($order_objects[$value['order_obj_id']]['name']),
                    'bn'            => trim($order_objects[$value['order_obj_id']]['bn']),
                    'number'        => $number,
                    'item_type'     => $value['item_type'],
                    'shop_goods_id' => $order_objects[$value['order_obj_id']]['shop_goods_id'],
                    'oid'           => $order_objects[$value['order_obj_id']]['oid'],
                    'logi_no'       => $value['logi_no'] ? $value['logi_no'] : $this->__sdf['logi_no'],
                    'logi_type'     => $value['logi_type'] ? $value['logi_type'] : $this->__sdf['logi_type'],
                    'logi_name'     => $value['logi_name'] ? $value['logi_name'] : $this->__sdf['logi_name'],
                    'delivery_id'   =>$value['delivery_id'],
                );

            } else {
                $delivery_items[] = array(
                    'name'          => trim($order_objects[$value['order_obj_id']]['name']),
                    'bn'            => trim($value['bn']),
                    'number'        => $value['number'],
                    'item_type'     => $value['item_type'],
                    'shop_goods_id' => $order_item['shop_goods_id'],
                    'shop_product_id' => $order_item['shop_product_id'],
                    'promotion_id'  => $order_item['promotion_id'],
                    'oid'           => $order_objects[$value['order_obj_id']]['oid'],
                    'nums'          => $order_item['nums'],
                    'sendnum'       => $order_item['sendnum'],
                    'logi_no'         => $value['logi_no'] ? $value['logi_no'] : $this->__sdf['logi_no'],
                    'logi_type'       => $value['logi_type'] ? $value['logi_type'] : $this->__sdf['logi_type'],
                    'logi_name'     => $value['logi_name'] ? $value['logi_name'] : $this->__sdf['logi_name'],
                    'delivery_id'   =>$value['delivery_id'],
                );
            }
        }

        $this->__sdf['delivery_items'] = $delivery_items;
    }
}