<?php
/**
 * @author ykm 2017/1/13
 * @describe 订单种类二进制常量类
 */

class ome_order_bool_type {
    #是否是服务订单
    const __SERVICE_CODE        = 0x0001;
    #菜鸟自动流转订单
    const __CNAUTO_CODE         = 0x0002;

    #跨境订单
    const __INTERNAL_CODE       = 0x0008;

	 #当日达
    const __CNDANG_CODE         = 0x0010;
    #次日达
    const __CNCI_CODE           = 0x0020;
    #预计时效表达
    const __CNSHI_CODE          = 0x0040;
    #预约配送
    const __CNYUE_CODE          = 0x0080;
    #多日达
    const __CNDUO_CODE          = 0x0100;
    
    #催发货
    const __URGENT_DELIVERY = 0x0200;
    
    //双十一预约退款
    const __BOOKING_REFUND = 0x0800;

    #天猫直送3pl
    const __3PL_CODE         = 0x0400;
    #风控订单
    const __RISK_CODE        = 0x2000;

        #唯品会JITX
    const __JITX_CODE           = 0x1000;

    private $boolStatus = array(
        self::__SERVICE_CODE => array('identifier'=>'服', 'text'=>'服务订单', 'color'=>'green'),
        self::__CNAUTO_CODE => array('identifier'=>'菜', 'text'=>'菜鸟自动流转订单', 'color'=>'yellow'),
        self::__INTERNAL_CODE => array('identifier'=>'跨', 'text'=>'跨境订单', 'color'=>'red'),

        self::__CNDANG_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟当日达订单', 'color'=>'#938F5C'),
        self::__CNCI_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟次日达订单', 'color'=>'#938F5C'),
        self::__CNSHI_CODE => array('identifier'=>'直', 'text'=>'预计时效表达订单', 'color'=>'#938F5C'),
        self::__CNYUE_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟预约配送订单', 'color'=>'#938F5C'),
        self::__CNDUO_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟多日达订单', 'color'=>'#938F5C'),
        self::__BOOKING_REFUND => array('identifier'=>'退','text'=>'预约退款订单','color'=>'blue','search'=>'true'),
        
        self::__URGENT_DELIVERY => array('identifier'=>'催', 'text'=>'催发货订单', 'color'=>'red', 'search'=>'true'),
        self::__3PL_CODE => array('identifier'=>'时', 'text'=>'天猫3PL订单', 'color'=>'#F18A50'),
        self::__RISK_CODE        => array('identifier'=>'风', 'text'=>'风控订单', 'color'=>'#E438A0'),
        self::__JITX_CODE => array('identifier'=>'JITX', 'text'=>'JITX订单', 'color'=>'#0F82A1'),
    );


    public function getBoolTypeText($num = null) {
        if($num) {
            return (array) $this->boolStatus[$num];
        }
        return $this->boolStatus;
    }

    public function getBoolTypeIdentifier($boolType) {
        $str = '';
        foreach($this->boolStatus as $k => $val) {
            if($boolType & $k) {
                $str .= sprintf("<span class='tag-label' title='%s' style='background-color:%s;color:#000000;'>%s</span>", $val['text'], $val['color'], $val['identifier']);
            }
        }
        return $str;
    }

    public function isCnService($boolType) {
        if(($boolType & ome_order_bool_type::__CNDANG_CODE)
            || ($boolType & ome_order_bool_type::__CNCI_CODE)
            || ($boolType & ome_order_bool_type::__CNSHI_CODE)
            || ($boolType & ome_order_bool_type::__CNDUO_CODE)
            || ($boolType & ome_order_bool_type::__CNYUE_CODE)){
            return true;
        }
        return false;
    }
    
    public function getOrder_type_list(){
        $order_type_list = array();
        $boolstatus = $this->boolStatus;
        foreach($boolstatus as $k=>$v){
            if ($v['search'] == 'true'){
                $order_type_list[$k]= $v['text'];
            }
        }
        return $order_type_list;
    }
    
    /**
     * 获取订单种类文字描述
     */
    public function getBoolTypeDescribe($boolType){
        $data = array();
        foreach($this->boolStatus as $k => $val) {
            if($boolType & $k) {
                $data[] = $val['text'];
            }
        }
        
        return implode('、', $data);
    }

    #是否jitx订单
    public function isJITX($boolType)
    {
        return $boolType & self::__JITX_CODE ? true : false;
    }
}