<?php
/**
 * 订单编辑时捆绑商品处理功能的实现方法
 * 对订单编辑的提交数据进行操作
 * @author chris.zhang
 * @package ome_order_edit
 * @copyright www.shopex.cn 2011.02.25
 *
 */
class ome_order_edit_pkg{
    
    protected  $config = array(
        'app'       => 'ome',
        'html'      => 'admin/order/edit/pkg_edit.html',
        'js_count'  => 'total_pkg()',
        'is_add'    => true,
        'add_title' => '添加促销类销售物料',
        'add_id'    => 'add_pkg_product',
    );
    
    /**
     * 获取捆绑商品类型页面配置
     * @return Araay conf
     */
    public function get_config(){
        return $this->config;
    }
    
    /**
     * 处理订单编辑时提交的数据
     * @access public
     * @param array $data 订单编辑的数据  //POST
     */
    public function process($data){
        if (!$data['pkg']) return false;
        
        $obj        = $data['pkg']['obj'];
        $onum       = $data['pkg']['num'];
        $oprice     = $data['pkg']['price'];
        $obj_pmt_price    = $data['pkg']['obj_pmt_price'];
        $item_pmt_price   = $data['pkg']['item_pmt_price'];
        $num        = $data['pkg']['inum'];
        $price      = $data['pkg']['iprice'];
        $order_id   = $data['order_id'];
        $newPkgONum = $data['pkg']['pkgonum'];//新增PKG
        $newPkgOPr  = $data['pkg']['pkgopr'];
        $new_obj_pmt_price  = $data['pkg']['new_obj_pmt_price'];
        $new_item_pmt_price  = $data['pkg']['new_item_pmt_price'];        
        $newPkgINum = $data['pkg']['pkgnum'];
        $newPkgIPr  = $data['pkg']['pkgpr'];
        $shop_id   = $data['shop_id'];
        
        $oPkgG      = app::get('omepkg')->model("pkg_goods");
        $oPkgP      = app::get('omepkg')->model("pkg_product");
        $oOrderItm  = app::get('ome')->model("order_items");
        $oOrderObj  = app::get('ome')->model("order_objects");

        $salesMLib = kernel::single('material_sales_material');
        $basicMStockLib = kernel::single('material_basic_material_stock');
        $basicMStockFreezeLib = kernel::single('material_basic_material_stock_freeze');

        $tmp_obj = array();
        $new_obj = array();
        
        $is_order_change = false;
        $is_goods_modify = false;
        $total = $total_pmt_goods = 0;
        //捆绑商品信息
        if ($obj && is_array($obj))
        foreach ($obj as $k =>$v){
            $tmp_obj[$k] = array('obj_id'=>$k,'pmt_price'=>$obj_pmt_price[$k]);
            $obj_ = $oOrderObj->dump($k);
           
            if (!$obj_) continue;

            if ($obj_['quantity'] != $onum[$k] || $obj_['price'] != $oprice[$k] || $obj_['pmt_price'] != $obj_pmt_price[$k]){
                $is_order_change = true;
                $is_goods_modify = true;
            }

            if (isset($onum[$k])){
                $tmp_amount = intval($onum[$k])*$oprice[$k];
                $total += $tmp_amount;
                $total_pmt_goods += $obj_pmt_price[$k];

                $oldbasicMInfos = $salesMLib->getBasicMBySalesMId($obj_['goods_id']);

                $oldpmt_price_rate = $salesMLib->calpmtpriceByRate($obj_pmt_price[$k], $oldbasicMInfos);

                if ($obj_['amount'] != $tmp_amount){
                    $is_order_change = true;
                    $is_goods_modify = true;
                }
                $tmp_obj[$k]['obj_id']           = $k;
                $tmp_obj[$k]['amount']           = $tmp_amount;
                $tmp_obj[$k]['quantity']         = intval($onum[$k]);
                $tmp_obj[$k]['price']            = $oprice[$k];
                $tmp_obj[$k]['amount']  = $tmp_obj[$k]['quantity'] * $tmp_obj[$k]['price'];
                $tmp_obj[$k]['delete'] = 'false';
                $obj_num_change = intval($onum[$k])-$obj_['quantity'];

                $tmp_item_sale_price = $tmp_item_pmt_price = $tmp_item_amount = 0;
                foreach ($v as $n){
                    $quantity = 0;
                    $oi = $oOrderItm->dump($n);
                    $pmt_price = $oldpmt_price_rate[$oi['bn']] ? $oldpmt_price_rate[$oi['bn']]['rate_price'] : '0';

                    $tmp_item_pmt_price += $pmt_price;
                    //$total_pmt_goods += $pmt_price;
                    $quantity = intval($oi['quantity'] / $obj_['quantity'])*intval($onum[$k]);
                    $item_price = $price[$n]==0 ? $oi['price'] : $price[$n];
                    $sale_price = $quantity * $item_price - $pmt_price;
                    $tmp_item_sale_price += $sale_price;
                    $tmp_item_amount += $quantity * $item_price;

                    if ($oi['quantity'] != $quantity || $oi['price'] != $item_price || $oi['pmt_price'] != $pmt_price){
                        $t_n = $quantity - $oi['quantity'];
                        if ($oi['delete'] == 'true'){
                            $basicMStockLib->freeze($oi['product_id'],$quantity);
                            $basicMStockFreezeLib->freeze($oi['product_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, $shop_id, 0, material_basic_material_stock_freeze::__SHARE_STORE, $quantity);
                        }else {
                            if ($t_n < 0){
                                $basicMStockLib->unfreeze($oi['product_id'],abs($t_n));
                                $basicMStockFreezeLib->unfreeze($oi['product_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, '', material_basic_material_stock_freeze::__SHARE_STORE, abs($t_n));
                            }elseif ($t_n > 0){
                                $basicMStockLib->freeze($oi['product_id'],abs($t_n));
                                $basicMStockFreezeLib->freeze($oi['product_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, $shop_id, 0, material_basic_material_stock_freeze::__SHARE_STORE, abs($t_n));
                            }
                        }
                        $is_order_change = true;
                        $is_goods_modify = true;
                    }elseif ($oi['delete'] == 'true'){
                        $basicMStockLib->freeze($oi['product_id'],$quantity);
                        $basicMStockFreezeLib->freeze($oi['product_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, $shop_id, 0, material_basic_material_stock_freeze::__SHARE_STORE, $quantity);
                        $is_order_change = true;
                        $is_goods_modify = true;
                    }

                    $tmp_obj[$k]['items'][$n]['item_id']    = $n;
                    $tmp_obj[$k]['items'][$n]['quantity']   = $quantity;
                    $tmp_obj[$k]['items'][$n]['price']      = $price[$n]==0?$oi['price']:$price[$n];
                    $tmp_obj[$k]['items'][$n]['delete']     = 'false';
                    $tmp_obj[$k]['items'][$n]['pmt_price']  = $pmt_price;
                    $tmp_obj[$k]['items'][$n]['sale_price']  = $sale_price;

                }

                //$tmp_obj[$k]['sale_price']  = $tmp_obj[$k]['amount'] - $obj_pmt_price[$k] - $tmp_item_pmt_price;
                $tmp_obj[$k]['sale_price']  = $tmp_obj[$k]['amount'] - $obj_pmt_price[$k];
                if ($obj_['sale_price'] != $tmp_obj[$k]['sale_price']){
                    $is_order_change = true;
                    $is_goods_modify = true;
                }
            }else {
                foreach ($v as $n){
                    $oi = $oOrderItm->dump($n);
                    if ($oi['delete'] == 'false'){
                        $basicMStockLib->unfreeze($oi['product_id'],$oi['quantity']);
                        $basicMStockFreezeLib->unfreeze($oi['product_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, '', material_basic_material_stock_freeze::__SHARE_STORE, $oi['quantity']);
                        $is_order_change = true;
                        $is_goods_modify = true;
                    }
                    $tmp_obj[$k]['items'][$n]['item_id'] = $n;
                    $tmp_obj[$k]['items'][$n]['delete']  = 'true';
                }

                $tmp_obj[$k]['delete'] = 'true';
            }
        }
        
        //新增捆绑商品
        if ($newPkgONum){
            $is_order_change = true;
            $is_goods_modify = true;
            foreach ($newPkgONum as $key => $n){
                if ($data['do_action'] != 2){
                    if ($n < 1 || $n > 499999){
                        trigger_error('数量必须大于1且小于499999', E_USER_ERROR);
                    }
                }

                $tmp_price = $newPkgOPr[$key];
                $pmt_price = $new_obj_pmt_price[$key];
                $amount = $n * $tmp_price;
                $obj_number = $n;

                $salesMInfo = $salesMLib->getSalesMById($shop_id,$key);
                if($salesMInfo){
                    $basicMInfos = $salesMLib->getBasicMBySalesMId($salesMInfo['sm_id']);
                    if($basicMInfos){
                        if($salesMInfo['sales_material_type'] == 2){
                            $obj_sale_price = $amount - $pmt_price;
                            //item层关联基础物料平摊销售价
                            $salesMLib->calProSaleMPriceByRate($obj_sale_price, $basicMInfos);

                            $pmt_price_rate = $salesMLib->calpmtpriceByRate($pmt_price, $basicMInfos);
                            $tmp = array();
                            foreach($basicMInfos as $kk => $basicMInfo){
                                $tmp['items'][] = array(
                                    'order_id'   => $order_id,
                                    'product_id' => $basicMInfo['bm_id'],
                                    'bn' => $basicMInfo['material_bn'],
                                    'name' => $basicMInfo['material_name'],
                                    'price' => $basicMInfo['rate_price'] ? bcdiv($basicMInfo['rate_price'], $basicMInfo['number']*$obj_number, 2) : 0.00,
                                    'amount' => $basicMInfo['rate_price'] ? $basicMInfo['rate_price'] : 0.00,
                                    'sale_price'=> $basicMInfo['rate_price'] ? $basicMInfo['rate_price'] : 0.00,
                                    'pmt_price'=>$pmt_price_rate[$basicMInfo['material_bn']] ? $pmt_price_rate[$basicMInfo['material_bn']]['rate_price'] : 0.00,
                                    'quantity' => $basicMInfo['number']*$obj_number,
                                    'sendnum' => 0,
                                    'item_type' => 'pkg'
                                );

                                $weight += $basicMInfo['weight']*$basicMInfo['number']*$obj_number;
                                $basicMStockLib->freeze($basicMInfo['bm_id'],$basicMInfo['number']*$obj_number);
                                $basicMStockFreezeLib->freeze($basicMInfo['bm_id'], material_basic_material_stock_freeze::__ORDER, 0, $order_id, $shop_id, 0, material_basic_material_stock_freeze::__SHARE_STORE, $basicMInfo['number']*$obj_number);
                            }

                            $tmp['order_id']    = $order_id;
                            $tmp['obj_type']    = 'pkg';
                            $tmp['obj_alias']   = '促销类';
                            $tmp['goods_id']    = $salesMInfo['sm_id'];
                            $tmp['bn']          = $salesMInfo['sales_material_bn'];
                            $tmp['name']        = $salesMInfo['sales_material_name'];
                            $tmp['price']       = $tmp_price;
                            $tmp['quantity']    = $obj_number;
                            $tmp['amount']      = $amount;
                            $tmp['weight']      = $weight;
                            $tmp['pmt_price']   = $pmt_price;
                            $tmp['sale_price']  = $obj_sale_price;

                            $new_obj[] = $tmp;
                            $total += $tmp['amount'];
                            $total_pmt_goods += $pmt_price;
                        }
                    }else{
                        continue;
                    }
                }else{
                    continue;
                }
            }
        }
        
        $rs = array(
            'oobj'  => $tmp_obj,
            'nobj'  => $new_obj,
            'total' => $total,
            'is_order_change' => $is_order_change,
            'is_goods_modify' => $is_goods_modify,
            'total_pmt_goods' => $total_pmt_goods,
        );
        return $rs;
    }
    
    /**
     * 判断这次提交的数据在处理完成后，是否还存在有正常的数据。
     * @param array $data 订单编辑的数据  //POST
     */
    public function is_null($data){
        if (!$data['pkg']) return true;
        $obj        = $data['pkg']['obj'];
        $onum       = $data['pkg']['num'];
        $oprice     = $data['pkg']['price'];
        $num        = $data['pkg']['inum'];
        $price      = $data['pkg']['iprice'];
        $newPkgONum = $data['pkg']['pkgonum'];//新增PKG
        $newPkgOPr  = $data['pkg']['pkgopr'];
        $newPkgINum = $data['pkg']['pkgnum'];
        $newPkgIPr  = $data['pkg']['pkgpr'];
        if ((empty($onum) && empty($newPkgONum)) || (empty($oprice) && empty($newPkgOPr))) return true;
        return false;
    }
    
    /**
     * 校验订单编辑时提交的数据
     * @param array $data 订单编辑的数据  //POST
     */
    public function valid($data){
        if (!$data['pkg']) return true;
        
        $obj        = $data['pkg']['obj'];
        $onum       = $data['pkg']['num'];
        $oprice     = $data['pkg']['price'];
        $obj_pmt_price     = $data['pkg']['obj_pmt_price'];
        $item_pmt_price    = $data['pkg']['item_pmt_price'];
        $new_obj_pmt_price    = $data['pkg']['new_obj_pmt_price'];
        $new_item_pmt_price   = $data['pkg']['new_item_pmt_price'];
        $num        = $data['pkg']['inum'];
        $price      = $data['pkg']['iprice'];
        $newPkgONum = $data['pkg']['pkgonum'];//新增PKG
        $newPkgOPr  = $data['pkg']['pkgopr'];
        $newPkgINum = $data['pkg']['pkgnum'];
        $newPkgIPr  = $data['pkg']['pkgpr'];
        
        
        //捆绑商品信息
        if ($obj && is_array($obj))
        foreach ($obj as $k =>$v){
            $tmp_obj[$k] = array('obj_id'=>$k);
            if (isset($onum[$k])){
                if ($onum[$k] < 1  || $onum[$k] > 99999){
                    $rs = array(
                        'flag' => false,
                        'msg' => "捆绑商品数量必须大于1且小于99999",
                    );
                    return $rs;
                }
            }

            $tmp_item_sale_price = 0;
            foreach ($v as $item_id){
                //if ($item_pmt_price[$item_id] < 0 || $item_pmt_price[$item_id] > $num[$item_id]*$price[$item_id]){
                if ($item_pmt_price[$item_id] < 0){
                    $rs = array(
                        'flag' => false,
                        'msg' => "优惠金额必须大于等于0",
                        'error_info' => array('name'=>'pkg[item_pmt_price]['.$item_id.']'),
                    );
                    return $rs;
                }
                $tmp_item_sale_price += $item_pmt_price[$item_id];
            }
            if ($obj_pmt_price[$k] < 0){
                $rs = array(
                    'flag' => false,
                    'msg' => "优惠金额必须大于等于0",
                    'error_info' => array('name'=>'pkg[obj_pmt_price]['.$k.']'),
                );
                return $rs;
            }
            if ($obj_pmt_price[$k]+$tmp_item_sale_price > $onum[$k] * $oprice[$k]){
                $rs = array(
                    'flag' => false,
                    'msg' => "优惠金额必须小于等于销售金额",
                    'error_info' => array('name'=>'pkg[obj_pmt_price]['.$k.']'),
                );
                return $rs;
            }

        }
    
        //新增捆绑商品
        if ($newPkgONum){
            foreach ($newPkgONum as $key => $n){
                if ($n < 1 || $n > 99999){
                    $rs = array(
                        'flag' => false,
                        'msg'  => "捆绑商品数量必须大于1且小于99999",
                    );
                    return $rs;
                }
                foreach ($newPkgINum[$key] as $k => $v){
                    if ($v < 1 || $v > 99999){
                        $rs = array(
                            'flag' => false,
                            'msg'  => "捆绑商品数量必须大于1且小于99999",
                        );
                        return $rs;
                    }
                }
            }
        }
        return true;
    }
    
    /**
     * 判断订单上商品明细是否被修改
     *
     * @param array $data 订单编辑的数据POST
     * @return bool
     */
    public function is_edit_product($data){
        if (!$data['pkg']) return false;
        
        $oOrderItm  = app::get('ome')->model("order_items");
        $oOrderObj  = app::get('ome')->model("order_objects");
        $salesMLib = kernel::single('material_sales_material');
        $obj        = $data['pkg']['obj'];
        $onum       = $data['pkg']['num'];
        $oprice     = $data['pkg']['price'];
        $obj_pmt_price    = $data['pkg']['obj_pmt_price'];
        $item_pmt_price   = $data['pkg']['item_pmt_price'];
        
        $num        = $data['pkg']['inum'];
        $price      = $data['pkg']['iprice'];
        $newPkgONum = $data['pkg']['pkgonum'];//新增PKG
        $order_id   = $data['order_id'];
        
        $tmp_obj = array();
        $total = $total_pmt_goods = 0;
        
        //捆绑商品信息
        if ($obj && is_array($obj)){
            foreach ($obj as $k =>$v){
                
                $tmp_obj[$k] = array('obj_id'=>$k,'pmt_price'=>$obj_pmt_price[$k]);


                
                //如果obj_id不存在，跳过
                $obj_ = $oOrderObj->dump($k);
                if (!$obj_) continue;
                
                $oldbasicMInfos = $salesMLib->getBasicMBySalesMId($obj_['goods_id']);

                $oldpmt_price_rate = $salesMLib->calpmtpriceByRate($obj_pmt_price[$k], $oldbasicMInfos);


                //捆绑商品数量或金额有变化
                if ($obj_['quantity'] != $onum[$k] || $obj_['price'] != $oprice[$k] || $obj_['pmt_price'] != $obj_pmt_price[$k]){
                    return true;
                }
                
                if (isset($onum[$k])){
                    $tmp_amount = intval($onum[$k])*$oprice[$k];
                    
                    //优惠金额变化,直接返回true
                    if ($obj_['amount'] != $tmp_amount){
                        return true;
                    }
                    
                    $tmp_obj[$k]['obj_id']           = $k;
                    $tmp_obj[$k]['amount']           = $tmp_amount;
                    $tmp_obj[$k]['quantity']         = intval($onum[$k]);
                    $tmp_obj[$k]['price']            = $oprice[$k];
                    $tmp_obj[$k]['amount']  = $tmp_obj[$k]['quantity'] * $tmp_obj[$k]['price'];
                    
                    $tmp_item_sale_price = $tmp_item_pmt_price = $tmp_item_amount = 0;
                    foreach ($v as $n){
                        $quantity = 0;
                        $oi = $oOrderItm->dump($n);
                        $pmt_price = $oldpmt_price_rate[$oi['bn']] ? $oldpmt_price_rate[$oi['bn']]['rate_price'] : '0';
                        
                        //$tmp_item_pmt_price += $pmt_price;
                        //$total_pmt_goods += $pmt_price;
                        
                        $quantity = intval($oi['quantity'] / $obj_['quantity'])*intval($onum[$k]);
                        $item_price = $price[$n]==0 ? $oi['price'] : $price[$n];
                        $sale_price = $quantity * $item_price - $pmt_price;
                        $tmp_item_sale_price += $sale_price;
                        $tmp_item_amount += $quantity * $item_price;
                        
                        if ($oi['quantity'] != $quantity || $oi['price'] != $item_price || $oi['pmt_price'] != $pmt_price){
                            return true;//数量有变化
                        }elseif ($oi['delete'] == 'true'){
                            return true;//恢复删除的商品
                        }
                        
                        $tmp_obj[$k]['items'][$n]['item_id']    = $n;
                        $tmp_obj[$k]['items'][$n]['quantity']   = $quantity;
                        $tmp_obj[$k]['items'][$n]['price']      = $price[$n]==0?$oi['price']:$price[$n];
                        $tmp_obj[$k]['items'][$n]['delete']     = 'false';
                        $tmp_obj[$k]['items'][$n]['pmt_price']  = $pmt_price;
                        $tmp_obj[$k]['items'][$n]['sale_price']  = $sale_price;
                    }
                    
                    //$tmp_obj[$k]['sale_price']  = $tmp_obj[$k]['amount'] - $obj_pmt_price[$k] - $tmp_item_pmt_price;
                    $tmp_obj[$k]['sale_price']  = $tmp_obj[$k]['amount'] - $obj_pmt_price[$k];
                    if ($obj_['sale_price'] != $tmp_obj[$k]['sale_price']){
                        return true;//金额有变化
                    }
                }else {
                    foreach ($v as $n){
                        $oi = $oOrderItm->dump($n);
                        if ($oi['delete'] == 'false'){
                            return true;//删除了商品
                        }
                    }
                }
            }
        }
        
        //新增捆绑商品
        if ($newPkgONum){
            return true;
        }
        
        return false;
    }
}