<?php
/**
 * 售后服务
 * 有关售后方面的扩展功能都可以使用此服务
 * @author dongqiujing
 * @package ome_service_aftersale
 * @copyright www.shopex.cn 2010.10.14
 *
 */
class ome_service_aftersale{
    
    public function __construct(&$app){
        $this->app = $app;
        $this->router = kernel::single('apibusiness_router_request');
    }

    /**
     * 售后申请
     * @access public
     * @param int $return_id 售后申请ID
     */
    public function add_aftersale($return_id){
        $returnModel = $this->app->model('return_product');
        $returninfo = $returnModel->dump($return_id);
        kernel::single('erpapi_router_request')->set('shop', $returninfo['shop_id'])->aftersale_addAfterSale($returninfo);
    }
    
    /**
     * 售后申请状态修改
     * @access public
     * @param int $return_id 售后申请ID
     */
    public function update_status($return_id,$status='',$mod='async',$memo=array()){
        $returnModel = $this->app->model('return_product');
        $returninfo = $returnModel->dump($return_id);
        if (is_array($memo)) {
            $returninfo['refuse_message'] = $memo['refuse_message'];
            $returninfo['refuse_proof']   = $memo['refuse_proof'];
            $returninfo['imgext']         = $memo['imgext'];
        }
        
        if($returninfo['source'] == 'matrix' && $returninfo['shop_type'] == 'tmall'){
            #拒绝退货的
            if($status == '5'){
                #没有凭证的，不再往前端打请求，避免二次请求
                if(empty($memo)){
                    return true;
                }
            }
            if ($status == '5' && $memo['refund_type']=='change'){//换货拒绝
                $status = '9';
                $returninfo['seller_refuse_reason_id'] = $memo['seller_refuse_reason_id'];
            }
        }

        // 订单
        $returninfo['order'] = app::get('ome')->model('orders')->db_dump($returninfo['order_id']);

        // 退货地址库
        // $returninfo['return_address'] = app::get('ome')->model('return_address')->db_dump(array ('shop_id' => $['shop_id']));


        if ($returninfo['source'] == 'matrix' && in_array($returninfo['shop_type'],array('bbc','ecos.b2c','ecos.b2b2c.stdsrc','360buy'))){
            $returninfo['memo'] = $memo;
        }
        $rs = kernel::single('erpapi_router_request')->set('shop', $returninfo['shop_id'])->aftersale_updateAfterSaleStatus($returninfo,$status,$mod);
        if ($mod == 'sync') {
            return $rs;
        }
    }

    /**
     * 退款留言
     * @access  public
     * @author cyyr24@sina.cn
     */
    function refund_message($apply_id,$type){
        $data = array();
        if (in_array($type,array('return','change'))) {
            $oReturn = $this->app->model('return_product');
            $oReturn_tmall = $this->app->model('return_product_tmall');
            $return = $oReturn->dump($apply_id);
            $shop_id = $return['shop_id'];
            $data['refund_bn'] = $return['return_bn'];
            $return_tmall = $oReturn_tmall->dump(array('return_bn'=>$return['return_bn'],'shop_id'=>$shop_id));
            if ($return_tmall) {
                $data['refund_phase'] = $return_tmall['refund_phase'];
                $data['refund_version'] = $return_tmall['refund_version'];
            }
            $data['tmall_type'] = $type;
        }else{
            $oRefund = $this->app->model('refund_apply');
            $refund = $oRefund->dump($apply_id);
            $shop_id = $refund['shop_id'];
            $refund_bn = $refund['refund_apply_bn'];
            $oRefund_tmall = $this->app->model('refund_apply_tmall');
            $refund_tmall = $oRefund_tmall->dump(array('apply_id'=>$apply_id,'shop_id'=>$shop_id));
            
            if ($refund_tmall) {
                $data['refund_phase'] = $refund_tmall['refund_phase'];
                $data['refund_version'] = $refund_tmall['refund_version'];
            }
            $data['refund_bn'] = $refund_bn;
        }
        $rs = kernel::single('erpapi_router_request')->set('shop', $shop_id)->finance_getRefundMessage($data);
         if($rs){
            if($rs['rsp'] == 'succ'){
                $tmp = $rs['data'];
                $tmp = $tmp['refund_messages']['refund_message'];
                
                 foreach ($tmp as $tk=>$tv) {
                    if (isset($tv['pic_urls'])) {
                        $tmp[$tk]['voucher_urls'] = $tv['pic_urls']['pic_url'][0]['url'];
                    }
                }
                return $tmp;
            }else{
                return false;
            }
        }else{
            return false;
        }
    }
    
    /**
     * 拒绝退货
     * @access  public
     * @author cyyr24@sina.cn
     */
    function refuse_return($returninfo){
        $returnModel = $this->app->model('return_product');
        $return_id = $returninfo['return_id'];
        $return = $returnModel->dump($return_id);
        $returninfo['return_bn'] = $return['return_bn'];
        $returninfo['order_id'] = $return['order_id'];
        $result = $this->router->setShopId($return['shop_id'])->refuse_return($returninfo);
        $rs = array('rsp'=>'fail','msg'=>'失败');
        if($result){
            if($result->rsp == 'succ'){
                $rs['rsp'] = 'succ';
                $rs['msg'] = '成功';
            }else{
                $rs['msg'] = $result->err_msg;
            }
        }
        return $rs;
    }

    /**
     * Short description.
     * @access  public
     * @author cyyr24@sina.cn
     */
    function searchAddress($shop_id,$rdef=''){
        kernel::single('erpapi_router_request')->set('shop', $shop_id)->logistics_searchAddress($rdef);

        return true;
    }
    
    /**
     * 退货回填物流单号.
     * @access  public
     * @author cyyr24@sina.cn
     */
    function update_return_logistics($reship_id){
        $oReship = $this->app->model('reship');
        $reshipinfo = $oReship->dump($reship_id);
        $rs = kernel::single('erpapi_router_request')->set('shop', $reshipinfo['shop_id'])->logistics_updateReturnLogistics($reshipinfo);
    }

    /**
     * 拒绝理由获取
     *  sunjing@shopex.cn
     */
    public function refuse_reason($return_id){
        $returnModel = $this->app->model('return_product');
        $returninfo = $returnModel->dump(array('return_id'=>$return_id,'source'=>'matrix','return_type'=>'change'),'return_bn,return_id,shop_id');
        if ($returninfo){
            $rs = kernel::single('erpapi_router_request')->set('shop', $returninfo['shop_id'])->aftersale_getRefuseReason($returninfo);

            if($rs){
                if($rs['rsp'] == 'succ'){
                    $tmp = $rs['data']['exchange']['exchange_refusereason'];
                    $return_model = $this->app->model('return_product_tmall');
                    $return_model->update(array('refusereason'=>json_encode($tmp)),array('return_id'=>$return_id));

                    return $tmp;
                }else{
                    return false;
                }
            }else{
                return false;
            }
        }

    }

    /**
    * 根据售后单信息返回换货单类型相关信息
    * sunjing@shopex.cn
    */
    public function get_return_type($returninfo){

        $tmallObj = app::get('ome')->model('return_product_tmall');
        $tmall_detail = $tmallObj->dump(array('return_id'=>$returninfo['return_id'],'refund_type'=>'change'),'*');

        return $tmall_detail;

    }

    /**
    * 卖家确认收货
    *
    */
    public function returngoods_agree($return_id){
        $returnModel = $this->app->model('return_product');
        $returninfo = $returnModel->dump(array('return_id'=>$return_id,'source'=>'matrix','return_type'=>'change'),'return_bn,return_id,shop_id,return_type');
        if($returninfo){
            $params = array(
                'dispute_id'    =>  $returninfo['return_bn'],

            );
            $rs = kernel::single('erpapi_router_request')->set('shop', $returninfo['shop_id'])->aftersale_returnGoodsAgree($params);
        }


    }

    /**
    *
    * 卖家拒绝确认收货
    */
    public function returngoods_refuse($data){
        $return_bn = $data['dispute_id'];
        $returnObj = app::get('ome')->model('return_product');
        $return_detail = $returnObj->dump(array('return_bn'=>$return_bn,'source'=>'matrix','return_type'=>'change'),'shop_id,return_id,order_id');
        if ($return_detail){
            $data['shop_id'] = $return_detail['shop_id'];
            $data['return_id'] = $return_detail['return_id'];
            $data['order_id'] = $return_detail['order_id'];

        $rs = kernel::single('erpapi_router_request')->set('shop', $return_detail['shop_id'])->aftersale_updateAfterSaleStatus($data,'10','sync');

            return $rs;
        }

    }

    /**
     *
     * 卖家发货tmall.exchange.consigngoods
     */
    public function exchange_consigngoods($order_id){
        $orderObj = app::get('ome')->model('orders');
        $reshipObj = app::get('ome')->model('reship');
        $order_detail = $orderObj->dump(array('order_id'=>$order_id,'createway'=>'after'),'order_id,shop_id,order_bn');
        $reship_detail = $reshipObj->dump(array('change_order_id'=>$order_id,'return_type'=>'change','source'=>'matrix','shop_type'=>'tmall'),'reship_id,return_id');
        if (!$order_detail || !$reship_detail) return true;

        $tmall_detail = kernel::single('ome_service_aftersale')->get_return_type(array('return_id'=>$reship_detail['return_id']));



        $deliveryModel = app::get('ome')->model('delivery');
        //
        $sql = "SELECT d.delivery_id,d.logi_no,d.logi_name,d.logi_id FROM sdb_ome_delivery_order AS dord
                                            LEFT JOIN sdb_ome_delivery AS d ON(dord.delivery_id=d.delivery_id)
                                            WHERE dord.order_id=".$order_id." AND (d.parent_id=0 OR d.is_bind='true') AND d.disabled='false' AND d.status  IN('succ')";
        $delivery_detail = $deliveryModel->db->selectrow($sql);


        if ($delivery_detail){

            $corpObj = app::get('ome')->model('dly_corp');
            $corp_detail = $corpObj->dump(array('corp_id'=>$delivery_detail['logi_id']),'type,name');

            $params = array(
                'dispute_id'            =>  $tmall_detail['return_bn'],
                'logistics_no'          =>  $delivery_detail['logi_no'],
                'corp_type'             =>  $corp_detail['type'],
                'order_bn'              =>  $order_detail['order_bn'],
                'logistics_company_name'=>  $delivery_detail['logi_name'],
                'order_id'              =>  $order_id,
            );

            $rs = kernel::single('erpapi_router_request')->set('shop', $order_detail['shop_id'])->aftersale_consignGoods($params);


            app::get('ome')->model('return_product_tmall')->update(array('seller_logistic_no'=>$delivery_detail['logi_no'],'seller_logistic_name'=>$delivery_detail['logi_name']),array('return_id'=>$reship_detail['return_id']));
        }



    }

    /**
     * 卖家确认收货(weimobv)
     *
     */
    public function returngoods_confirm($return_id){
        $returnModel = app::get('ome')->model('return_product');
        $returninfo = $returnModel->db_dump(array('return_id'=>$return_id,'source'=>'matrix'),'return_bn,return_id,shop_id,kinds');
        if($returninfo){
            $params = array(
                'refund_id' => $returninfo['return_bn'],
            );
            $rs = kernel::single('erpapi_router_request')->set('shop', $returninfo['shop_id'])->aftersale_returnGoodsAgree($params);
        }
    }
}