<?php
/**
 * 设置并检查物流号
 *
 * @author hzjsq@msn.com
 * @version 0.1b
 */

class omeauto_auto_plugin_logi extends omeauto_auto_plugin_abstract implements omeauto_auto_plugin_interface {

    /**
     * 是否支持批量审单
     */
    protected $__SUP_REP_ROLE = true;

    /**
     * 快递配置信息
     * @var $array
     */
    static $corpList = array();

    /**
     * 电子面单来源类型
     * @var $array
     */
    static $channelType = array();

    /**
     * 快递公司地区配置
     * @var Array
     */
    static $corpArea = array();

    /**
     * 地区配置信息
     * @var Array
     */
    static $region = array();

    /**
     * 状态码
     * @var integer
     */
    protected $__STATE_CODE = omeauto_auto_const::__LOGI_CODE;

    /**
     * 开始处理
     *
     * @param omeauto_auto_group_item $group 要处理的订单组
     * @return Array
     */
    public function process(& $group, &$confirmRoles) {
        $branchId = $group->getBranchId();
        $isStoreBranch = $group->isStoreBranch();

        //由于库存判断不满足条件，没有聚焦到仓库，不判断物流公司的选择逻辑
        if(!$branchId){
            return true;
        }

        //如果是门店仓设置相应的物流公司
        if (app::get('o2o')->is_installed() && $isStoreBranch) {
                $dlyType = $group->getStoreDlyType();
                $corp = app::get('ome')->model('dly_corp')->getList('corp_id, name, type, is_cod, weight, channel_id, shop_id, tmpl_type', array('type'=>$dlyType), 0, 1);
                if($corp){
                    $group->setDlyCorp($corp[0]);
                    return true;
                }else{
                    //不能匹配
                    $group->setOrderStatus('*', $this->getMsgFlag());
                    $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                }
        }else{
            //电商仓物流优选逻辑处理
            /* 店铺物流绑定 start */
            $shopCropObj = app::get('ome')->model('shop_dly_corp');
            $shopObj = app::get('ome')->model("shop");
            $cropObj = app::get('ome')->model('dly_corp');

            $orders = $group->getOrders();
            

            foreach($orders as $val){
                
                if(kernel::single('ome_order_bool_type')->isJITX($val['order_bool_type'])) {
                    $corpData = kernel::single('logistics_rule')->getJITXCorp($val);
                    if($corpData) {
                        $group->setDlyCorp($corpData);
                    } else {
                        $group->setOrderStatus('*', $this->getMsgFlag());
                        $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                    }

                    // 平台运单号
                    $orderExtend = app::get('ome')->model('order_extend')->db_dump(array('order_id'=>$val['order_id']),'platform_logi_no');

                    $group->setWaybillCode($orderExtend['platform_logi_no']);

                    return null;
                }

                if(empty($is_cod)) {
                    $filter['shop_id'] = $val['shop_id'];
                    $filter['crop_name'] = $val['shipping'];
                    $is_cod = $val['is_cod'];
                }

                // 爱库存初始化运单号
                if($val['shop_type'] === 'aikucun' && $val['shipping']){
                    $cropData = $cropObj->dump(array('type'=>$val['shipping'],'channel_id|than'=>'0','disable'=>'false'));
                    if (!$cropData){
                        $group->setOrderStatus('*', $this->getMsgFlag());
                        $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                        return null;
                    }
                    $group->setDlyCorp($cropData);

                    // 平台运单号
                    $orderExtend = app::get('ome')->model('order_extend')->db_dump(array('order_id'=>$val['order_id']),'platform_logi_no');

                    $waybill_arr = explode(',', $orderExtend['platform_logi_no']);
                    $group->setWaybillCode($waybill_arr[0]);
                    $group->setSubWaybillCode(array_slice($waybill_arr, 1));

                    return;
                }

                if($val['order_type'] == 'vopczc') {
                    $corpData = kernel::single('logistics_rule')->getVopczcCorp();
                    $group->setDlyCorp($corpData);
                    return null;
                }
            }

            $shopData = $shopObj->dump($filter['shop_id']);
            $cropSet = false;
            if($shopData['crop_config']['cropBind']==1){
                $shopCrop = $shopCropObj->dump($filter);
                if($shopCrop['corp_id']>0){
                    $cropObj = app::get('ome')->model('dly_corp');
                    $cropData = $cropObj->dump($shopCrop['corp_id']);
                    if($cropData['corp_id']>0 && $cropData['disabled']=='false'){
                        $group->setDlyCorp($cropData);
                        $cropSet = true;
                    }
                }
                if($cropSet==false && $shopData['crop_config']['sysCrop']!=1){//未匹配物流且系统不自动选择
                    $group->setOrderStatus('*', $this->getMsgFlag());
                    $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                    $cropSet = true;

                }
            }
            /* 店铺物流绑定 end */
            //判断是否京东货到付款是否启用京东面单
            if ($shopData['shop_type'] == '360buy') {
                $jdcorpconf =  app::get('ome')->getConf('shop.jdcorp.config.'.$filter['shop_id']);
                if ($jdcorpconf['config'] == '1') {
                    $jdcorpList = $this->getjdcorp();
                    
                    if ($is_cod=='true') {//
                        
                        if ( $jdcorpList && $jdcorpList[$jdcorpconf['corp_id']]) {
                            
                            $group->setDlyCorp($jdcorpList[$jdcorpconf['corp_id']]);
                            $cropSet = true;
                        }
                        
                        if($cropSet==false){
                            $group->setOrderStatus('*', $this->getMsgFlag());
                            $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                            $cropSet = true;
                        }
                    }
                    
                    if ($is_cod=='false' &&  $jdcorpconf['is_cod']=='1') {//货到付款也启用
                        
                        if ($jdcorpList[$jdcorpconf['corp_id']]) {
                               $group->setDlyCorp($jdcorpList[$jdcorpconf['corp_id']]);
                               $cropSet = true;
                        }
                    }
                }
                
            }

            $exrecommend_available = kernel::single('channel_func')->check_exrecommend_available();
           #如果开启智选物流功能，则获取快递鸟推荐的智选物流
            $channel_type = app::get('ome')->model('branch')->getChannelBybranchID($group->getBranchId());
           if($exrecommend_available && in_array($channel_type,array('selfwms'))){
               
                $exrecommend_corp_info =  kernel::single('ome_event_trigger_exrecommend_recommend')->exrecommend($group->getBranchId(),$group->get_order_data());
                $corpId = $exrecommend_corp_info['taobao']['exrecommend_corp_id'];
               if ($corpId > 0) {
                  //能匹配到物流公司
                   $group->setDlyCorp(self::$corpList[$corpId]);
                   $group->setWaybillCode($exrecommend_corp_info['taobao']['waybill_code']);
                   $cropSet = true;
               }
           }
           
           //[指定快递]针对淘宝和天猫订单
           if ($shopData['shop_type']=='taobao') {
               $order_ids = array();
               foreach($orders as $val){
                   $order_ids[] = $val['order_id'];
               }
           
               $cropData = kernel::single('ome_order_func')->get_assign_express($order_ids);
               if($cropData){
                   //能匹配到物流公司
                   $group->setDlyCorp($cropData);
                   $cropSet = true;
               }
           }
           
            if(!$cropSet || $cropSet==false){
                //自动匹配物流公司
                $this->initCropData();
                $corpId = $this->markSelectDlyCorp($group);

                if (!$corpId) {
                    $corpId = kernel::single('logistics_rule')->autoMatchDlyCorp($group->getShipArea(),$branchId,$group->getWeight(),$group->getShopType(),$filter['shop_id']);
                    if ($corpId > 0 && self::$corpList[$corpId]) {
                        //能匹配到物流公司

                        $group->setDlyCorp(self::$corpList[$corpId]);
                    } else {
                        //不能匹配
                        $group->setOrderStatus('*', $this->getMsgFlag());
                        $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                    }
                } else {
                    $channel_id = self::$corpList[$corpId]['channel_id'];
                    if (!is_array($corpId) && (self::$corpList[$corpId]['tmpl_type']=='normal' || self::$channelType[$channel_id]=='ems' || (self::$channelType[$channel_id]=='wlb' && self::$corpList[$corpId]['shop_id']==$filter['shop_id']))) {
                        $mark = kernel::single('omeauto_auto_group_mark');
                        $corpId= $mark->fetchCorpId($corpId);
                        $group->setDlyCorp(self::$corpList[$corpId]);
                    } else {
                        //不能匹配
                        $group->setOrderStatus('*', $this->getMsgFlag());
                        $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                    }
                }
            }
        }
    }

     /**
     * 获取该插件名称
     *
     * @param Void
     * @return String
     */
    public function getTitle() {

        return '无匹配物流';
    }

    /**
     * 根据收货地址自动匹配物流公司 （查看代码 已弃用  by wangjianjun 20170804）
     * @param String $shipArea 送货地址
     * @return mixed
     */
     function autoSelectDlyCorp($shipArea, $branchId, &$confirmRoles) {
        $regionId = preg_replace('/.*:([0-9]+)$/is', '$1', $shipArea);
        $this->initCropData();
        $regionPath = self::$region[$regionId];

        $regionIds = explode(',', $regionPath);
        foreach($regionIds as $key=>$val){
            if($regionIds[$key] == '' || empty($regionIds[$key])){
                unset($regionIds[$key]);
            }
        }
        if(count($regionIds)<3 && count($regionIds)>0){
            foreach(self::$region as $key=>$val){
                if(strpos($val,$regionPath)!==false && $regionPath != $val){
                    $childIds[] = $key;
                }
            }
            if(count($childIds)>0){
                $dlyAreaObj = app::get('ome')->model('dly_corp_area');
                $dlyCount = $dlyAreaObj->count(array('region_id'=>$childIds));
                if($dlyCount>0){
                    return 0;
                }
            }
        }

        //通过区域匹配可送达的物流公司
        $corpIds = $this->getCorpByArea($regionPath, $branchId);

        //在增加默认全部可送的快递公司
        if (empty($corpIds) && $confirmRoles['allDlyCrop'] != 1) {
            $corpIds = $this->getDefaultCorp($branchId);
        }

        //获取最佳物流
        $corpId = $this->getBestCorpId($corpIds);

        //根据设置返回物流公司ID
        return $corpId;
    }

    /**
     * 根据客服备注获取物流公司
     *
     * @param Void
     * @return mixed
     */
    private function markSelectDlyCorp(& $group) {

        $mark = kernel::single('omeauto_auto_group_mark');
        if (! $mark->useMark()) {

            return null;
        }
        $ret = array();
        $wCode = trim($mark->getCodeByFix('markDelivery'));
        foreach ($group->getOrders() as $order) {

            $markText = $this->getMark($order['mark_text']);

            $wRet = $mark->getMark($wCode, $markText);
            if (!empty($wRet)) {

                //$ret = array_merge($ret, $wRet);
                foreach ($wRet as  $wItem) {

                    if (!in_array($wItem, $ret)) {

                        $ret[] = $wItem;
                    }
                }
            }
        }

        //检查快递是否唯一，否则置为不可用
        if (!empty($ret)) {

             if (count($ret) == 1) {

                 return $ret[0];
             }  else {

                 $group->setOrderStatus('*', $mark->getMsgFlag('w'));
                 $group->setStatus(omeauto_auto_group_item::__OPT_HOLD, $this->_getPlugName());
                 return $ret;
             }

        } else {

            return false;
        }
    }

    /**
     * 获取全局可用的物流  (查看代码 已弃用 by wangjianjun 20170804)
     * @return Array
     */
    private function getDefaultCorp($branchId) {
        $corpIds = array();
        $branch_corp_lib = kernel::single("ome_branch_corp");
        $corp_ids = $branch_corp_lib->getCorpIdsByBranchId(array($branchId));
        foreach (self::$corpList as $corpId => $info) {
            if (!isset(self::$corpArea[$corpId]) && in_array($corpId,$corp_ids)) {
                $corpIds[$corpId] = true;
            }
        }
        return $corpIds;
    }

    /**
     * 获取最佳物流公司
     *
     * @param Array $corpIds 可用物流
     * @return Integer
     */
    private function getBestCorpId($corpIds) {

        //返回权重最高的
        $weight = -1;
        $id = 0;
        foreach ($corpIds as $corpId => $v) {

            if (self::$corpList[$corpId]['weight'] > $weight) {

                $weight = self::$corpList[$corpId]['weight'];
                $id = $corpId;
            }
        }

        return $id;
    }

    /**
     * 通过发货地区的地区路径，获取可匹配的快递公司 （查看代码 已弃用 by wangjianjun 20170804）
     * @param String $regionPath 发货地区的地区路径
     * @return Array;
     */
    private function getCorpByArea($regionPath, $branchId) {
        $corpIds = array();
        //先查找有区域配置的快递公司
        if (!empty($regionPath)) {
            $regionIds = explode(',', $regionPath);
            array_shift($regionIds);
            array_pop($regionIds);
            $branch_corp_lib = kernel::single("ome_branch_corp");
            $corp_ids = $branch_corp_lib->getCorpIdsByBranchId(array($branchId));
            foreach ($regionIds as $rId) {
                foreach(self::$corpArea as $corpId => $cRegion) {
                    if (in_array($rId, $cRegion) && in_array($corpId,$corp_ids)) {
                        $corpIds[$corpId] = true;
                    }
                }
            }
        }
        return $corpIds;
    }

    /**
     * 初始化快递公司配置
     *
     * @param void
     * @return void
     */
    private function initCropData() {
        if (!empty(self::$region)) {
            return;
        }

        //获取地区配置信息
        $regions = kernel::single('eccommon_regions')->getList('region_id,region_path');
        foreach ($regions as $row) {
            self::$region[$row['region_id']] = $row['region_path'];
        }
        unset($regions);

        //获取快递公司配置信息
        $corp = app::get('ome')->model('dly_corp')->getList('corp_id, name, type, is_cod, weight, channel_id, shop_id, tmpl_type', array('disabled' => 'false'), 0, -1, 'weight DESC');
        foreach($corp as $item) {
            self::$corpList[$item['corp_id']] = $item;
        }
        unset($corp);

        //快递公司配送区域配置信息s
        $corpArea = app::get('ome')->model('dly_corp_area')->getList('*');
        foreach ($corpArea as $item) {

            self::$corpArea[$item['corp_id']][] = $item['region_id'];
        }
        unset($corpArea);

        //电子面单来源类型
        $channelObj = app::get("logisticsmanager")->model('channel');
        $channel = $channelObj->getList("channel_id,channel_type",array('status'=>'true'));
        foreach($channel as $val) {
            self::$channelType[$val['channel_id']] = $val['channel_type'];
            unset($val);
        }
        unset($channel);
    }

    /**
     * 获取提示信息
     *
     * @param Array $order 订单内容
     * @return Array
     */
    public function getAlertMsg(& $order) {

        return array('color' => 'BLUE', 'flag'=>'物' , 'msg' => '无法自动匹配物流公司');
    }

    /**
     * 获取用于快速审核的选项页，输出HTML代码
     *
     * @param void
     * @return String
     */
    public function getInputUI() {

        //获取快递公司配置信息
        $corpList = array('-1' => '自动匹配物流');
        $corp = app::get('ome')->model('dly_corp')->getList('corp_id, name, type, is_cod, weight', array('disabled' => 'false'), 0, -1, 'weight DESC');
        foreach($corp as $item) {
            $corpList[$item['corp_id']] = $item['name'];
        }
        unset($corp);

        if (empty($corpList)) {

            $result = "<span>您还没有设置可用的物流公司。</span>";
        } else {
            $result = "<span class='customTitle'>请选择指的物流公司：</sapn>\n<select name='customAuto[logi][customLogiId]'>\n";
            foreach ($corpList as $logiId => $cropName) {

                $result .= "<option value='{$logiId}'>{$cropName}</option>\n";
            }
            $result .= "</select>\n";
        }

        return $result;
    }

    public function getjdcorp(){
        $db = kernel::database();
        $dlycorps = $db->select("SELECT d.* FROM sdb_ome_dly_corp as d LEFT JOIN sdb_logisticsmanager_channel as c on d.channel_id=c.channel_id WHERE c.channel_type='360buy' AND d.disabled='false'");
        $jdcorpList = array();
        foreach ($dlycorps as $corp ) {
            $jdcorpList[$corp['corp_id']] = $corp;
        }
        return $jdcorpList;
    }
}